---@class IXAnimationBase : XOwnerRecorder
IXAnimationBase = {}


---@public 获取资源文件名
---@return string 资源文件名
function IXAnimationBase:GetFilename() end


---@public 获取动画类型
---@return number 动画类型
function IXAnimationBase:GetAnimationType() end


---@public 获取资源中骨骼信息类型
---@return PoseType 骨骼信息类型
function IXAnimationBase:GetSampleType() end


---@public 获取动画起始时间
---@return number 动画起始时间
function IXAnimationBase:GetStartTime() end


---@public 获取动画长度
---@return number 动画长度
function IXAnimationBase:GetTimeLength() end


---@class IXAnimationManager : XOwnerRecorder
IXAnimationManager = {}


---@public 初始化
---@return boolean
function IXAnimationManager:Init() end


---@public 释放动画资源
---@return void
function IXAnimationManager:Release() end


---@public 加载动画资源
---@param szFile string 动画资源文件路径名
---@return IXAnimationBase 动画指针
function IXAnimationManager:LoadAnimation(szFile) end


---@public 重新加载动画资源
---@param szFile string 动画资源文件路径名
---@return IXAnimationBase 动画指针
function IXAnimationManager:ReloadAnimation(szFile) end


---@public 内存中创建动画资源
---@param szFile string 为资源指定一个路径信息
---@param type number 动画类型
---@return IXAnimationBase 动画指针
function IXAnimationManager:CreateAnimation(szFile, type) end


---@public 释放动画资源
---@param pAsset IXAnimationBase 动画资源指针
---@return boolean 是否释放成功
function IXAnimationManager:ReleaseAnimation(pAsset) end


---@public 判断动画资源是否加载成功
---@param szFile string 要判断的动画资源文件路径名
---@return boolean 是否加载成功
function IXAnimationManager:IsAnimationLoaded(szFile) end


---@public 设置是否使用动画采样的简单模式，默认使用
---@param bSimpleInterpMode boolean 是否使用简化模式
---@return void
function IXAnimationManager:EnableSimpleInterpMode(bSimpleInterpMode) end


---@public 设置是否使用动画采样的简单模式，默认使用
---@return boolean 是否使用简化模式
function IXAnimationManager:IsSimpleInterpMode() end


