---@class FxElement : XOwnerRecorder
FxElement = {}


---@public 是否可以完成，如：一个粒子系统有Loop次数大于0，则认为是可以完成的
---@return boolean 返回结果
function FxElement:CanComplete() end


---@public 获取最大粒子数
---@return number 最大粒子数
function FxElement:GetMaxParticles() end


---@public 复制一个完全相同的自身，不添加到Template中,如果之后手动添加到了Template中，不需要delete，否则需要自己delete
---@return FxElement 返回复制的指针对象
function FxElement:Clone() end


---@public 判断是否是粒子系统
---@return boolean 是否是粒子系统
function FxElement:IsParticleSystem() end


---@public 设置是否启用
---@param bSet boolean 是否启用
---@return void
function FxElement:SetEnabled(bSet) end


---@public 判断是否启用
---@return boolean 是否启用xture:启用，xfalse:禁用
function FxElement:IsEnabled() end


---@public 获取名称
---@return string 名称字符串
function FxElement:GetName() end


---@public 设置元素名称
---@param strName string
---@return void
function FxElement:SetName(strName) end


---@public 获取元素类型
---@return number 元素类型
function FxElement:GetType() end


---@public 获取模板指针
---@return IFxTemplate 模板指针
function FxElement:GetFxTemplate() end


---@public 设置材质参数
---@param szName string 材质名称
---@param val  XMaterialParamTypeValue 材质参数值
---@return void
function FxElement:SetMaterialInstanceParam(szName, val) end


---@public 清除材质参数
---@param szName string 材质名称
---@return void
function FxElement:ClearMaterialInstanceParam(szName) end


---@public 设置材质纹理参数
---@param szName string 材质名称
---@param pTexture IXTexture
---@return void
function FxElement:SetMaterialInstanceTextureParam(szName, pTexture) end


---@public 清除材质纹理参数
---@param szName string 材质名称
---@return void
function FxElement:ClearMaterialInstanceTextureParam(szName) end


