---@class FxProperty : XOwnerRecorder
FxProperty = {}


---@type number @enum Type
FxProperty.FPT_INVALID = 0


---@type number @enum Type
FxProperty.FPT_BOOL = 0


---@type number @enum Type
FxProperty.FPT_INT32 = 0


---@type number @enum Type
FxProperty.FPT_FLOAT = 0


---@type number @enum Type
FxProperty.FPT_VECTOR2 = 0


---@type number @enum Type
FxProperty.FPT_VECTOR3 = 0


---@type number @enum Type
FxProperty.FPT_VECTOR4 = 0


---@type number @enum Type
FxProperty.FPT_COLORVALUE = 0


---@type number @enum Type
FxProperty.FPT_PATH = 0


---@type number @enum Type
FxProperty.FPT_STRING = 0


---@type number @enum Type
FxProperty.FPT_ENUMTABLE = 0


---@type number @enum Type
FxProperty.FPT_DISTRIBUTIONFLOAT = 0


---@type number @enum Type
FxProperty.FPT_DISTRIBUTIONVECTOR = 0


---@type number @enum Type 与VECTOR实现相同，只是在界面显示上有区分
FxProperty.FPT_DISTRIBUTIONCOLOR = 0


---@type number @enum Type
FxProperty.FPT_INTINTFLOATARRAY = 0


---@type number @enum Type vector4
FxProperty.FPT_DISTRIBUTIONVECTOR4 = 0


---@public 获取属性类型
---@return number 属性类型
function FxProperty:GetType() end


---@public 获取属性名称
---@return string 属性名称
function FxProperty:GetName() end


---@public 设置bool类型属性
---@param b boolean bool类型属性值
---@return void
function FxProperty:SetValue(b) end


---@public 设置xint32类型属性
---@param n number xint32类型属性值
---@return void
function FxProperty:SetValue(n) end


---@public 设置xfloat32类型属性
---@param f number xfloat32类型属性值
---@return void
function FxProperty:SetValue(f) end


---@public 设置XVECTOR2类型属性
---@param vec2 XVECTOR2 XVECTOR2类型属性值
---@return void
function FxProperty:SetValue(vec2) end


---@public 设置XVECTOR3类型属性
---@param vec3 XVECTOR3 XVECTOR3类型属性值
---@return void
function FxProperty:SetValue(vec3) end


---@public 设置XVECTOR4类型属性
---@param vec4 XVECTOR4 XVECTOR4类型属性值
---@return void
function FxProperty:SetValue(vec4) end


---@public 设置XCOLORBASE类型属性
---@param color  XCOLORBASE XCOLORBASE类型属性值
---@return void
function FxProperty:SetValue(color) end


---@public 设置XString类型属性
---@param str string XString类型属性值
---@return void
function FxProperty:SetValue(str) end


---@public 从另一个属性对象拷贝信息
---@param property  FxProperty 要拷贝的属性对象
---@return boolean 是否拷贝成功
function FxProperty:CopyValueFrom(property) end


---@public FxProperty_SetValue08
---@param enumTable  FxEnumTable
---@return void
function FxProperty:SetValue(enumTable) end


---@public FxProperty_GetBool00
---@return boolean
function FxProperty:GetBool() end


---@public FxProperty_GetInt00
---@return number
function FxProperty:GetInt() end


---@public FxProperty_GetFloat00
---@return number
function FxProperty:GetFloat() end


---@public FxProperty_GetVector200
---@return XVECTOR2
function FxProperty:GetVector2() end


---@public FxProperty_GetVector300
---@return XVECTOR3
function FxProperty:GetVector3() end


---@public FxProperty_GetVector400
---@return XVECTOR4
function FxProperty:GetVector4() end


---@public FxProperty_GetColorBase00
---@return XCOLORBASE
function FxProperty:GetColorBase() end


---@public FxProperty_GetString00
---@return string
function FxProperty:GetString() end


---@public FxProperty_GetEnumPointer00
---@return FxEnumTable
function FxProperty:GetEnumPointer() end


---@public FxProperty_GetRawDistributionFloat00
---@return XRawDistributionFloat
function FxProperty:GetRawDistributionFloat() end


---@public FxProperty_GetRawDistributionVector00
---@return XRawDistributionVector
function FxProperty:GetRawDistributionVector() end


---@public FxProperty_GetRawDistributionVector400
---@return XRawDistributionVector4
function FxProperty:GetRawDistributionVector4() end


---@public FxProperty_GetIntFloatArray00
---@return XIntIntFloatArrayData
function FxProperty:GetIntFloatArray() end


