---@class IX2DShape : XOwnerRecorder
IX2DShape = {}


---@type number @enum Type 圆形
IX2DShape.X_CIRCLE = 0


---@type number @enum Type 线段
IX2DShape.X_EDGE = 0


---@type number @enum Type 多边形
IX2DShape.X_POLYGON = 0


---@type number @enum Type 数量
IX2DShape.X_NUM = 0


---@public 获取形状类型，并返回
---@return number
function IX2DShape:GetType() end


---@class IX2DCircleShape : IX2DShape
IX2DCircleShape = {}


---@public 设置圆形半径
---@param fRadius number 圆形半径
---@return void
function IX2DCircleShape:SetRadius(fRadius) end


---@public 获取圆形半径
---@return number 圆形半径
function IX2DCircleShape:GetRadius() end


---@class IX2DEdgeShape : IX2DShape
IX2DEdgeShape = {}


---@public 设置形状
---@param v1 XVECTOR2 一端的顶点位置
---@param v2 XVECTOR2
---@return void
function IX2DEdgeShape:Set(v1, v2) end


---@public 获取形状
---@return XVECTOR2
---@return XVECTOR2
---@return void
function IX2DEdgeShape:Get() end


---@class IX2DPolygonShape : IX2DShape
IX2DPolygonShape = {}


---@public 设置形状
---@param points XVECTOR2
---@param nCnt number
---@return void
function IX2DPolygonShape:Set(points, nCnt) end


---@public 设置为Box形状
---@param hx number box的一半的宽
---@param hy number box的一半的高
---@return void
function IX2DPolygonShape:SetAsBox(hx, hy) end


---@public 设置为Box形状
---@param hx number box的一半的宽
---@param hy number box的一半的高
---@param vCenter XVECTOR2 box的中心点
---@param fAngle number box的旋转角度
---@return void
function IX2DPolygonShape:SetAsBox(hx, hy, vCenter, fAngle) end


---@class X2DShapeFactory
X2DShapeFactory = {}


---@public 创建一个形状，并返回相应的形状指针
---@param eType number 形状类型
---@return IX2DShape 形状指针
function X2DShapeFactory:CreateShape(eType) end


---@public 销毁一个形状
---@param pShape IX2DShape 形状指针
---@return void
function X2DShapeFactory:DestoryShape(pShape) end


