---@class IXSkeletalPhysicsInstance : XOwnerRecorder
IXSkeletalPhysicsInstance = {}


---@public 释放
---@return void
function IXSkeletalPhysicsInstance:Release() end


---@public 设置所有刚体是否启用物理模拟
---@param bSimulate boolean 是否启用物理模拟
---@return void
function IXSkeletalPhysicsInstance:SetAllBodiesSimulatePhysics(bSimulate) end


---@public 给当前骨头的刚体的子刚体设置是否启用物理模拟
---@param szBoneName string 骨头名称
---@param bSimulate boolean 是否启用物理模拟
---@param bIncludeSelf boolean 是否包含自己，如果为xtrue，同时设置自己，默认为xtrue
---@return void
function IXSkeletalPhysicsInstance:SetAllBodiesBelowSimulatePhysics(szBoneName, bSimulate, bIncludeSelf) end


---@public 模型实例的变换矩阵发生变化时，需要更新骨骼物理的状态
---@param fScaleEpsilon number 标示Scale变化的阈值
---@return void
function IXSkeletalPhysicsInstance:OnBindModelInstanceTransformChanged(fScaleEpsilon) end


---@public 根据骨头名字获取对应的body
---@param strBoneName string
---@return IXSkeletalBody 对应的body指针
function IXSkeletalPhysicsInstance:GetBody(strBoneName) end


---@public 获取所有body数目
---@return number
function IXSkeletalPhysicsInstance:GetBodyNumber() end


---@public 根据索引，获取对应的body指针
---@param nBodyIndex number
---@return IXSkeletalBody 对应的body指针
function IXSkeletalPhysicsInstance:GetBody(nBodyIndex) end


