---点击事件
---@class GestureClickParam
GestureClickParam = {}


---@type number @enum Type 普通点击
GestureClickParam.NormalClick = 0


---@type number @enum Type 长按
GestureClickParam.LongClick = 0


---@type number @enum Type 连续点击
GestureClickParam.MultiClick = 0


---@type number @enum State 按下
GestureClickParam.Pressed = 0


---@type number @enum State 状态改变
GestureClickParam.Changed = 0


---@type number @enum State 抬起
GestureClickParam.Raised = 0


---@type XVECTOR2 点击位置
GestureClickParam.vPosition = {}


---@type number 事件类型
GestureClickParam.eType = 0


---@type number 事件状态
GestureClickParam.eState = 0


---@type number
GestureClickParam.fParam = 0


---@type number 事件标记
GestureClickParam.nTag = 0


---单指移动事件
---@class GestureMoveParam
GestureMoveParam = {}


---@type number @enum State 开始移动
GestureMoveParam.Moved = 0


---@type number @enum State 状态改变
GestureMoveParam.Changed = 0


---@type number @enum State 停止移动
GestureMoveParam.Stopped = 0


---@type XVECTOR2 上一时刻位置
GestureMoveParam.vLastPosition = {}


---@type XVECTOR2 点击位置
GestureMoveParam.vPosition = {}


---@type number 事件状态
GestureMoveParam.eState = 0


---@type number 事件标记
GestureMoveParam.nTag = 0


---双指同向移动
---@class GestureMove2Param
GestureMove2Param = {}


---@type number @enum State 开始移动
GestureMove2Param.Moved = 0


---@type number @enum State 状态改变
GestureMove2Param.Changed = 0


---@type number @enum State 停止移动
GestureMove2Param.Stopped = 0


---@type XVECTOR2[] 此刻位置
GestureMove2Param.aPositions = {}


---@type XVECTOR2[] 上一时刻位置
GestureMove2Param.aLastPositions = {}


---@type XVECTOR2 移动方向
GestureMove2Param.vDir = {}


---@type number 事件状态
GestureMove2Param.eState = 0


---双指捏合
---@class GesturePinchParam
GesturePinchParam = {}


---@type number @enum State 开始移动
GesturePinchParam.Moved = 0


---@type number @enum State 状态改变
GesturePinchParam.Changed = 0


---@type number @enum State 停止移动
GesturePinchParam.Stopped = 0


---@type XVECTOR2[] 此刻位置
GesturePinchParam.aPositions = {}


---@type XVECTOR2[] 上一时刻位置
GesturePinchParam.aLastPositions = {}


---@type number
GesturePinchParam.fLastScale = 0


---@type number
GesturePinchParam.fNewScale = 0


---@type number 事件状态
GesturePinchParam.eState = 0


---双指选装
---@class GestureRotate2Param
GestureRotate2Param = {}


---@type number @enum State 开始移动
GestureRotate2Param.Moved = 0


---@type number @enum State 停止移动
GestureRotate2Param.Stopped = 0


---@type number @enum Order 顺时针
GestureRotate2Param.Clockwise = 0


---@type number @enum Order 逆时针
GestureRotate2Param.CounterClockwise = 0


---@type number @enum Order 无效
GestureRotate2Param.NotCircle = 0


---@type number 事件状态
GestureRotate2Param.eState = 0


---@type number 手指绕序
GestureRotate2Param.eOrder = 0


---@class XGestureManager : XOwnerRecorder
XGestureManager = {}


---@public 设置移动的距离判定，默认20
---@param nMoveJudgement number 移动的距离判定值
---@return void
function XGestureManager:SetMoveJudgement_v1(nMoveJudgement) end


---@public 设置移动的距离判定，默认20
---@return number
function XGestureManager:GetMoveJudgement_v1() end


---@public 设置连续点击的间隔时间，点击间隔在该时间内视为连续点击，否则为普通单击，默认0.2s
---@param fTime number 连续点击的间隔时间
---@return void
function XGestureManager:SetMultiClickInterpTime(fTime) end


---@public 获取连续点击的间隔时间，点击间隔在该时间内视为连续点击，否则为普通单击，默认0.2s
---@return number 连续点击的间隔时间
function XGestureManager:GetMultiClickInterpTime() end


---@public 设置长按的判定时间，默认0.2s
---@param fTime number 长按的判定时间
---@return void
function XGestureManager:SetLongPressTime(fTime) end


---@public 获取长按的判定时间，默认0.2s
---@return number 长按的判定时间
function XGestureManager:GetLongPressTime() end


---@public XGestureManager_SetUIFitst00
---@param b boolean
---@return void
function XGestureManager:SetUIFitst(b) end


---@public XGestureManager_IsUIFirst00
---@return boolean
function XGestureManager:IsUIFirst() end


