---@class XUIAnimationValue
XUIAnimationValue = {}


---@type number
XUIAnimationValue.x = 0


---@type number
XUIAnimationValue.y = 0


---@type number
XUIAnimationValue.z = 0


---@type number
XUIAnimationValue.w = 0


---@public XUIAnimationValue_new00
---@return XUIAnimationValue
function XUIAnimationValue:new() end


---@public XUIAnimationValue_GetFloat00
---@return number
function XUIAnimationValue:GetFloat() end


---@public XUIAnimationValue_SetFloat00
---@param value number
---@return void
function XUIAnimationValue:SetFloat(value) end


---@public XUIAnimationValue_GetVec200
---@return XVECTOR2
function XUIAnimationValue:GetVec2() end


---@public XUIAnimationValue_SetVec200
---@param value XVECTOR2
---@return void
function XUIAnimationValue:SetVec2(value) end


---@public XUIAnimationValue_GetVec300
---@return XVECTOR3
function XUIAnimationValue:GetVec3() end


---@public XUIAnimationValue_SetVec300
---@param value XVECTOR3
---@return void
function XUIAnimationValue:SetVec3(value) end


---@public XUIAnimationValue_GetVec400
---@return XVECTOR4
function XUIAnimationValue:GetVec4() end


---@public XUIAnimationValue_SetVec400
---@param value XVECTOR4
---@return void
function XUIAnimationValue:SetVec4(value) end


---@public XUIAnimationValue_GetColor00
---@return XCOLORBASE
function XUIAnimationValue:GetColor() end


---@public XUIAnimationValue_SetColor00
---@param value  XCOLORBASE
---@return void
function XUIAnimationValue:SetColor(value) end


---@public XUIAnimationValue_SetZero00
---@return void
function XUIAnimationValue:SetZero() end


---@class IXUIAnimationSequence : XClass
IXUIAnimationSequence = {}


---@public 从头播放, 并且设置为非动画剪辑段播放模式
---@return void
function IXUIAnimationSequence:Play() end


---@public 停止播放
---@return void
function IXUIAnimationSequence:Stop() end


---@public 暂停播放
---@return void
function IXUIAnimationSequence:Pause() end


---@public 设置播放循环状态播放
---@param bLoop boolean
---@return void
function IXUIAnimationSequence:SetLoop(bLoop) end


---@public 设置播放反向状态
---@param bReverse boolean
---@return void
function IXUIAnimationSequence:SetReverse(bReverse) end


---@public 判断是否是循环播放状态
---@return boolean
function IXUIAnimationSequence:IsLoop() end


---@public 判断是否是反向播放状态
---@return boolean
function IXUIAnimationSequence:IsReverse() end


---@public 判断是否是正在播放状态
---@return boolean
function IXUIAnimationSequence:IsPlaying() end


---@class XUIAnimationComponent : XUIComponent
XUIAnimationComponent = {}


---@type number @enum AnimationType
XUIAnimationComponent.AniNULL = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniPosition = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniColor = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniScale = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniRotation = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniAlpha = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniGlobalZ = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniSpawn = 0


---@type number @enum AnimationType
XUIAnimationComponent.AniSequence = 0


---@public 创建一个XUILayoutComponent布局组件
---@param pNode XUINode 目标节点
---@return XUIAnimationComponent 创建出的XUILayoutComponent组件
function XUIAnimationComponent:Create(pNode) end


---@public XUIAnimationComponent_Create01
---@return XUIAnimationComponent
function XUIAnimationComponent:Create() end


---@public 设置动画类型
---@param eType number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetAnimationType(eType) end


---@public XUIAnimationComponent_GetAnimationType00
---@return number
function XUIAnimationComponent:GetAnimationType() end


---@public 设置获取动画起止值
---@param val  XUIAnimationValue 数值，start:是否起始值：缺省true,index:大于等于0时为组动画中子动画索引
---@param start boolean
---@param index number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetAnimationValue(val, start, index) end


---@public XUIAnimationComponent_GetAnimationValue00
---@param start boolean
---@param index number
---@return XUIAnimationValue
function XUIAnimationComponent:GetAnimationValue(start, index) end


---@public 设置获取子动画类型
---@param index number
---@return number
function XUIAnimationComponent:GetSubAnimationType(index) end


---@public XUIAnimationComponent_AddSubAnimationItem00
---@param eType number
---@return XUIAnimationComponent
function XUIAnimationComponent:AddSubAnimationItem(eType) end


---@public XUIAnimationComponent_RemoveSubAnimationItems00
---@return XUIAnimationComponent
function XUIAnimationComponent:RemoveSubAnimationItems() end


---@public XUIAnimationComponent_RemoveSubAnimationItem00
---@param index number
---@return XUIAnimationComponent
function XUIAnimationComponent:RemoveSubAnimationItem(index) end


---@public XUIAnimationComponent_SetSubAnimationType00
---@param idx number
---@param eType number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetSubAnimationType(idx, eType) end


---@public XUIAnimationComponent_GetSubAnimationNum00
---@return number
function XUIAnimationComponent:GetSubAnimationNum() end


---@public 设置延迟播放时长
---@param value number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetDelay(value) end


---@public XUIAnimationComponent_GetDelay00
---@return number
function XUIAnimationComponent:GetDelay() end


---@public 设置播放时长
---@param value number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetDuration(value) end


---@public XUIAnimationComponent_GetDuration00
---@return number
function XUIAnimationComponent:GetDuration() end


---@public 设置缓动函数
---@param value number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetEase(value) end


---@public XUIAnimationComponent_GetEase00
---@return number
function XUIAnimationComponent:GetEase() end


---@public 设置缓动函数
---@param repeat number
---@return XUIAnimationComponent
function XUIAnimationComponent:SetRepeat(repeat) end


---@public XUIAnimationComponent_GetRepeat00
---@return number
function XUIAnimationComponent:GetRepeat() end


---@manual xelua_XEngine_XUIAnimationComponent_SetUpdateCallBack_manual
---@public XUIAnimationComponent_SetUpdateCallBack_manual
---@param callback std::function<void(XUIAnimationComponent*animation)>
---@return XUIAnimationComponent
function XUIAnimationComponent:SetUpdateCallBack(callback) end


---@manual xelua_XEngine_XUIAnimationComponent_SetStartCallBack_manual
---@public XUIAnimationComponent_SetStartCallBack_manual
---@param callback std::function<void(XUIAnimationComponent*animation)>
---@return XUIAnimationComponent
function XUIAnimationComponent:SetStartCallBack(callback) end


---@manual xelua_XEngine_XUIAnimationComponent_SetCompleteCallBack_manual
---@public XUIAnimationComponent_SetCompleteCallBack_manual
---@param callback std::function<void(XUIAnimationComponent*animation)>
---@return XUIAnimationComponent
function XUIAnimationComponent:SetCompleteCallBack(callback) end


---@public 从头播放, 并且设置为非动画剪辑段播放模式
---@return void
function XUIAnimationComponent:Play() end


---@public 暂停播放
---@return void
function XUIAnimationComponent:Pause() end


---@public 停止播放
---@param bComplete boolean
---@return void
function XUIAnimationComponent:Stop(bComplete) end


---@public XUIAnimationComponent_Jump00
---@param time number
---@return void
function XUIAnimationComponent:Jump(time) end


---@public 设置播放循环状态播放
---@param bLoop boolean
---@return void
function XUIAnimationComponent:SetLoop(bLoop) end


---@public 设置播放反向状态
---@param bReverse boolean
---@return void
function XUIAnimationComponent:SetReverse(bReverse) end


---@public 判断是否是循环播放状态
---@return boolean
function XUIAnimationComponent:IsLoop() end


---@public 判断是否是反向播放状态
---@return boolean
function XUIAnimationComponent:IsReverse() end


---@public 判断是否是正在播放状态
---@return boolean
function XUIAnimationComponent:IsPlaying() end


---@public XUIAnimationComponent_SetSequencePath00
---@param path string
---@return XUIAnimationComponent
function XUIAnimationComponent:SetSequencePath(path) end


---@public XUIAnimationComponent_GetSequencePath00
---@return string
function XUIAnimationComponent:GetSequencePath() end


---@public XUIAnimationComponent_GetSequencer00
---@return IXUIAnimationSequence
function XUIAnimationComponent:GetSequencer() end


