---UI的音频组件
---@class XUIAudioComponent : XUIComponent
XUIAudioComponent = {}


---@public 创建一个XUIAudioComponent音频组件
---@param pNode XUINode 目标节点
---@return XUIAudioComponent 创建出的XUIAudioComponent组件
function XUIAudioComponent:Create(pNode) end


---@public XUIAudioComponent_Create01
---@return XUIAudioComponent
function XUIAudioComponent:Create() end


---@public XUIAudioComponent_SetAudioPath00
---@param path string
---@return void
function XUIAudioComponent:SetAudioPath(path) end


---@public XUIAudioComponent_GetAudioPath00
---@return string
function XUIAudioComponent:GetAudioPath() end


---@public 播放音频
---@return void
function XUIAudioComponent:PlayAudio() end


---@public 停止播放音频
---@param release boolean 是否释放资源
---@return void
function XUIAudioComponent:StopAudio(release) end


---@public 暂停背景音频
---@return void
function XUIAudioComponent:PauseAudio() end


---@public 恢复音频播放
---@return void
function XUIAudioComponent:ResumeAudio() end


---@public 音频是否正在播放
---@return boolean
function XUIAudioComponent:IsAudioPlaying() end


---@public 设置/获取音频播放音量
---@param fVolume number
---@return void
function XUIAudioComponent:SetVolume(fVolume) end


---@public XUIAudioComponent_GetVolume00
---@return number
function XUIAudioComponent:GetVolume() end


---@public 设置/获取音频是否循环播放
---@param bLoop boolean 是否循环
---@return void
function XUIAudioComponent:SetLoop(bLoop) end


---@public XUIAudioComponent_IsLoop00
---@return boolean
function XUIAudioComponent:IsLoop() end


---@public 获取音频总时长
---@return number 毫秒
function XUIAudioComponent:GetDuration() end


---@public 获取音频当前播放进度
---@return number 毫秒
function XUIAudioComponent:GetCurrentPosition() end


---@public 设置音频当前播放进度
---@param position number 毫秒
---@return void
function XUIAudioComponent:SetCurrentPosition(position) end


---@type number @enum AudioTriggerPolicy
XUIAudioComponent.On_Nil = 0


---@type number @enum AudioTriggerPolicy
XUIAudioComponent.On_Loaded = 0


---@type number @enum AudioTriggerPolicy
XUIAudioComponent.On_Touch_Bagan = 0


---@type number @enum AudioTriggerPolicy
XUIAudioComponent.On_Touch_Ended = 0


---@type number @enum AudioTriggerPolicy
XUIAudioComponent.On_Touch_Cancled = 0


---@type number @enum AudioType
XUIAudioComponent.AT_Effect = 0


---@type number @enum AudioType
XUIAudioComponent.AT_BackgRound = 0


---@public XUIAudioComponent_SetAudioTriggerPolicy00
---@param p number
---@return void
function XUIAudioComponent:SetAudioTriggerPolicy(p) end


---@public XUIAudioComponent_GetAudioTriggerPolicy00
---@return number
function XUIAudioComponent:GetAudioTriggerPolicy() end


