---@type number @enum XUITextVAlignment
XUI_TV_TOP = 0


---@type number @enum XUITextVAlignment
XUI_TV_CENTER = 0


---@type number @enum XUITextVAlignment
XUI_TV_BOTTOM = 0


---@type number @enum XUITextHAlignment
XUI_TH_LEFT = 0


---@type number @enum XUITextHAlignment
XUI_TH_CENTER = 0


---@type number @enum XUITextHAlignment
XUI_TH_RIGHT = 0


---@type number @enum XUIGlyphCollection
XUI_GC_DYNAMIC = 0


---@type number @enum XUIGlyphCollection
XUI_GC_CUSTOM = 0


---@class XUITTFConfig
XUITTFConfig = {}


---@public XUITTFConfig_new00
---@return XUITTFConfig
function XUITTFConfig:new() end


---@public XUITTFConfig_new01
---@param _strFilePath string
---@param _fontPointSize number
---@param _nOutline number
---@return XUITTFConfig
function XUITTFConfig:new(_strFilePath, _fontPointSize, _nOutline) end


---@public XUITTFConfig_new02
---@param _strFilePath string
---@param _fontPointSize number
---@param _nOutline number
---@param _eGlyphCollection number
---@param _pCustomGlyphCollection string
---@return XUITTFConfig
function XUITTFConfig:new(_strFilePath, _fontPointSize, _nOutline, _eGlyphCollection, _pCustomGlyphCollection) end


---@type string 字体文件路径
XUITTFConfig.strFontFilePath = ''


---@type number 字体点数大小
XUITTFConfig.fontPointSize = 0


---@type number 更新类型
XUITTFConfig.eGlyphs = 0


---@type string @readonly 自定义类型时，预生成的字符
XUITTFConfig.pCustomGlyphs = ''


---@type number 字体边界线宽
XUITTFConfig.nOutlineSize = 0


---@type string
XUITTFConfig.strSceneID = ''


---@class XUIIMFConfig
XUIIMFConfig = {}


---@public XUIIMFConfig_new00
---@return XUIIMFConfig
function XUIIMFConfig:new() end


---@public XUIIMFConfig_new01
---@param _strPlistFilePath string
---@param _fontPointSize number
---@return XUIIMFConfig
function XUIIMFConfig:new(_strPlistFilePath, _fontPointSize) end


---@public XUIIMFConfig_new02
---@param _strPlistFilePath string
---@param _fontPointSize number
---@param _eGlyphCollection number
---@param _pCustomGlyphCollection string
---@return XUIIMFConfig
function XUIIMFConfig:new(_strPlistFilePath, _fontPointSize, _eGlyphCollection, _pCustomGlyphCollection) end


---@type string 字体文件路径
XUIIMFConfig.strFontFilePath = ''


---@type number 字体点数大小
XUIIMFConfig.fontPointSize = 0


---@class XUIFontRenderComponent : X2DRenderComponent
XUIFontRenderComponent = {}


---@public 创建一个XUIFontRenderComponent渲染组件
---@param pNode XUINode 目标节点
---@return XUIFontRenderComponent 创建出的XUIFontRenderComponent组件
function XUIFontRenderComponent:Create(pNode) end


---@public XUIFontRenderComponent_Create01
---@return XUIFontRenderComponent
function XUIFontRenderComponent:Create() end


---@type number @enum XUIFontType
XUIFontRenderComponent.XUIFT_TTF = 0


---@type number @enum XUIFontType
XUIFontRenderComponent.XUIFT_SYSTEMF = 0


---@type number @enum XUIFontType
XUIFontRenderComponent.XUIFT_IMAGE = 0


---@public 应用设置
---@return void
function XUIFontRenderComponent:UpdateImmediately() end


---@public 设置字体大小
---@param fPointSize number
---@return void
function XUIFontRenderComponent:SetTextPointSize(fPointSize) end


---@public 获取字体大小
---@return number
function XUIFontRenderComponent:GetTextPointSize() end


---@public 设置是否自动换行
---@param bEnableWrap boolean 默认true，为false时，要求m_fLabelWidth>0.0f，才会进行自动换行处理。
---@return void
function XUIFontRenderComponent:SetEnableWrap(bEnableWrap) end


---@public 获取是否自动换行
---@return boolean
function XUIFontRenderComponent:GetEnableWrap() end


---@manual 设置文本内容 手动导出 增加扩展，支持传入任何类型
---@public XUIFontRenderComponent_SetString_manual
---@param strUtf8Text string
---@return void
function XUIFontRenderComponent:SetString(strUtf8Text) end


---@public 获取文本内容
---@return string
function XUIFontRenderComponent:GetString() end


---@public 获取文本大小
---@return number
function XUIFontRenderComponent:GetStringCount() end


---@public 设置文本对齐方式
---@param hAlign number 水平对齐
---@param vAlign number 竖直对齐
---@return void
function XUIFontRenderComponent:SetAlignment(hAlign, vAlign) end


---@public 设置文本水平对齐方式
---@param hAlign number 水平对齐
---@return void
function XUIFontRenderComponent:SetHAlignMent(hAlign) end


---@public 设置文本垂直对齐方式
---@param vAlign number 垂直对齐
---@return void
function XUIFontRenderComponent:SetVAlignMent(vAlign) end


---@public 获取文本水平对齐方式
---@return number 水平对齐方式
function XUIFontRenderComponent:GetHAlignment() end


---@public 获取文本垂直对齐方式
---@return number 垂直对齐方式
function XUIFontRenderComponent:GetVAlignment() end


---@public 设置文本区域
---即Label的宽度和高度，按文字行最大宽度和高度自动调整
---@param fWidth number
---@param fHeight number 高度当fHeight>0.0，且文字总高度超出fHeight，则截断文字。fWidth或fHeight为小于等于0.0，则表示大小自动适应。
---@return void
function XUIFontRenderComponent:SetDimensions(fWidth, fHeight) end


---@public 获取文本区域
---@return XVECTOR2
function XUIFontRenderComponent:GetDimensions() end


---@public 设置文本颜色
---@param clr  XCOLORBASE 文本颜色
---@return void
function XUIFontRenderComponent:SetTextColor(clr) end


---@public 获取文本颜色
---@return  XCOLORBASE 返回文本颜色
function XUIFontRenderComponent:GetTextColor() end


---@public 设置文本渐变颜色-上层颜色
---@param clr  XCOLORBASE 文本上层颜色
---@return void
function XUIFontRenderComponent:SetTextUpperColor(clr) end


---@public 获取文本渐变颜色-上层颜色
---@return  XCOLORBASE 返回文本上层颜色
function XUIFontRenderComponent:GetTextUpperColor() end


---@public 设置文本渐变颜色-下层颜色
---@param clr  XCOLORBASE 文本下层颜色
---@return void
function XUIFontRenderComponent:SetTextLowerColor(clr) end


---@public 获取文本渐变颜色-下层颜色
---@return  XCOLORBASE 返回文本下层颜色
function XUIFontRenderComponent:GetTextLowerColor() end


---@public 设置文本描边颜色
---@param clrOutLine  XCOLORBASE 描边颜色
---@return void
function XUIFontRenderComponent:SetOutlineColor(clrOutLine) end


---@public 获取文本描边颜色
---@return  XCOLORBASE 返回描边颜色
function XUIFontRenderComponent:GetOutlineColor() end


---@public 设置文本描边宽度
---@param nOutlineSize number
---@return void
function XUIFontRenderComponent:SetOutlineSize(nOutlineSize) end


---@public 获取文本描边宽度
---@return number 返回描边颜色
function XUIFontRenderComponent:GetOutlineSize() end


---@public 获取文本描边宽度
---设置文本的字间距, 仅TTF文字支持
---@param fAdditionalKerning number 字间距值
---@return void 返回描边颜色
function XUIFontRenderComponent:SetAdditionalKerning(fAdditionalKerning) end


---@public 获取文本的字间距, 仅TTF文字支持
---@return number
function XUIFontRenderComponent:GetAdditionalKerning() end


---@public 设置文本的行间距, 仅TTF文字支持
---@param fLineSpacing number
---@return void
function XUIFontRenderComponent:SetLineSpacing(fLineSpacing) end


---@public 获取文本的行间距, 仅TTF文字支持
---@return number
function XUIFontRenderComponent:GetLineSpacing() end


---@public 更改字体
---@param strPath string
---@return void
function XUIFontRenderComponent:SetTTFFontPath(strPath) end


---@public XUIFontRenderComponent_GetTTFFontPath00
---@return string
function XUIFontRenderComponent:GetTTFFontPath() end


---@public XUIFontRenderComponent_SetFontPath00
---@param strPath string
---@return void
function XUIFontRenderComponent:SetFontPath(strPath) end


---@public XUIFontRenderComponent_GetFontPath00
---@return string
function XUIFontRenderComponent:GetFontPath() end


---@public XUIFontRenderComponent_SetPListPath00
---@param strPath string
---@return void
function XUIFontRenderComponent:SetPListPath(strPath) end


---@public XUIFontRenderComponent_GetImgFontPath00
---@return string
function XUIFontRenderComponent:GetImgFontPath() end


---@public 设置是否允许在西文单词中换行, 仅TTF文字支持
---@param bBreakOfWesternWord boolean 是否在西文中换行
---@return void
function XUIFontRenderComponent:SetBreakOfWesternWord(bBreakOfWesternWord) end


---@public 获取是否允许在西文单词中换行
---@return boolean
function XUIFontRenderComponent:GetBreakOfWesternWord() end


---@public 切换到系统字体
---@return void
function XUIFontRenderComponent:ChangeToSystemFont() end


---@public 设置系统字体名称
---@param strFontName string 系统字体名称
---@return void
function XUIFontRenderComponent:SetSystemFontName(strFontName) end


---@public 获取系统字体名称
---@return string
function XUIFontRenderComponent:GetSystemFontName() end


---@public 设置默认的ttf路径
---@return number
function XUIFontRenderComponent:GetLabelType() end


---@public XUIFontRenderComponent_SetLabelType00
---@param type number
---@return void
function XUIFontRenderComponent:SetLabelType(type) end


---@public XUIFontRenderComponent_SetRichText00
---@param tichtext string
---@return void
function XUIFontRenderComponent:SetRichText(tichtext) end


---@public XUIFontRenderComponent_SetTextFormat00
---@param _format  XUITextFormat
---@return void
function XUIFontRenderComponent:SetTextFormat(_format) end


---@public XUIFontRenderComponent_GetFontTextures00
---@return IXTexture2D[]
function XUIFontRenderComponent:GetFontTextures() end


---@class XUITextFormat
XUITextFormat = {}


---@public XUITextFormat_new00
---@return XUITextFormat
function XUITextFormat:new() end


---@public XUITextFormat_new01
---@param other  XUITextFormat
---@return XUITextFormat
function XUITextFormat:new(other) end


---@public XUITextFormat_setFormat00
---@param format  XUITextFormat
---@return void
function XUITextFormat:setFormat(format) end


---@type string
XUITextFormat.fontPath = ''


---@type number
XUITextFormat.fontSize = 0


---@type number 附加的字间隔
XUITextFormat.fontKerning = 0


---@type number 附加的行间隔
XUITextFormat.fontLineSpacing = 0


---@type XCOLORBASE
XUITextFormat.color = {}


---@type XCOLORBASE
XUITextFormat.Uppercolor = {}


---@type XCOLORBASE
XUITextFormat.Lowercolor = {}


---@type XCOLORBASE
XUITextFormat.outlineColor = {}


---@type number
XUITextFormat.outlineSize = 0


---@type boolean
XUITextFormat.bEnableWrap = false


---@type boolean
XUITextFormat.bBreakOfWesternWord = false


---@type number
XUITextFormat.horizontalAlign = 0


---@type number
XUITextFormat.verticalAlign = 0


