---@class SubviewParam
SubviewParam = {}


---@type XVECTOR3
SubviewParam.m_vPosition = {}


---@type XQUATERNION
SubviewParam.m_Quat = {}


---@type number
SubviewParam.m_fFOV = 0


---@type boolean
SubviewParam.m_bUseDefaultSetting = false


---@type string
SubviewParam.m_sSubviewActorName = ''


---@type string
SubviewParam.m_sModelActorName = ''


---UI的渲染组件基类
---@class XUISpriteRenderComponent : X2DRenderComponent
XUISpriteRenderComponent = {}


---@type number @enum XImageType
XUISpriteRenderComponent.IT_Simple = 0


---@type number @enum XImageType
XUISpriteRenderComponent.IT_Sliced = 0


---@type number @enum XImageType
XUISpriteRenderComponent.IT_Fill = 0


---@type number @enum XImageType
XUISpriteRenderComponent.IT_Tiled = 0


---@type number @enum XImageType
XUISpriteRenderComponent.IT_Polygon = 0


---@type number @enum XImageType
XUISpriteRenderComponent.IT_Quad = 0


---@type number @enum XImageFillMode
XUISpriteRenderComponent.IF_Horizontal = 0


---@type number @enum XImageFillMode
XUISpriteRenderComponent.IF_Vertical = 0


---@type number @enum XImageFillMode
XUISpriteRenderComponent.IF_Radial90 = 0


---@type number @enum XImageFillMode
XUISpriteRenderComponent.IF_Radial180 = 0


---@type number @enum XImageFillMode
XUISpriteRenderComponent.IF_Radial360 = 0


---@type number @enum XOrigin_HorizontalFill
XUISpriteRenderComponent.HF_Left = 0


---@type number @enum XOrigin_HorizontalFill
XUISpriteRenderComponent.HF_Right = 0


---@type number @enum XOrigin_VerticalFill
XUISpriteRenderComponent.VF_Top = 0


---@type number @enum XOrigin_VerticalFill
XUISpriteRenderComponent.VF_Bottom = 0


---@type number @enum XOrigin_90Fill
XUISpriteRenderComponent.NF_BottomLeft = 0


---@type number @enum XOrigin_90Fill
XUISpriteRenderComponent.NF_TopLeft = 0


---@type number @enum XOrigin_90Fill
XUISpriteRenderComponent.NF_TopRight = 0


---@type number @enum XOrigin_90Fill
XUISpriteRenderComponent.NF_BottomRight = 0


---@type number @enum XOrigin_180Fill
XUISpriteRenderComponent.EF_Bottom = 0


---@type number @enum XOrigin_180Fill
XUISpriteRenderComponent.EF_Left = 0


---@type number @enum XOrigin_180Fill
XUISpriteRenderComponent.EF_Top = 0


---@type number @enum XOrigin_180Fill
XUISpriteRenderComponent.EF_Right = 0


---@type number @enum XOrigin_360Fill
XUISpriteRenderComponent.TF_Bottom = 0


---@type number @enum XOrigin_360Fill
XUISpriteRenderComponent.TF_Right = 0


---@type number @enum XOrigin_360Fill
XUISpriteRenderComponent.TF_Top = 0


---@type number @enum XOrigin_360Fill
XUISpriteRenderComponent.TF_Left = 0


---@public 创建一个XUISpriteRenderComponent渲染组件
---@param pNode XUINode 目标节点
---@return XUISpriteRenderComponent 创建出的XUISpriteRenderComponent组件
function XUISpriteRenderComponent:Create(pNode) end


---@public XUISpriteRenderComponent_Create01
---@return XUISpriteRenderComponent
function XUISpriteRenderComponent:Create() end


---@public 设置是否使用纹理
---@param bUse boolean 是否使用纹理
---@return void
function XUISpriteRenderComponent:SetUseTexture(bUse) end


---@public 获取是否使用纹理
---@return boolean 是否使用纹理
function XUISpriteRenderComponent:IsUseTexture() end


---@public 加载纹理
---@param nTag number 该纹理路径的索引值，XUIImage可以持有多张纹理，即不同nTag可以对应不同纹理路径，默认从0开始。
---@param strTextureName string 纹理的文件路径，该路径若是pvr/ktx则不需要传后缀名，引擎通过当前平台是android/ios自动补后缀，若是png/jpg则需要传后缀名。
---@param texType number 路径的类型,相对路径/绝对路径。
---@return boolean 是否加载成功。
function XUISpriteRenderComponent:LoadTexture(nTag, strTextureName, texType) end


---@public 显示索引为nTag的图片
---@param nTag number 该值为Create、或者LoadTexture时传入的nTag值，XUIImage控件会展示对应的图片。
---@return void
function XUISpriteRenderComponent:ShowTexture(nTag) end


---@public 删除指定tag对应的纹理
---@param nTag number 对应的索引
---@return void
function XUISpriteRenderComponent:RemoveTexture(nTag) end


---@public 获取纹理数目
---@return number 纹理数目
function XUISpriteRenderComponent:GetTextureNum() end


---@public 获取当前正在显示的纹理索引
---@return number 正在显示的纹理索引
function XUISpriteRenderComponent:GetCurrentTag() end


---@public 获取指定tag的纹理路径，并返回
---@param nTag number 指定tag
---@return string 纹理路径
function XUISpriteRenderComponent:GetTexturePath(nTag) end


---@public 查询指定tag的纹理是否存在
---@param nTag number 指定tag
---@return boolean 纹理是否存在
function XUISpriteRenderComponent:IsTextureExisted(nTag) end


---@public 获取是否使用纹理的尺寸
---@return boolean 是否使用纹理的尺寸
function XUISpriteRenderComponent:IsFollowTextureSize() end


---@public 设置是否使用纹理的尺寸
---@param bFollow boolean 是否使用纹理的尺寸
---@return void
function XUISpriteRenderComponent:SetFollowTextureSize(bFollow) end


---@public 按百分比显示图片的一部分
---@param vLTPercent XVECTOR2 图片左上角的百分比
---@param vBRPercent XVECTOR2 图片右下角的百分比
---@return void
function XUISpriteRenderComponent:SetRectPercent(vLTPercent, vBRPercent) end


---@public 设置图片是否左右翻转
---@param bFlip boolean 是否翻转
---@return void
function XUISpriteRenderComponent:SetFlipX(bFlip) end


---@public 获取图片是否左右翻转
---@return boolean 是否翻转
function XUISpriteRenderComponent:IsFlipX() end


---@public 获取指定tag的纹理原始大小
---@param nTag number 指定tag
---@return XVECTOR2 纹理原始大小（返回类型XVECTOR2）
function XUISpriteRenderComponent:GetTextureOriginalSize(nTag) end


---@public 设置XUIImage是否启用序列帧模式
---@param bUse boolean 是否启用序列帧模式
---@return void
function XUISpriteRenderComponent:SetUseSequence(bUse) end


---@public 获取XUIImage是否启用序列帧模式
---@return boolean 是否启用序列帧模式
function XUISpriteRenderComponent:IsUseSequence() end


---@public 获取XUIImage是否正在播放序列帧
---@return boolean 是否正在播放序列帧
function XUISpriteRenderComponent:IsSequencePlaying() end


---@public 设置播放序列帧
---@param bPlay boolean 是否播放序列帧
---@return void
function XUISpriteRenderComponent:PlaySequence(bPlay) end


---@public 重置序列帧，重置序列帧为未播放时的初始状态。
---@return void
function XUISpriteRenderComponent:ResetSequence() end


---@public 设置序列帧UV
---@param vTile XVECTOR2 参数为XVECTOR2类型，对应的x为序列帧图片横向的帧图片个数，y为纵向的帧图片个数。举例：有个序列帧图片，图片上为34共12帧图片，那么参数需要传入为XVECTOR2(3,4)。
---@return void
function XUISpriteRenderComponent:SetUVTile(vTile) end


---@public 设置序列帧UV
---@param fUTile number
---@param fVTile number
---@return void
function XUISpriteRenderComponent:SetUVTile(fUTile, fVTile) end


---@public 获取序列帧UV
---@return XVECTOR2 获取当前序列帧UV设置。
function XUISpriteRenderComponent:GetUVTile() end


---@public 设置序列帧动画的FPS
---@param fFPS number 序列帧动画的FPS
---@return void
function XUISpriteRenderComponent:SetSequenceFPS(fFPS) end


---@public 获取序列帧动画的FPS
---@return number 序列帧动画的FPS
function XUISpriteRenderComponent:GetSequenceFPS() end


---@public 设置序列帧图片中保存的真正的帧数
---@param nNum number 序列帧图片中保存的真正的帧数。举例：有个序列帧图片，图片格式为34共12帧图片，但是最后一帧是空白的（并没有图片），那么参数应当传为11。
---@return void
function XUISpriteRenderComponent:SetActualFrameNum(nNum) end


---@public 获取当前序列帧图片中保存的真正的帧数
---@return number 返回值为通过SetActualFrameNum传入的值，默认为1
function XUISpriteRenderComponent:GetActualFrameNum() end


---@public XUISpriteRenderComponent_SetActualFrameBegin00
---@param nNum number
---@return void
function XUISpriteRenderComponent:SetActualFrameBegin(nNum) end


---@public XUISpriteRenderComponent_GetActualFrameBegin00
---@return number
function XUISpriteRenderComponent:GetActualFrameBegin() end


---@public 设置当前播放到第nFrame帧。
---@param nFrame number 当前播放到第nFrame帧。
---@return void
function XUISpriteRenderComponent:SetCurrentFrame(nFrame) end


---@public 返回当前播放到第nFrame帧。
---@return number 当前播放到第nFrame帧。
function XUISpriteRenderComponent:GetCurrentFrame() end


---@public 设置是否使用九宫格
---@param bSet boolean 是否使用九宫格
---@return void
function XUISpriteRenderComponent:Enable9Slice(bSet) end


---@public 判断是否使用九宫格
---@return boolean 是否使用九宫格
function XUISpriteRenderComponent:Is9SliceEnabled() end


---@public 设置九宫格左侧部分宽度(单位:像素)
---@param fLeft number 左侧部分宽度
---@return void
function XUISpriteRenderComponent:SetSliceLeft(fLeft) end


---@public 获取九宫格左侧部分宽度(单位:像素)
---@return number 左侧部分宽度
function XUISpriteRenderComponent:GetSliceLeft() end


---@public 设置九宫格右侧部分宽度(单位:像素)
---@param fRight number 右侧部分宽度
---@return void
function XUISpriteRenderComponent:SetSliceRight(fRight) end


---@public 获取九宫格右侧部分宽度(单位:像素)
---@return number 右侧部分宽度
function XUISpriteRenderComponent:GetSliceRight() end


---@public 设置九宫格上侧部分宽度(单位:像素)
---@param fTop number 上侧部分宽度
---@return void
function XUISpriteRenderComponent:SetSliceTop(fTop) end


---@public 获取九宫格上侧部分宽度(单位:像素)
---@return number 上侧部分宽度
function XUISpriteRenderComponent:GetSliceTop() end


---@public 设置九宫格下侧部分宽度(单位:像素)
---@param fBottom number
---@return void
function XUISpriteRenderComponent:SetSliceBottom(fBottom) end


---@public 获取九宫格下侧部分宽度(单位:像素)
---@return number 下侧部分宽度
function XUISpriteRenderComponent:GetSliceBottom() end


---@public 设置九宫格小图的UV
---通常情况不需要调用
---@param vLT XVECTOR2
---@param vBR XVECTOR2
---@return void
function XUISpriteRenderComponent:SetTListUV(vLT, vBR) end


---@public 获取九宫格下侧部分宽度(单位:像素)
---@return XVECTOR2
---@return XVECTOR2
---@return void
function XUISpriteRenderComponent:GetTlistUV() end


---@public 获取纹理指针
---@return  XUITexture 纹理指针
function XUISpriteRenderComponent:GetUITexture() end


---@public 设置是否使用遮罩纹理
---@param bUse boolean 是否使用遮罩纹理
---@return void
function XUISpriteRenderComponent:SetUseMaskTexture(bUse) end


---@public 获取是否使用遮罩纹理
---@return boolean 是否使用遮罩纹理
function XUISpriteRenderComponent:IsUseMaskTexture() end


---@public 加载遮罩纹理
---@param strTextureNamek string 遮罩纹理路径
---@return boolean
function XUISpriteRenderComponent:LoadMaskTexture(strTextureNamek) end


---@public 获取遮罩纹理路径
---@return string 遮罩纹理路径
function XUISpriteRenderComponent:GetMaskTexturePath() end


---@public 获取遮罩纹理指针
---@return  XUITexture 遮罩纹理指针
function XUISpriteRenderComponent:GetUIMaskTexture() end


---@public 返回合图中小图名称
---@return string 合图中小图名称
function XUISpriteRenderComponent:GetCurrentPlistSpriteName() end


---@public 设置图片类型
---@param type number 普通、九宫格、填充模式为兼容之前九宫格亦可通过enable9slice开启
---@return void
function XUISpriteRenderComponent:SetImageType(type) end


---@public XUISpriteRenderComponent_GetImageType00
---@return number
function XUISpriteRenderComponent:GetImageType() end


---@public 设置填充模式
---@param type number 水平、垂直、径向90、径向180、径向360
---@return void
function XUISpriteRenderComponent:SetFillMode(type) end


---@public XUISpriteRenderComponent_GetImageFillMode00
---@return number
function XUISpriteRenderComponent:GetImageFillMode() end


---@public 设置填充数值
---@param amount number [0,1]
---@return void
function XUISpriteRenderComponent:SetFillAmount(amount) end


---@public XUISpriteRenderComponent_GetFillAmount00
---@return number
function XUISpriteRenderComponent:GetFillAmount() end


---@public 设置填充起点
---@param origin number
---@return void
function XUISpriteRenderComponent:SetHorizontalFillOrigin(origin) end


---@public XUISpriteRenderComponent_SetVerticalFillOrigin00
---@param origin number
---@return void
function XUISpriteRenderComponent:SetVerticalFillOrigin(origin) end


---@public XUISpriteRenderComponent_Set90FillOrigin00
---@param origin number
---@return void
function XUISpriteRenderComponent:Set90FillOrigin(origin) end


---@public XUISpriteRenderComponent_Set180FillOrigin00
---@param origin number
---@return void
function XUISpriteRenderComponent:Set180FillOrigin(origin) end


---@public XUISpriteRenderComponent_Set360FillOrigin00
---@param origin number
---@return void
function XUISpriteRenderComponent:Set360FillOrigin(origin) end


---@public XUISpriteRenderComponent_SetFillOrigin00
---@param origin number
---@return void
function XUISpriteRenderComponent:SetFillOrigin(origin) end


---@public XUISpriteRenderComponent_GetFillOrigin00
---@return number
function XUISpriteRenderComponent:GetFillOrigin() end


---@public 设置填充是否翻转
---@param reverse boolean
---@return void
function XUISpriteRenderComponent:SetFillReverse(reverse) end


---@public XUISpriteRenderComponent_GetFillReverse00
---@return boolean
function XUISpriteRenderComponent:GetFillReverse() end


---@public 加载plist 快捷方式
---@param spritename string 小图名称可不带后缀会自行匹配pvrtgapngktx
---@param tag number
---@return void
function XUISpriteRenderComponent:LoadPlistTexture(spritename, tag) end


---@public 设置/获取SubView相关参数
---@return SubviewParam
function XUISpriteRenderComponent:GetSubviewParam() end


---@public XUISpriteRenderComponent_UseSubViewFromMainEditor00
---@return boolean
function XUISpriteRenderComponent:UseSubViewFromMainEditor() end


---@public XUISpriteRenderComponent_SetUseSubViewFromMainEditor00
---@param use boolean
---@return void
function XUISpriteRenderComponent:SetUseSubViewFromMainEditor(use) end


