---@class XEAttachRules : XMemBase
XEAttachRules = {}


---@type  XEAttachRules @readonly 
XEAttachRules.KeepRelativeTransform = {}


---@type  XEAttachRules @readonly 
XEAttachRules.KeepWorldTransform = {}


---@type  XEAttachRules @readonly 
XEAttachRules.SnapToTargetNotIncludingScale = {}


---@type  XEAttachRules @readonly 
XEAttachRules.SnapToTargetIncludingScale = {}


---@type number @enum EAttachmentRule Keeps current relative transform as the relative transform to the new parent.
XEAttachRules.KeepRelative = 0


---@type number @enum EAttachmentRule Automatically calculates the relative transform such that the attached component maintains the same world transform.
XEAttachRules.KeepWorld = 0


---@type number @enum EAttachmentRule Snaps transform to the attach point
XEAttachRules.SnapToTarget = 0


---@type number @enum EAttachmentFollowRule Follow none
XEAttachRules.FollowNone = 0


---@type number @enum EAttachmentFollowRule Follow Translation-X Only
XEAttachRules.FollowTraslationX = 0


---@type number @enum EAttachmentFollowRule Follow Translation-X Only
XEAttachRules.FollowTraslationY = 0


---@type number @enum EAttachmentFollowRule Follow Translation-X Only
XEAttachRules.FollowTraslationZ = 0


---@type number @enum EAttachmentFollowRule
XEAttachRules.FollowTraslation = 0


---@type number @enum EAttachmentFollowRule
XEAttachRules.FollowRotationAxisX = 0


---@type number @enum EAttachmentFollowRule
XEAttachRules.FollowRotationAxisY = 0


---@type number @enum EAttachmentFollowRule
XEAttachRules.FollowRotationAxisZ = 0


---@type number @enum EAttachmentFollowRule
XEAttachRules.FollowRotation = 0


---@type number @enum EAttachmentFollowRule Follow Scale-X Only
XEAttachRules.FollowScaleX = 0


---@type number @enum EAttachmentFollowRule Follow Scale-Y Only
XEAttachRules.FollowScaleY = 0


---@type number @enum EAttachmentFollowRule Follow Scale-Z Only
XEAttachRules.FollowScaleZ = 0


---@type number @enum EAttachmentFollowRule
XEAttachRules.FollowScale = 0


---@type number @enum EAttachmentFollowRule Follow all transform for the binding
XEAttachRules.FollowAll = 0


---@public XEAttachRules_new00
---@param InRule number
---@param bInWeldSimulatedBodies boolean
---@return XEAttachRules
function XEAttachRules:new(InRule, bInWeldSimulatedBodies) end


---@public XEAttachRules_new01
---@param InLocationRule number
---@param InRotationRule number
---@param InScaleRule number
---@param bInWeldSimulatedBodies boolean
---@return XEAttachRules
function XEAttachRules:new(InLocationRule, InRotationRule, InScaleRule, bInWeldSimulatedBodies) end


---@type number The rule to apply to location when attaching
XEAttachRules.LocationRule = 0


---@type number The rule to apply to rotation when attaching
XEAttachRules.RotationRule = 0


---@type number The rule to apply to scale when attaching
XEAttachRules.ScaleRule = 0


---@type boolean Whether to weld simulated bodies together when attaching
XEAttachRules.bWeldSimulatedBodies = false


---Rules for detaching components
---@class XEDetachmentTransformRules : XMemBase
XEDetachmentTransformRules = {}


---@type  XEDetachmentTransformRules @readonly 
XEDetachmentTransformRules.KeepRelativeTransform = {}


---@type  XEDetachmentTransformRules @readonly 
XEDetachmentTransformRules.KeepWorldTransform = {}


---@type number @enum EDetachmentRule Keeps current relative transform as the relative transform to the new parent.
XEDetachmentTransformRules.KeepRelative = 0


---@type number @enum EDetachmentRule Automatically calculates the relative transform such that the attached component maintains the same world transform.
XEDetachmentTransformRules.KeepWorld = 0


---@public XEDetachmentTransformRules_new00
---@param InRule number
---@param bInCallModify boolean
---@return XEDetachmentTransformRules
function XEDetachmentTransformRules:new(InRule, bInCallModify) end


---@public XEDetachmentTransformRules_new01
---@param InLocationRule number
---@param InRotationRule number
---@param InScaleRule number
---@param bInCallModify boolean
---@return XEDetachmentTransformRules
function XEDetachmentTransformRules:new(InLocationRule, InRotationRule, InScaleRule, bInCallModify) end


---@public XEDetachmentTransformRules_new02
---@param AttachmentRules  XEDetachmentTransformRules
---@param bInCallModify boolean
---@return XEDetachmentTransformRules
function XEDetachmentTransformRules:new(AttachmentRules, bInCallModify) end


---@type number The rule to apply to location when attaching
XEDetachmentTransformRules.LocationRule = 0


---@type number The rule to apply to rotation when attaching
XEDetachmentTransformRules.RotationRule = 0


---@type number The rule to apply to scale when attaching
XEDetachmentTransformRules.ScaleRule = 0


---@type boolean
XEDetachmentTransformRules.bCallModify = false


