---@class XEPathFileTool
XEPathFileTool = {}


---@public 规范化路径
---@param strFullName cppstring 要规范化的路径（string类型）
---@param reverse boolean 默认为true,如果reverse为true，转换为/(反斜杠)，否则为\(斜杠，Windows命令行识别，不识别/)
---@return void
function XEPathFileTool:NormalPath(strFullName, reverse) end


---@public 规范化路径
---@param pFullName string 要规范化的路径（char类型）
---@param reverse boolean 默认为true,如果reverse为true，转换为/(反斜杠)，否则为\(斜杠，Windows命令行识别，不识别/)
---@return void
function XEPathFileTool:NormalPath(pFullName, reverse) end


---@public 规范化路径
---@param pFullName string 要规范化的路径（XString类型）
---@param reverse boolean 默认为true,如果reverse为true，转换为/(反斜杠)，否则为\(斜杠，Windows命令行识别，不识别/)
---@return void
function XEPathFileTool:NormalPath(pFullName, reverse) end


---@public 规范化路径
---@param pFullName string 要规范化的路径
---@param reverse boolean 默认为true,如果reverse为true，转换为/(反斜杠)，否则为\(斜杠，Windows命令行识别，不识别/)
---@return cppstring
function XEPathFileTool:GetNormalPath(pFullName, reverse) end


---@public 获取一个规范化、简化的路径, 以 / 分级
---@param pPathName string 要规范化的路径
---@return cppstring
function XEPathFileTool:GetExpandPath(pPathName) end


---@public 对路径加密
---@param strKey cppstring 密钥
---@param strpath cppstring
---@return void
function XEPathFileTool:EncodePath(strKey, strpath) end


---@public 对路径解密
---@param strKey cppstring 密钥
---@param strpath cppstring
---@return void
function XEPathFileTool:DecodePath(strKey, strpath) end


---@public 从完整路径中得到目录部分
---@param strFullName cppstring 完整路径
---@return cppstring 	目录部分
function XEPathFileTool:GetPathDir(strFullName) end


---@public 从完整的名字中得到名字(带后缀名)
---@param strFullName cppstring 完整路径
---@return cppstring 	名字(带后缀名)
function XEPathFileTool:GetFileName(strFullName) end


---@public 获取后缀名
---@param strName cppstring 文件名字
---@return cppstring 后缀名
function XEPathFileTool:GetFileExt(strName) end


---@public 去掉后缀名
---@param strName cppstring 文件名字
---@return cppstring 去掉后缀名之后的字符串
function XEPathFileTool:GetFilePathExceptExt(strName) end


