---@class XEVariant
XEVariant = {}


---@type number @enum PType
XEVariant.XVT_NONE = 0


---@type number @enum PType 1个xfloat32
XEVariant.XVT_FLOAT1 = 0


---@type number @enum PType 2个xfloat32
XEVariant.XVT_FLOAT2 = 0


---@type number @enum PType 3个xfloat32
XEVariant.XVT_FLOAT3 = 0


---@type number @enum PType 4个xfloat32
XEVariant.XVT_FLOAT4 = 0


---@type number @enum PType RGB颜色
XEVariant.XVT_COLORRGB = 0


---@type number @enum PType RGBA颜色
XEVariant.XVT_COLORRGBA = 0


---@type number @enum PType xbool类型
XEVariant.XVT_BOOL = 0


---@type number @enum PType xint32类型
XEVariant.XVT_INT = 0


---@type number @enum PType xuint32类型
XEVariant.XVT_UINT = 0


---@type number @enum PType XString类型
XEVariant.XVT_STRING = 0


---@type number @enum PType XETransform类型
XEVariant.XVT_TRANSFORM = 0


---@type number @enum PType XArray<XEVariant>类型
XEVariant.XVT_VARIANT_WRAPPER = 0


---@type number @enum PType void*类型，用户自定义数据类型
XEVariant.XVT_USER_DATA = 0


---@type number @enum PType void*類型+類型名稱說明
XEVariant.XVT_USER_DATA_WITH_TYPE = 0


---@type number @enum PType Matrix4矩阵
XEVariant.XVT_MATRIX4 = 0


---@type number @enum PType Matrix3矩阵
XEVariant.XVT_MATRIX3 = 0


---@type number @enum PType 四元数
XEVariant.XVT_QUATERNION = 0


---@type number @enum PType 1个xfloat64
XEVariant.XVT_DOUBLE1 = 0


---@type number @enum PType
XEVariant.XVT_NUM = 0


---@public XEVariant_new00
---@return XEVariant
function XEVariant:new() end


---@public XEVariant_new01
---@param type number
---@return XEVariant
function XEVariant:new(type) end


---@public XEVariant_new02
---@param value  XEVariant
---@return XEVariant
function XEVariant:new(value) end


---@public 设置1个xfloat32数据
---@param fValue number xfloat32数据
---@return void
function XEVariant:SetFloat(fValue) end


---@public 设置2个xfloat32数据
---@param fValue1 number xfloat32数据1
---@param fValue2 number xfloat32数据2
---@return void
function XEVariant:SetFloat2(fValue1, fValue2) end


---@public 设置3个xfloat32数据
---@param fValue1 number xfloat32数据1
---@param fValue2 number xfloat32数据2
---@param fValue3 number xfloat32数据3
---@return void
function XEVariant:SetFloat3(fValue1, fValue2, fValue3) end


---@public 设置4个xfloat32数据
---@param fValue1 number xfloat32数据1
---@param fValue2 number xfloat32数据2
---@param fValue3 number xfloat32数据3
---@param fValue4 number xfloat32数据4
---@return void
function XEVariant:SetFloat4(fValue1, fValue2, fValue3, fValue4) end


---@public 设置RGB颜色数据
---@param fR number R(xfloat32)
---@param fG number G(xfloat32)
---@param fB number B(xfloat32)
---@return void
function XEVariant:SetColor(fR, fG, fB) end


---@public 设置RGBA颜色数据
---@param fR number R(xfloat32)
---@param fG number G(xfloat32)
---@param fB number B(xfloat32)
---@param fA number A(xfloat32)
---@return void
function XEVariant:SetColor(fR, fG, fB, fA) end


---@public 设置1个xfloat64数据
---@param dValue number
---@return void
function XEVariant:SetDouble(dValue) end


---@public 设置xbool数据
---@param bValue boolean xbool数据
---@return void
function XEVariant:SetBool(bValue) end


---@public 设置xint32数据
---@param nValue_ number xint32数据
---@return void
function XEVariant:SetInt(nValue_) end


---@public 设置xuint32数据
---@param nValue_ number
---@return void
function XEVariant:SetUInt(nValue_) end


---@public 设置XArray<XEVariant>数据
---@param vw XEVariant[] XArray<XEVariant>数据
---@return void
function XEVariant:SetVariantWrapper(vw) end


---@public 设置XETransform数据
---@param tf  XETransform XETransform数据
---@return void
function XEVariant:SetTransform(tf) end


---@public 设置XString数据
---@param str string XString数据
---@return void
function XEVariant:SetString(str) end


---@public 设置XVECTOR2数据(XVT_FLOAT2)
---@param Value XVECTOR2 XVECTOR2数据
---@return void
function XEVariant:SetVECTOR2(Value) end


---@public 设置XVECTOR3数据(XVT_FLOAT3)
---@param Value XVECTOR3 XVECTOR3数据
---@return void
function XEVariant:SetVECTOR3(Value) end


---@public 设置XVECTOR4数据(XVT_FLOAT4)
---@param Value XVECTOR4 XVECTOR4数据
---@return void
function XEVariant:SetVECTOR4(Value) end


---@public 设置XCOLORBASE数据(XVT_COLORRGBA)
---@param Value  XCOLORBASE XCOLORBASE数据
---@return void
function XEVariant:SetCOLORGBASE(Value) end


---@public 设置用户自定义数据(XVT_USER_DATA)
---@param pUserData userdata void数据
---@return void
function XEVariant:SetUserData(pUserData) end


---@public 设置用户自定义数据和類型(XVT_USER_DATA_WITH_TYPE)
---@param pUserData userdata void数据
---@param str string
---@return void
function XEVariant:SetUserDataWithType(pUserData, str) end


---@public 设置XMATRIX4数据
---@param mat4 XMATRIX4
---@return void
function XEVariant:SetMatrix4(mat4) end


---@public 设置XMATRIX3数据
---@param mat3 XMATRIX3
---@return void
function XEVariant:SetMatrix3(mat3) end


---@public 设置XQUATERNION数据
---@param quat XQUATERNION
---@return void
function XEVariant:SetQuaternion(quat) end


---@public 获取1个xfloat32数据
---@return number 1个xfloat32数据
function XEVariant:GetFloat() end


---@public 获取2个xfloat32数据
---@return number
---@return number
---@return void
function XEVariant:GetFloat2() end


---@public 获取3个xfloat32数据
---@return number
---@return number
---@return number
---@return void
function XEVariant:GetFloat3() end


---@public 获取4个xfloat32数据
---@return number
---@return number
---@return number
---@return number
---@return void
function XEVariant:GetFloat4() end


---@public 获取指定xfloat32数据, 不判定数据是否有效
---@return number
---@return number
---@return number
---@return number
---@return void
function XEVariant:GetFloats() end


---@public 获取RGB颜色数据
---@return number
---@return number
---@return number
---@return void
function XEVariant:GetColor() end


---@public 获取RGBA颜色数据
---@param fR number xfloat32数据(R)
---@param fG number xfloat32数据(G)
---@param fB number xfloat32数据(B)
---@param fA number xfloat32数据(A)
---@return void
function XEVariant:GetColor(fR, fG, fB, fA) end


---@public 获取1个xfloat64数据
---@return number 1个xfloat64数据
function XEVariant:GetDouble() end


---@public 获取xbool数据
---@return boolean xbool数据
function XEVariant:GetBool() end


---@public 获取xint32数据
---@return number xint32数据
function XEVariant:GetInt() end


---@public 获取xuint32数据
---@return number xuint32数据
function XEVariant:GetUInt() end


---@public 获取用户自定义数据
---@return userdata void数据
function XEVariant:GetUserData() end


---@public 获取帶類型的用户自定义数据的類型
---@return string constxchar数据類型
function XEVariant:GetTypeOfUserData() end


---@public 获取帶類型的用户自定义数据的數據
---@return userdata void数据
function XEVariant:GetDataOfUserData() end


---@public 获取XString数据
---@return string XString数据
function XEVariant:GetString() end


---@public 获取XETransform数据
---@return XETransform XETransform数据
function XEVariant:GetTransform() end


---@public 获取XArray<XEVariant>数据
---@return XEVariant[] XArray<XEVariant>数据
function XEVariant:GetVariantWrapper() end


---@public 获取XVT_VARIANT_WRAPPER数据条目个数
---@return number 条目个数
function XEVariant:GetVariantWrapperItemNum() end


---@public 获取XVT_VARIANT_WRAPPER某个条目
---@param nIndex number nIndex条目索引
---@return XEVariant 条目指针
function XEVariant:GetVariantWrapperItem(nIndex) end


---@public 删除XVT_VARIANT_WRAPPER某个条目
---@param nIndex number nIndex条目索引
---@return boolean 是否删除成功
function XEVariant:RemoveVariantWrapperItemAt(nIndex) end


---@public 添加XVT_VARIANT_WRAPPER某个条目
---@param data  XEVariant data添加的条目(XEVariant)
---@return boolean 是否添加成功
function XEVariant:AddVariantWrapperItem(data) end


---@public 获取XVECTOR2数据
---@return XVECTOR2 XVECTOR2数据
function XEVariant:GetVECTOR2() end


---@public 获取XVECTOR3数据
---@return XVECTOR3 XVECTOR3数据
function XEVariant:GetVECTOR3() end


---@public 获取XVECTOR4数据
---@return XVECTOR4 XVECTOR4数据
function XEVariant:GetVECTOR4() end


---@public 获取XCOLORBASE数据
---@return XCOLORBASE XCOLORBASE数据
function XEVariant:GetCOLORGBASE() end


---@public 获取XMATRIX4数据
---@return XMATRIX4 XMATRIX4数据
function XEVariant:GetMatrix4() end


---@public 获取XMATRIX3数据
---@return XMATRIX3 XMATRIX3数据
function XEVariant:GetMatrix3() end


---@public 获取XQUATERNION数据
---@return XQUATERNION XQUATERNION数据
function XEVariant:GetQuaternion() end


---@public 获取当前数据类型
---@return number 数据类型
function XEVariant:GetType() end


---@public XEVariant_SetType00
---@param type number
---@return void
function XEVariant:SetType(type) end


