---@class XETriggerBaseActor : XEActor
XETriggerBaseActor = {}


---@class XETriggerBaseActor__Listener
local XETriggerBaseActor__Listener = {}
XETriggerBaseActor.Listener = XETriggerBaseActor__Listener


---@public XETriggerBaseActor_Listener_new00
---@return XETriggerBaseActor__Listener
function XETriggerBaseActor__Listener:new() end


---@public 响应触发时需要执行的函数
---@return void
function XETriggerBaseActor__Listener:Execute() end


---@public 设置触发类型
---@param state number 触发类型，对应TriggerState
---@return void
function XETriggerBaseActor__Listener:SetTriggerState(state) end


---@public 获取触发类型
---@return number
function XETriggerBaseActor__Listener:GetTriggerState() end


---@public 获取延时倒计时时刻
---@return number
function XETriggerBaseActor__Listener:GetCountDown() end


---@public 设置延时倒计时时长
---@param fVal number 延时倒计时时长
---@return void
function XETriggerBaseActor__Listener:SetCountDown(fVal) end


---@public 重置延时倒计时时刻
---@return void
function XETriggerBaseActor__Listener:ResetCountDown() end


---@public 设置重复触发
---@param bRepeat boolean xtrue:重复触发，xfalse:不重复触发
---@return void
function XETriggerBaseActor__Listener:SetTriggerRepeat(bRepeat) end


---@public 获取是否重复触发状态
---@return boolean
function XETriggerBaseActor__Listener:IsTriggerRepeat() end


---@public 设置激活状态
---@param bActive boolean xtrue:激活，xfalse:不激活
---@return void
function XETriggerBaseActor__Listener:SetActive(bActive) end


---@public 获取激活状态
---@return boolean
function XETriggerBaseActor__Listener:IsActive() end


---@public 添加Listener
---@param pListener XETriggerBaseActor::Listener 要添加的Listener指针
---@return void
function XETriggerBaseActor:AddListener(pListener) end


---@public 移除Listener
---@param pListener XETriggerBaseActor::Listener 要移除的Listener指针
---@return void
function XETriggerBaseActor:RemoveListener(pListener) end


---@public XETriggerBaseActor_new00
---@return XETriggerBaseActor
function XETriggerBaseActor:new() end


---@public 响应Actor碰触到触发器
---@param pOverlapActor XEActor
---@return void
function XETriggerBaseActor:OnOverlapBegin(pOverlapActor) end


---@public 响应Actor停留在触发器中
---@param pOverlapActor XEActor
---@return void
function XETriggerBaseActor:OnOverlapStay(pOverlapActor) end


---@public 响应Actor离开触发器
---@param pOverlapActor XEActor
---@return void
function XETriggerBaseActor:OnOverlapEnd(pOverlapActor) end


---@public 添加触发器响应的事件数据
---@param nState number 触发响应类型
---@param eEventType number 事件类型
---@return void
function XETriggerBaseActor:AddOverlapEventData(nState, eEventType) end


---@public XETriggerBaseActor_AddOverlapEventData01
---@param nState number
---@param eEventType number
---@param eventData  XEVariant
---@return void
function XETriggerBaseActor:AddOverlapEventData(nState, eEventType, eventData) end


---@public XETriggerBaseActor_AddOverlapEventData02
---@param nState number
---@param eEventType number
---@param eventData  XEVariant
---@param strSender string
---@return void
function XETriggerBaseActor:AddOverlapEventData(nState, eEventType, eventData, strSender) end


---@public XETriggerBaseActor_AddOverlapEventData03
---@param nState number
---@param eEventType number
---@param eventData  XEVariant
---@param strSender string
---@param strExecutor string
---@param fdelay number
---@return void
function XETriggerBaseActor:AddOverlapEventData(nState, eEventType, eventData, strSender, strExecutor, fdelay) end


---@public 移除触发器响应的事件数据
---@param nAddIndex number
---@return boolean
function XETriggerBaseActor:RemoveOverlapEventData(nAddIndex) end


---@public 进行触发器碰撞检测
---@param eType number 触发器检测类型，默认为TriggerOverlapCheck_AABB，AABB包围盒检测
---@return void
function XETriggerBaseActor:OnOverlapCheck(eType) end


---@public 获取触发器响应的事件数据
---@param nIndex number 获取响应事件数据的下标
---@return  XETriggerData
function XETriggerBaseActor:GetTriggerData(nIndex) end


---@public 获取触发器响应的事件数据
---@param nIndex number 获取响应事件数据的下标
---@return XETriggerData
function XETriggerBaseActor:GetTriggerData(nIndex) end


---@public 获取触发器响应的事件数据列表
---@return XETriggerData[]
function XETriggerBaseActor:GetTriggerDataList() end


---@public 重置事件数据第一次触发状态信息
---@return void
function XETriggerBaseActor:ResetTriggerData() end


---@public 添加单个需要检测碰撞的actor名称
---@param strActorName string
---@return void
function XETriggerBaseActor:AddOverlapCheckActor(strActorName) end


---@public 添加多个需要检测碰撞的actor名称
---@param aActorNames string[]
---@return void
function XETriggerBaseActor:AddOverlapCheckActors(aActorNames) end


---@public 删除某个检测碰撞actor名称
---@param index number
---@return void
function XETriggerBaseActor:RemoveOverlapCheckActor(index) end


---@public 获取需要检测碰撞的actor名称
---@return string[]
function XETriggerBaseActor:GetOverlapCheckActors() end


---@public XETriggerBaseActor_GetOverlapCheckActors01
---@return string[]
function XETriggerBaseActor:GetOverlapCheckActors() end


---@public 获取某个检测碰撞的actor名称
---@param nIndex number
---@return string
function XETriggerBaseActor:GetOverlapCheckActor(nIndex) end


---@public 添加单个需要检测碰撞的actor对象指针（仅运行时用，不保存）
---@param pActor XEActor
---@return void
function XETriggerBaseActor:AddOverlapCheckActorForPlay(pActor) end


---@public 删除某个检测碰撞actor对象指针（仅运行时用，不保存）
---@param pActor XEActor
---@return void
function XETriggerBaseActor:RemoveOverlapCheckActorForPlay(pActor) end


---@public 获取需要检测碰撞的actor对象指针（仅运行时用，不保存）
---@return XEActor[]
function XETriggerBaseActor:GetOverlapCheckActorsForPlay() end


---@public XETriggerBaseActor_GetOverlapCheckActorsForPlay01
---@return XEActor[]
function XETriggerBaseActor:GetOverlapCheckActorsForPlay() end


---@type string @readonly Actor类型名
XETriggerBaseActor.ACTOR_TYPENAME = ''


