---3D纹理组件
---对应XE3DTextureActor
---@class XE3DTextureComponent : XEActorComponent
XE3DTextureComponent = {}


---@public XE3DTextureComponent_new00
---@return XE3DTextureComponent
function XE3DTextureComponent:new() end


---@type number @enum eTexcoordOrigin
XE3DTextureComponent.TO_LEFT_TOP = 0


---@type number @enum eTexcoordOrigin
XE3DTextureComponent.TO_LEFT_BOTTOM = 0


---@type number @enum eTexcoordOrigin
XE3DTextureComponent.TO_RIGHT_TOP = 0


---@type number @enum eTexcoordOrigin
XE3DTextureComponent.TO_RIGHT_BOTTOM = 0


---@type number @enum EPivotVerticalType
XE3DTextureComponent.EPVT_CENTER = 0


---@type number @enum EPivotVerticalType
XE3DTextureComponent.EPVT_BOTTOM = 0


---@public 设置要渲染的2D纹理对象
---@param pTexture IXTexture 纹理实例对象
---@param bReleaseOld boolean 是否释放旧的纹理实例
---@return void
function XE3DTextureComponent:SetRenderTexture(pTexture, bReleaseOld) end


---@public 获取资源路径
---@return string 资源路径
function XE3DTextureComponent:GetAssetPath() end


---@public 设置空间纹理保持在相机视图空间里不变（即在屏幕位置不变）
---@param bSet boolean
---@return void
function XE3DTextureComponent:SetPinToScreen(bSet) end


---@public 空间纹理是否保持在相机视图空间里不变（在屏幕位置不变）
---@return boolean
function XE3DTextureComponent:IsPinToScreen() end


---@public 设置空间纹理面向相机
---@param bSet boolean
---@return void
function XE3DTextureComponent:SetFaceViewportCamera(bSet) end


---@public 空间纹理是否面向相机
---@return boolean 为xture时为面向当前视口相机
function XE3DTextureComponent:IsFaceViewportCamera() end


---@public 构建纹理的顶点坐标
---@return boolean 是否成功
function XE3DTextureComponent:BuildVertices() end


---@public 重置并构建标准的四方网格数据，用于纹理的顶点坐标和纹理坐标构建
---@param fScale number
---@param eTexcoordOriginType number
---@return void
function XE3DTextureComponent:ResetAndBuildStanderData(fScale, eTexcoordOriginType) end


---@public 顶点和索引数据是否有效
---@return boolean 是否有效
function XE3DTextureComponent:IsVertiesAndIndiesValid() end


---@public 数据是否有效，用于纹理的顶点坐标和纹理坐标构建
---@return boolean 是否有效
function XE3DTextureComponent:IsDataValid() end


---@public 更新渲染帧的顶点数据和索引数据
---@param pViewport XEViewport
---@return void
function XE3DTextureComponent:UpdateRenderVertiesAndIndies(pViewport) end


---@public 设置支点在竖直方向的类型
---@param eType number 类型
---@return void
function XE3DTextureComponent:SetPivotVerticalType(eType) end


---@public 获取支点在竖直方向的类型
---@return number
function XE3DTextureComponent:GetPivotVerticalType() end


---@public 3D顶点相对于位置点（原点）的位置(模型坐标空间)
---@param nVertIndex number
---@return XVECTOR3
function XE3DTextureComponent:GetVertexLocalLocation(nVertIndex) end


---@public 3D顶点世界空间位置
---@param nVertIndex number
---@return XVECTOR3
function XE3DTextureComponent:GetVertexLocation(nVertIndex) end


---@type string @readonly Component类型名
XE3DTextureComponent.COMPONENT_TYPENAME = ''


