---用于绘画的专用组件
---@class XEBrushComponent : XEActorComponent
XEBrushComponent = {}


---@public XEBrushComponent_new00
---@return XEBrushComponent
function XEBrushComponent:new() end


---@type string @readonly Component类型名
XEBrushComponent.COMPONENT_TYPENAME = ''


---@public 获取画刷几何体指针
---@return IXBrushPrimitive IXBrushPrimitive画刷几何体指针
function XEBrushComponent:GetBrushPrimitive() end


---@public 创建画刷几何体
---@param brushInitParam IXBrushManager::BrushInitParam 画刷初始化参数
---@return boolean 是否创建成功(xbool)
function XEBrushComponent:BuildBrushPrimitive(brushInitParam) end


---@public 设置画刷颜色
---@param clrBrushColor XCOLORBASE 画刷颜色
---@return void
function XEBrushComponent:SetBrushColor(clrBrushColor) end


---@public 获取画刷颜色
---@return XCOLORBASE 画刷颜色(XCOLORBASE)
function XEBrushComponent:GetBrushColor() end


---@public 移除路径上的所有点
---@return void
function XEBrushComponent:RemoveAllPathPoints() end


---@public 为画刷添加一个路径点
---@param vWorldPoint XVECTOR3 世界空间坐标点
---@return void
function XEBrushComponent:AddPathWorldPoint(vWorldPoint) end


---@public 设置材质文件，并重新创建画刷几何体
---@param szMaterialPath string mt文件滤镜
---@param bReCreateBrushPrimitive boolean 是否重新创建画刷几何体
---@return boolean 是否创建成功(xbool),如果bReCreateBrushPrimitive为xfalse，返回值为必为xfalse
function XEBrushComponent:SetMaterialFile(szMaterialPath, bReCreateBrushPrimitive) end


---@public 设置ShapeGroup中各顶点纹理坐标在U方向上的平铺方式(0-1)，并重新创建画刷几何体
---@param eMode number 纹理坐标平铺方式
---@param bReCreateBrushPrimitive boolean 是否重新创建画刷几何体
---@return boolean 是否创建成功(xbool),如果bReCreateBrushPrimitive为xfalse，返回值为必为xfalse
function XEBrushComponent:SetTexcoordLoopMode(eMode, bReCreateBrushPrimitive) end


---@public 更改画刷形状，并重新创建画刷几何体
---@param shapeGroup XBrushShape[] 画刷形状组
---@param bReCreateBrushPrimitive boolean 是否重新创建画刷几何体
---@return boolean 是否创建成功(xbool),如果bReCreateBrushPrimitive为xfalse，返回值为必为xfalse
function XEBrushComponent:SetBrushShapeGroup(shapeGroup, bReCreateBrushPrimitive) end


---@public 更改画刷形状，并重新创建画刷几何体
---@param nIndex number 画刷形状组的索引
---@param aBrushShape XVECTOR3[] 画刷形状组的某个索引对应的形状
---@param bReCreateBrushPrimitive boolean 是否重新创建画刷几何体
---@return boolean 是否创建成功(xbool),如果bReCreateBrushPrimitive为xfalse，返回值为必为xfalse
function XEBrushComponent:SetBrushShapeByIndex(nIndex, aBrushShape, bReCreateBrushPrimitive) end


---@public 增加画刷形状的点，并重新创建画刷几何体
---@param vWorldPos XVECTOR3 组成画刷形状的世界坐标点
---@param nIndex number 画刷形状组的索引，默认为0
---@param bReCreateBrushPrimitive boolean 是否重新创建画刷几何体
---@return boolean 是否创建成功(xbool),如果bReCreateBrushPrimitive为xfalse，返回值为必为xfalse
function XEBrushComponent:AddBrushShapePoint(vWorldPos, nIndex, bReCreateBrushPrimitive) end


---@public 增加画刷初始颜色，并重新创建画刷几何体
---@param clrBrushColor XCOLORBASE 画刷初始颜色
---@param bReCreateBrushPrimitive boolean 是否重新创建画刷几何体
---@return boolean 是否创建成功(xbool),如果bReCreateBrushPrimitive为xfalse，返回值为必为xfalse
function XEBrushComponent:SetBrushInitColor(clrBrushColor, bReCreateBrushPrimitive) end


---@public XEBrushComponent_GetBrushInitParam00
---@return IXBrushManager__BrushInitParam
function XEBrushComponent:GetBrushInitParam() end


---@public 创建一段新的路径,如果上一段路径还没有添加路径点，则不会创建新路径
---@return void
function XEBrushComponent:CreateNewPath() end


