---子Actor组件
---它是一种特殊的组件，用于嵌套Actor，有父子Actor关系，其中子Actor作为父Actor的一个子Actor组件实现这种嵌套关系。
---@class XEChildActorComponent : XEActorComponent
XEChildActorComponent = {}


---@public XEChildActorComponent_new00
---@return XEChildActorComponent
function XEChildActorComponent:new() end


---@public 根据源所属Actor更新该组件的变换矩阵
---@return void
function XEChildActorComponent:UpdateTransformFromGuestActor() end


---@public 如果组件嵌套的时候，选择了父Actor中的某个节点，则需要根据父Actor的节点更新该组件的变换矩阵
---@return void
function XEChildActorComponent:UpdateTranformFromParentUserNode() end


---@public 获取子组件原来所属的Actor
---@return XEActor
function XEChildActorComponent:GetGuestActor() end


---@public 设置子组件原来所属的Actor
---@param pActor XEActor
---@return void
function XEChildActorComponent:SetGuestActor(pActor) end


---@public 设置子组件的跟随规则
---@param eFollowRule number
---@return void
function XEChildActorComponent:SetFollowRule(eFollowRule) end


---@public 获取子组件的跟随规则
---@return number
function XEChildActorComponent:GetFollowRule() end


---@type string @readonly Component类型名
XEChildActorComponent.COMPONENT_TYPENAME = ''


