---移动组件基类
---用来完成业务层面的移动
---@class XEMovementComponent : XEActorComponent
XEMovementComponent = {}


---@public XEMovementComponent_new00
---@return XEMovementComponent
function XEMovementComponent:new() end


---@public 设置被控制移动的Component
---@param pUpdatedComponent XEActorComponent 被控制的Component
---@return void
function XEMovementComponent:SetUpdatedComponent(pUpdatedComponent) end


---@public XEMovementComponent_GetUpdatedComponent00
---@return XEActorComponent
function XEMovementComponent:GetUpdatedComponent() end


---@public XEMovementComponent_SetConstrainToPlaneNormal00
---@param vNormal XVECTOR3
---@return void
function XEMovementComponent:SetConstrainToPlaneNormal(vNormal) end


---@public XEMovementComponent_GetConstrainToPlaneNormal00
---@return XVECTOR3
function XEMovementComponent:GetConstrainToPlaneNormal() end


---@public XEMovementComponent_SetConstrainToPlane00
---@param bEnabled boolean
---@return void
function XEMovementComponent:SetConstrainToPlane(bEnabled) end


---@public XEMovementComponent_IsConstrainToPlane00
---@return boolean
function XEMovementComponent:IsConstrainToPlane() end


---@public XEMovementComponent_ConstrainDirectionToPlane00
---@param vDirection XVECTOR3
---@return XVECTOR3
function XEMovementComponent:ConstrainDirectionToPlane(vDirection) end


---@public XEMovementComponent_ConstrainNormalToPlane00
---@param Normal XVECTOR3
---@return XVECTOR3
function XEMovementComponent:ConstrainNormalToPlane(Normal) end


---@public XEMovementComponent_SlideAlongSurface00
---@param vDelta XVECTOR3
---@param fTime number
---@param vNormal XVECTOR3
---@param hitResult XEHitResult
---@param bHandleImpact boolean
---@return number
function XEMovementComponent:SlideAlongSurface(vDelta, fTime, vNormal, hitResult, bHandleImpact) end


---@public XEMovementComponent_ComputeSlideVector00
---@param vDelta XVECTOR3
---@param fTime number
---@param vNormal XVECTOR3
---@param hitResult  XEHitResult
---@return XVECTOR3
function XEMovementComponent:ComputeSlideVector(vDelta, fTime, vNormal, hitResult) end


---@public XEMovementComponent_TwoWallAdjust00
---@param vDelta XVECTOR3
---@param hitResult  XEHitResult
---@param vOldHitNormal XVECTOR3
---@return void
function XEMovementComponent:TwoWallAdjust(vDelta, hitResult, vOldHitNormal) end


---@public XEMovementComponent_MoveUpdatedComponent00
---@param vDelta XVECTOR3
---@param vNewRotation XQUATERNION
---@param bSweep boolean
---@param outHit XEHitResult
---@param eTeleport number
---@return boolean
function XEMovementComponent:MoveUpdatedComponent(vDelta, vNewRotation, bSweep, outHit, eTeleport) end


---@public XEMovementComponent_SafeMoveUpdatedComponent00
---@param vDelta XVECTOR3
---@param vNewRotation XQUATERNION
---@param bSweep boolean
---@param outHit XEHitResult
---@param eTeleport number
---@return boolean
function XEMovementComponent:SafeMoveUpdatedComponent(vDelta, vNewRotation, bSweep, outHit, eTeleport) end


---@public XEMovementComponent_GetPenetrationAdjustment00
---@param hit  XEHitResult
---@return XVECTOR3
function XEMovementComponent:GetPenetrationAdjustment(hit) end


---@public XEMovementComponent_ResolvePenetration00
---@param vAdjustment XVECTOR3
---@param hitResult  XEHitResult
---@param vNewRotation XQUATERNION
---@return boolean
function XEMovementComponent:ResolvePenetration(vAdjustment, hitResult, vNewRotation) end


---@type string @readonly Component类型名
XEMovementComponent.COMPONENT_TYPENAME = ''


---@public XEMovementComponent_GetTypeName00
---@return string
function XEMovementComponent:GetTypeName() end


