---编辑骨骼组件
---编辑骨骼组件用于调整骨头构件参数.
---@class XEPinchSkeletonComponent : XEPrimitiveComponent
XEPinchSkeletonComponent = {}


---@public XEPinchSkeletonComponent_new00
---@return XEPinchSkeletonComponent
function XEPinchSkeletonComponent:new() end


---@class XEPinchSkeletonComponent__PinchParamCurMinMaxStep
local XEPinchSkeletonComponent__PinchParamCurMinMaxStep = {}
XEPinchSkeletonComponent.PinchParamCurMinMaxStep = XEPinchSkeletonComponent__PinchParamCurMinMaxStep


---@public XEPinchSkeletonComponent_PinchParamCurMinMaxStep_new00
---@return XEPinchSkeletonComponent__PinchParamCurMinMaxStep
function XEPinchSkeletonComponent__PinchParamCurMinMaxStep:new() end


---@type string 名称
XEPinchSkeletonComponent__PinchParamCurMinMaxStep.szPinchElementName = ''


---@type number 最小值
XEPinchSkeletonComponent__PinchParamCurMinMaxStep.fMin = 0


---@type number 最大值
XEPinchSkeletonComponent__PinchParamCurMinMaxStep.fMax = 0


---@type number 步进
XEPinchSkeletonComponent__PinchParamCurMinMaxStep.fStep = 0


---@type number 当前值
XEPinchSkeletonComponent__PinchParamCurMinMaxStep.fCur = 0


---@public 骨头捏造控制器绑定到组件的父节点模型实例上
---@return boolean 是否成功
---@attention 调用此函数之前，需要保证已经设置了骨头捏造配置文件路径
function XEPinchSkeletonComponent:BindFromParent() end


---@public 骨头捏造控制器绑定到模型实例上
---@param pModelIns IXModelInstance 模型实例指针
---@return boolean 是否成功
---@attention 调用此函数之前，需要保证已经设置了骨头捏造配置文件路径
function XEPinchSkeletonComponent:Bind(pModelIns) end


---@public 骨头捏造控制器与模型实例解绑，并释放资源
---@return boolean 是否解绑成功
function XEPinchSkeletonComponent:Unbind() end


---@public 加载骨头捏造配置文件（xpc文件）
---@param pSkePinchCfgPath string 骨头捏造配置xpc文件路径
---@return boolean 是否加载成功
function XEPinchSkeletonComponent:LoadPinchParamConfig(pSkePinchCfgPath) end


---@public 加载并应用实例配置文件（xpc.instance文件）
---@param pSkePinchParamInsCfgPath string 实例配置xpc.instance文件路径
---@return boolean 是否成功
function XEPinchSkeletonComponent:ApplyPinchParamFromCfg(pSkePinchParamInsCfgPath) end


---@public 重置构件参数
---@param pPinchNodeName string 构件参数节点名称，如果此项为空，则重置所有构件参数；否则，只重置该构件参数节点
---@return boolean 是否成功
function XEPinchSkeletonComponent:ResetPinchParams(pPinchNodeName) end


---@public 设置某个构件参数值（设置到骨头捏造控制器）
---@param pinchParam  XPinchParam 要设置的构件参数值
---@return boolean 是否设置成功
function XEPinchSkeletonComponent:SetPinchParam(pinchParam) end


---@public 设置多个构件参数值（设置到骨头捏造控制器）
---@param pinchParams XPinchParam[] 要设置的构件参数值数组
---@return boolean 是否设置成功
function XEPinchSkeletonComponent:SetPinchParams(pinchParams) end


---@public 获取某个构件参数值
---@param pParamName string [in]要获取的构件参数名称
---@return XPinchParam
---@return boolean 是否成功
function XEPinchSkeletonComponent:GetPinchParam(pParamName) end


---@public 获取所有构件参数值
---@return XPinchParam[] 所有构件参数值数组
function XEPinchSkeletonComponent:GetPinchParamsByArray() end


---@public 判断某构件参数节点是否有效
---@param pPinchNodeName string
---@return boolean 是否有效
function XEPinchSkeletonComponent:VerifyPinchNode(pPinchNodeName) end


---@public 由骨头捏造控制器更新组件内记录的构件参数节点信息
---@param pPinchNodeName string 构件参数节点名称，如果为空，更新全部构件参数节点信息；否则，只更新该构件参数节点信息
---@return boolean 是否成功
function XEPinchSkeletonComponent:UpdateValueFromExistence(pPinchNodeName) end


---@public 同步组件内构件参数信息给骨头捏造控制器
---@return boolean 是否成功
function XEPinchSkeletonComponent:SyncValueToPinchControl() end


---@public 获取某个构件参数全信息结构体（包括该参数的最小值/最大值/当前值/步长等）
---@param pPinchNodeName string
---@return XEPinchSkeletonComponent__PinchParamCurMinMaxStep 参数信息结构体指针
function XEPinchSkeletonComponent:GetPinchParamCMMS(pPinchNodeName) end


---@public 获取所有构件参数全信息结构体（包括该参数的最小值/最大值/当前值/步长等）
---@return PinchParamCurMinMaxStep[] 参数全信息结构体数组
function XEPinchSkeletonComponent:GetPinchParamCMMSArray() end


---@public 设置骨头捏造配置文件路径
---@param pPath string
---@return void
function XEPinchSkeletonComponent:SetPinchParamConfigPath(pPath) end


---@public 获取骨头捏造配置文件路径
---@return string
function XEPinchSkeletonComponent:GetPinchParamConfigPath() end


---@public 获取骨头捏造控制器指针
---@return XPinchFaceControl
function XEPinchSkeletonComponent:GetPinchControl() end


---@public 获取当前模型实例指针
---@return IXModelInstance
function XEPinchSkeletonComponent:GetModelInstance() end


---@type string @readonly Component类型名
XEPinchSkeletonComponent.COMPONENT_TYPENAME = ''


