---@class XESubviewPreviewer : XETexCustomPrimitive
XESubviewPreviewer = {}


---Subview 纹理预览组件
---对应XESubviewPreviewerActor
---@class XESubviewPreviewerComponent : XEActorComponent
XESubviewPreviewerComponent = {}


---@public 作为持有体绑定到子视图(使用当前其他属性设置）
---@param pSubviewName string 渲染的子视图名称
---@param bCreatSubviewIfNotExist boolean 如果子视图不存在,则指定是否自动创建一个
---@param bCreateCameraForSubview boolean 是否为subview创建一个内部相机对象,并使用该相机,以当前视口中相机参数进行创建，如果要修改相机参数，请获取该视口相机并进行修改
---@return boolean 是否成功
function XESubviewPreviewerComponent:BindSubview(pSubviewName, bCreatSubviewIfNotExist, bCreateCameraForSubview) end


---@public 从子视图中解除绑定
---@param bRemoveSubview boolean 是否在解除绑定后删除子视图
---@param pSubviewName string
---@return boolean 是否成功
function XESubviewPreviewerComponent:UnBindSubview(bRemoveSubview, pSubviewName) end


---@public 获取Subview Texture object
---@return XESubviewPreviewer
function XESubviewPreviewerComponent:GetSubviewPreviewer() end


---@public 设置面向相机
---@param bSet boolean
---@return void
function XESubviewPreviewerComponent:SetFaceViewportCamera(bSet) end


---@public 获取是否面向相机
---@return boolean
function XESubviewPreviewerComponent:IsFaceViewportCamera() end


---@public 获取是否渲染顶点
---@return boolean
function XESubviewPreviewerComponent:IsRenderVertices() end


---@public 设置是否渲染顶点
---@param bRender boolean
---@return void
function XESubviewPreviewerComponent:SetRenderVertices(bRender) end


---@type string @readonly Component类型名
XESubviewPreviewerComponent.COMPONENT_TYPENAME = ''


