---动画播放控制列表类，它也属于一个动画控制器
---@class XEAnimComponentPlayList : XEAnimController
XEAnimComponentPlayList = {}


---@public XEAnimComponentPlayList_new00
---@return XEAnimComponentPlayList
function XEAnimComponentPlayList:new() end


---@public XEAnimComponentPlayList_new01
---@param pAnimOwnerComponent XEModelComponent
---@return XEAnimComponentPlayList
function XEAnimComponentPlayList:new(pAnimOwnerComponent) end


---@class XEAnimComponentPlayList__Listener : XEAnimController__Listener
local XEAnimComponentPlayList__Listener = {}
XEAnimComponentPlayList.Listener = XEAnimComponentPlayList__Listener


---@public XEAnimComponentPlayList_Listener_new00
---@return XEAnimComponentPlayList__Listener
function XEAnimComponentPlayList__Listener:new() end


---@class XEAnimComponentPlayList__AnimWrapper
local XEAnimComponentPlayList__AnimWrapper = {}
XEAnimComponentPlayList.AnimWrapper = XEAnimComponentPlayList__AnimWrapper


---@public XEAnimComponentPlayList_AnimWrapper_new00
---@return XEAnimComponentPlayList__AnimWrapper
function XEAnimComponentPlayList__AnimWrapper:new() end


---@type number 索引
XEAnimComponentPlayList__AnimWrapper.nAddIndex = 0


---@type boolean stand by animation
XEAnimComponentPlayList__AnimWrapper.bSetAsScreenSaver = false


---@type string using path to generate the actual animation.
XEAnimComponentPlayList__AnimWrapper.strAnimAssetPath = ''


---@public 获取播放信息列表
---@return AnimWrapper[]
function XEAnimComponentPlayList:GetAnimWrapperList() end


---@public 判断是否是按播放列表顺序播放
---@return boolean
function XEAnimComponentPlayList:IsInTurnsPlay() end


---@public 获取当前播放的索引
---@return number
function XEAnimComponentPlayList:GetCurPlayIndex() end


---@public 设置与其关联的模型组件
---@param pOwner XEModelComponent
---@return void
function XEAnimComponentPlayList:SetComponentOwner(pOwner) end


---@public 获取与其关联的模型组件
---@return XEModelComponent
function XEAnimComponentPlayList:GetComponentOwner() end


---@public 播放 播放次序列表中索引为nArrangeIndex的动画条目
---@param nArrangeIndex number
---@return boolean 是否成功播放
function XEAnimComponentPlayList:PlayItem(nArrangeIndex) end


---@public 设置当前播放条目的播放次序索引
---@param nArrangeIndex number
---@return boolean 如果索引合法返回true,索引非法返回false.
function XEAnimComponentPlayList:SetCurrentPlayItemAt(nArrangeIndex) end


---@public 向播放列表中添加动画信息
---@param pAssetPath string 要添加的动画路径
---@param bSetAsScreenSaver boolean 是否标记为待机动画，默认为false
---@return number
function XEAnimComponentPlayList:AddAnimWrapper(pAssetPath, bSetAsScreenSaver) end


---@public 如果在Listener的响应函数中，想切换动画，调用此函数添加想要切换的动画信息
---@param pAssetPath string 要切换的动画资源路径
---@param bSetListLoop boolean 是否循环播放
---@return void
function XEAnimComponentPlayList:AddAnimPendingToPlay(pAssetPath, bSetListLoop) end


---@public 对应AddAnimPendingToPlay，如果想要切换动画立即生效，而不是等到下一帧生效，则调用此函数
---@return void
function XEAnimComponentPlayList:ApplyPendingAnimNow() end


---@public 从播放列表删除某个（些）动画条目
---@param pAssetPath string
---@param nAddIndex number 要删除的动画在添加列表中的索引（与播放次序列表索引不同，播放次序索引列表受播放次序模式影响），如果该值设为-1，表示删除动画列表中全部路径为pAssetPath的动画，默认为-1
---@return boolean
function XEAnimComponentPlayList:RemoveAnimWrapper(pAssetPath, nAddIndex) end


---@public 从播放列表删除某个动画条目
---@param nAddIndex number 要删除的动画在列表中的索引
---@return boolean
function XEAnimComponentPlayList:RemoveAnimWrapperForAddIndex(nAddIndex) end


---@public 删除播放列表中的全部条目
---@return void
function XEAnimComponentPlayList:RemoveAllAnimWrapper() end


---@public 根据索引获取某个动画条目
---@param nAddIndex number 添加到动画列表中的索引
---@return XEAnimComponentPlayList__AnimWrapper
function XEAnimComponentPlayList:GetAnimWrapperForAddIndex(nAddIndex) end


---@public 获取添加条目列表中索引为nAddIndex的播放次序索引值
---@param nAddIndex number 添加列表中的索引
---@return number 播放次序索引值
function XEAnimComponentPlayList:GetArrangeIndexForAddIndex(nAddIndex) end


---@public 获取播放次序索引为nArrangeIndex对应的添加条目列表中索引（与GetArrangeIndexForAddIndex相反）
---@param nArrangeIndex number 播放次序索引值
---@return number 对应添加列表中的索引
function XEAnimComponentPlayList:GetAddIndexForArrangeIndex(nArrangeIndex) end


---@public 根据动画路径获取添加列表中的索引值
---@param pAssetPath string 动画路径
---@return number 对应添加列表中的索引
function XEAnimComponentPlayList:GetAddIndexForOneAnim(pAssetPath) end


---@public 随机播放（根据随机播放模式生成随机播放的播放次序列表）
---@return void
function XEAnimComponentPlayList:Shuffle() end


---@public 顺序播放(根据顺序播放模式生成顺序播放的播放次序列表)
---@return void
function XEAnimComponentPlayList:MakeInTurns() end


---@public 获取对应的模型动画控制器
---@return XEAnimController
function XEAnimComponentPlayList:GetCurAnimController() end


---@public 判断当前播放条目是否被标记为待机动画
---@return boolean
function XEAnimComponentPlayList:IsCurrentScreenSaver() end


