---@class XEAnimControllerBase : XOwnerRecorder
XEAnimControllerBase = {}


---@type number @enum EPlayControlState 未知状态
XEAnimControllerBase.PS_UNKNOWN = 0


---@type number @enum EPlayControlState 播放
XEAnimControllerBase.PS_PLAY = 0


---@type number @enum EPlayControlState 暂停
XEAnimControllerBase.PS_PAUSE = 0


---@type number @enum EPlayControlState 停止
XEAnimControllerBase.PS_STOP = 0


---@type number @enum EAnimationMode 运行态
XEAnimControllerBase.AM_RUN = 0


---@type number @enum EAnimationMode 编辑态
XEAnimControllerBase.AM_EDIT = 0


---@type number @enum EAnimationMode
XEAnimControllerBase.AM_RUN_CLIP_SECTION = 0


---@class XEAnimControllerBase__AnimClipSection
local XEAnimControllerBase__AnimClipSection = {}
XEAnimControllerBase.AnimClipSection = XEAnimControllerBase__AnimClipSection


---@type number
XEAnimControllerBase__AnimClipSection.nSectionStart = 0


---@type number
XEAnimControllerBase__AnimClipSection.nSectionEnd = 0


---@type number <= 0 means infinite
XEAnimControllerBase__AnimClipSection.nLoopNum = 0


---@type number current loop-playing count
XEAnimControllerBase__AnimClipSection.nCurPlayLoopCount = 0


---@type boolean indicate the active status
XEAnimControllerBase__AnimClipSection.bActive = false


---@type string
XEAnimControllerBase__AnimClipSection.strClipName = ''


---@public XEAnimControllerBase_AnimClipSection_new00
---@return XEAnimControllerBase__AnimClipSection
function XEAnimControllerBase__AnimClipSection:new() end


---@public XEAnimControllerBase_new00
---@return XEAnimControllerBase
function XEAnimControllerBase:new() end


---@public 添加监听者
---@param pListener XEAnimControllerBase::Listener
---@return boolean
function XEAnimControllerBase:AddListener(pListener) end


---@public 移除监听者
---@param pListener XEAnimControllerBase::Listener
---@return boolean
function XEAnimControllerBase:RemoveListener(pListener) end


---@public 获取动画状态
---@return number
function XEAnimControllerBase:GetAnimRunMode() end


---@public 设置动画状态
---@param em number
---@return void
function XEAnimControllerBase:SetAnimRunMode(em) end


---@public 获取动画播放控制状态
---@return number
function XEAnimControllerBase:GetAnimPlayState() end


---@public 设置动画播放控制状态
---@param ps number
---@return void
function XEAnimControllerBase:SetAnimPlayState(ps) end


---@public 判断是否是循环播放状态
---@return boolean
function XEAnimControllerBase:IsLoop() end


---@public 判断是否是反向播放状态
---@return boolean
function XEAnimControllerBase:IsReverse() end


---@public 判断是否是正在播放状态
---@return boolean
function XEAnimControllerBase:IsPlaying() end


---@public 判断是否是自动播放状态
---@return boolean
function XEAnimControllerBase:IsAutoPlay() end


---@public 设置动画自动播放状态
---@param bAuto boolean
---@return void
function XEAnimControllerBase:SetAutoPlay(bAuto) end


---@public 获取动画播放速率
---@return number
function XEAnimControllerBase:GetPlayRate() end


---@public 判断动画是否是运行状态
---@return boolean
function XEAnimControllerBase:IsAnimRunMode() end


---@public 获取当前时间
---@return number
function XEAnimControllerBase:GetCurTime() end


---@public 获取当前所有监听者数组
---@return Listener[]
function XEAnimControllerBase:GetAnimListener() end


---@public 添加一个空白动画剪辑段，请使用返回结构进行设置
---@return XEAnimControllerBase__AnimClipSection
function XEAnimControllerBase:AddAnimClipSection() end


---@public 删除动画剪辑段, 如果szClipName为空，则删除所有
---@param szClipName string
---@return boolean
function XEAnimControllerBase:RemoveAnimClipSection(szClipName) end


---@public 查找一个动画剪辑段，根据名称, bIgnoreActive是否忽略剪辑的激活状态
---@param szClipName string
---@param bIgnoreActive boolean
---@return XEAnimControllerBase__AnimClipSection
function XEAnimControllerBase:FindAnimClipSectionByName(szClipName, bIgnoreActive) end


---@public 查找一个动画剪辑段，根据时刻, bIgnoreActive是否忽略剪辑的激活状态,in micro seconds.
---@param nMicoTimeStamp number
---@param bIgnoreActive boolean
---@return XEAnimControllerBase__AnimClipSection
function XEAnimControllerBase:FindAnimClipSectionByTimestamp(nMicoTimeStamp, bIgnoreActive) end


---@public 将播放时刻指针移动到指定剪辑段的头部
---@param szClipName string
---@return boolean
function XEAnimControllerBase:NavigateToAnimClipSectionHead(szClipName) end


---@public 将播放时刻指针移动到指定剪辑段的尾部
---@param szClipName string
---@return boolean
function XEAnimControllerBase:NavigateToAnimClipSectionTail(szClipName) end


---@public 从头播放, 并且设置为非动画剪辑段播放模式
---@return void
function XEAnimControllerBase:Play() end


---@public 指明要特定播放的剪辑动画段, 使动画控制器只在该剪辑段内播放。如果nLoopNum <=0,则该动画段无限循环
---@param szClipName string
---@param nLoopNum number
---@return boolean
function XEAnimControllerBase:PlayClipSection(szClipName, nLoopNum) end


---@public 获取当前设定的播放动画段
---@return XEAnimControllerBase__AnimClipSection
function XEAnimControllerBase:GetPlayClipSection() end


---@public 恢复播放
---@return void
function XEAnimControllerBase:Resume() end


---@public 停止播放
---@return void
function XEAnimControllerBase:Stop() end


---@public 暂停播放
---@return void
function XEAnimControllerBase:Pause() end


---@public 设置播放循环状态播放
---@param bLoop boolean
---@return void
function XEAnimControllerBase:SetLoop(bLoop) end


---@public 设置播放反向状态
---@param bReverse boolean
---@return void
function XEAnimControllerBase:SetReverse(bReverse) end


---@public 设置播放速率
---@param fRate number
---@return void
function XEAnimControllerBase:SetPlayRate(fRate) end


---@public 计算动画控制器的运行时结束时间
---@return number
function XEAnimControllerBase:GetTimeLength() end


---@public 定位播放器时刻， 单位为微秒
---@param nTime number
---@return void
function XEAnimControllerBase:SetTime(nTime) end


