---动画曲线播放控制器
---可以控制相机、Actor或组件的变换以曲线方式变化。
---一般设置了飞行起始点、飞行结束点，然后调用Fly()就可以了，默认是反正切曲线变化。
---@class XEAnimCurveFlyController : XEAnimController
XEAnimCurveFlyController = {}


---@public XEAnimCurveFlyController_new00
---@return XEAnimCurveFlyController
function XEAnimCurveFlyController:new() end


---@type number @enum eCanDriveObjectType
XEAnimCurveFlyController.AT_ACTOR = 0


---@type number @enum eCanDriveObjectType
XEAnimCurveFlyController.AT_COMPONENT = 0


---@type number @enum eCanDriveObjectType
XEAnimCurveFlyController.AT_CAMERA_BASE = 0


---@type number @enum eCanDriveObjectType
XEAnimCurveFlyController.AT_USER_DATA = 0


---@type number @enum eFlyAccelerationType 线性
XEAnimCurveFlyController.FAT_LINEAR = 0


---@type number @enum eFlyAccelerationType 反正切
XEAnimCurveFlyController.FAT_ATAN = 0


---@type number @enum eFlyStepInType 步进类型为按飞行时长，为默认的方式
XEAnimCurveFlyController.FST_DURATION = 0


---@type number @enum eFlyStepInType 步进类型为按飞行速度
XEAnimCurveFlyController.FST_VELOCITY = 0


---@type number @enum eFlyPointMode
XEAnimCurveFlyController.FPM_FIX_POINTS = 0


---@type number @enum eFlyPointMode
XEAnimCurveFlyController.FPM_FLEXIBLE_POINTS = 0


---@public 设置飞行持续时间，单位是秒（s）
---@param fTime number
---@return void
function XEAnimCurveFlyController:SetFlyDuration(fTime) end


---@public 获取飞行持续时间，单位是秒（s）
---@return number
function XEAnimCurveFlyController:GetFlyDuration() end


---@public 设置一个飞行速度
---@param fV number
---@return void
function XEAnimCurveFlyController:SetFlyVelocity(fV) end


---@public 获取飞行速度，单位是m/秒（m/s）
---@return number
function XEAnimCurveFlyController:GetFlyVelocity() end


---@public 获取已经飞行的时间，单位是秒（s）
---@return number
function XEAnimCurveFlyController:GetCurElapseTime() end


---@public 设置飞行持续时间最小值，单位是秒（s）
---@param fDuration number
---@return void
function XEAnimCurveFlyController:SetMinFlyDuration(fDuration) end


---@public 获取飞行持续时间最小值，单位是秒（s）
---@return number
function XEAnimCurveFlyController:GetMinFlyDuration() end


---@public 设置飞行持续时间最大值，单位是秒（s）
---@param fDuration number
---@return void
function XEAnimCurveFlyController:SetMaxFlyDuration(fDuration) end


---@public 设置飞行持续时间最大值，单位是秒（s）
---@return number
function XEAnimCurveFlyController:GetMaxFlyDuration() end


---@public 获取当前飞行曲线点数
---@return number
function XEAnimCurveFlyController:GetFlyCurvePointNum() end


---@public 获取百分比对应的点索引，取百分比上限，即 inputPercent <= percentInVals
---@param fPercent number
---@return number
function XEAnimCurveFlyController:GetFlyCurvePointIndexForUpperPercent(fPercent) end


---@public 设置飞行曲线在时间变化类型为FAT_ATAN时，
---反正切函数的图像特性，使x在区间[-fFlyInterval, fEndingRatefFlyInterval]内，
---计算arctan(x)的函数值，并以此值作为飞行百分比。当fEndingRate = 1时，表现为两端缓慢相同，中间快速；
---fEndingRate越大，则飞行结尾越长。
---@param fEndingRate number
---@param fFlyInterval number
---@return void
function XEAnimCurveFlyController:SetFlyEndFadeFactor(fEndingRate, fFlyInterval) end


---@public 设置飞行曲线在时间变化类型为FAT_ATAN时，
---反正切函数的图像特性，使x在区间[-fFlyInterval  fStartRate, fFlyInterval]内，
---计算arctan(x)的函数值，并以此值作为飞行百分比。当fStartRate = 1时，表现为两端缓慢相同，中间快速；
---fEndingRate越大，则飞行结尾越长。
---@param fStartRate number
---@param fFlyInterval number
---@return void
function XEAnimCurveFlyController:SetFlyStartFadeFactor(fStartRate, fFlyInterval) end


---@public 设置飞行曲线在时间变化类型为FAT_ATAN时，
---反正切函数的图像特性，使x在区间[-fStartRatefFlyInterval, fEnd]Rate  fFlyInterval内
---计算arctan(x)的函数值，并以此值作为飞行百分比。
---fEndingRate越大，则飞行结尾越长。
---@param fStartRate number
---@param fEndRate number
---@param fFlyInterval number
---@return void
function XEAnimCurveFlyController:SetFlyFadeFactor(fStartRate, fEndRate, fFlyInterval) end


---@public 设置飞行开始的变换信息，有四种方式
---@param mat4 XMATRIX4
---@return void
function XEAnimCurveFlyController:SetFlyBegin(mat4) end


---@public 设置飞行开始的变换信息，有四种方式
---@param vLocation XVECTOR3
---@param vForwardDir XVECTOR3
---@param vUp XVECTOR3
---@return void
function XEAnimCurveFlyController:SetFlyBegin(vLocation, vForwardDir, vUp) end


---@public 设置飞行开始的变换信息，有四种方式
---@param vLocation XVECTOR3
---@param quat XQUATERNION
---@return void
function XEAnimCurveFlyController:SetFlyBegin(vLocation, quat) end


---@public 设置飞行开始的变换信息，有四种方式
---@param vLocation XVECTOR3
---@param fPitch number
---@param fYaw number
---@param fRoll number
---@return void
function XEAnimCurveFlyController:SetFlyBegin(vLocation, fPitch, fYaw, fRoll) end


---@public 设置飞行结束的变换信息，有四种方式
---@param mat4 XMATRIX4
---@return void
function XEAnimCurveFlyController:SetFlyEnd(mat4) end


---@public 设置飞行结束的变换信息，有四种方式
---@param vLocation XVECTOR3
---@param vForwardDir XVECTOR3
---@param vUp XVECTOR3
---@return void
function XEAnimCurveFlyController:SetFlyEnd(vLocation, vForwardDir, vUp) end


---@public 设置飞行结束的变换信息，有四种方式
---@param vLocation XVECTOR3
---@param quat XQUATERNION
---@return void
function XEAnimCurveFlyController:SetFlyEnd(vLocation, quat) end


---@public 设置飞行结束的变换信息，有四种方式
---@param vLocation XVECTOR3
---@param fPitch number
---@param fYaw number
---@param fRoll number
---@return void
function XEAnimCurveFlyController:SetFlyEnd(vLocation, fPitch, fYaw, fRoll) end


---@public 在飞行变化曲线中添加点
---@param mat4 XMATRIX4 对应的变换矩阵信息
---@param fPercent number 对应的变化百分比[0-1]
---@return void
function XEAnimCurveFlyController:SetupFlyPoint(mat4, fPercent) end


---@public 按某个百分比时的变换矩阵进行物件飞行
---@param fPercent number [in]变化百分比[0-1]
---@return XMATRIX4
---@return boolean
function XEAnimCurveFlyController:FlyToPercent(fPercent) end


---@public 获取某个百分比时的变换矩阵
---@param fPercent number [in]变化百分比[0-1]
---@return XMATRIX4
---@return boolean
function XEAnimCurveFlyController:GetFlyMatrixOfPercent(fPercent) end


---@public 计算某个时间戳时的变换矩阵
---@param fTimestamp number [in]飞行时间戳,范围是[0-duration]
---@return XMATRIX4
---@return boolean
function XEAnimCurveFlyController:FlyToTimestamp(fTimestamp) end


---@public 获取当前飞行百分比
---@return number
function XEAnimCurveFlyController:GetCurFlyPercent() end


---@public 开始飞行（至少设置了起始和结束点，就可以执行此函数）
---自动计算一次持续时间， 如果步进模式为按时间，则限制在最大最小时间范围内
---@param pWorld XEWorld 飞行的世界
---@param objType number 飞行物体类型（Actor/Component/Camera）
---@param pFlyObject userdata 飞行的物体
---@param accelerateType number 飞行类型（Linear/ArcTangent）
---@param stepInType number
---@param pointMode number 飞行的点模式
---@return void
function XEAnimCurveFlyController:Fly(pWorld, objType, pFlyObject, accelerateType, stepInType, pointMode) end


---@public 设置飞行缓存点数的大小，达到指定的数量时，构建飞行曲线，并清空缓存
---@param nSize number
---@return void
function XEAnimCurveFlyController:SetCacheSize(nSize) end


---@public 添加一个飞行缓存点
---@param mat4 XMATRIX4 [in]飞行点矩阵
---@param fOffsetTimeVal number 指明一个飞行偏移时间，如果>0,则使用该偏移作为新点的j时间戳
---@return number 返回为0时，缓存达到或超过容量，并且开始飞行；否则返回当前缓存数
function XEAnimCurveFlyController:AddCachePoint(mat4, fOffsetTimeVal) end


---@public 从缓存中构建曲线，需要在Fly被调用之后
---@return boolean
function XEAnimCurveFlyController:BuildFromCachePoint() end


---@public 清空飞行曲线
---@return void
function XEAnimCurveFlyController:ClearFlyPoints() end


---@public 删除一个飞行曲线上的点
---@param nIndex number
---@return boolean
function XEAnimCurveFlyController:RemoveFlyPoint(nIndex) end


---@public 获取飞行物体的类型
---@return number
function XEAnimCurveFlyController:GetFlyObjectType() end


---@public 获取相机，如果飞行物体是相机，则返回相机，否则返回NULL
---@return XBaseCamera
function XEAnimCurveFlyController:GetCameraFlyObject() end


---@public 获取Actor，如果飞行物体是Actor，则返回Actor，否则返回NULL
---@return XEActor
function XEAnimCurveFlyController:GetActorFlyObject() end


---@public 获取XEActorComponent，如果飞行物体是XEActorComponent，则返回XEActorComponent，否则返回NULL
---@return XEActorComponent
function XEAnimCurveFlyController:GetActorComponentFlyObject() end


---@public 获取飞行物体
---@return userdata
function XEAnimCurveFlyController:GetFlyObject() end


---@class XEAnimFlyCurveControllerManager : XOwnerRecorder
XEAnimFlyCurveControllerManager = {}


---@public XEAnimFlyCurveControllerManager_new00
---@return XEAnimFlyCurveControllerManager
function XEAnimFlyCurveControllerManager:new() end


---@public 添加一个引擎实例中的物件飞行控制器, 如果不指定szControllerName， 则自动命名（唯一）
---@param szControllerName string
---@return XEAnimCurveFlyController
function XEAnimFlyCurveControllerManager:AddAnimCurveFlyController(szControllerName) end


---@public 移动一个物件飞行控制器
---@param szControllerName string
---@return boolean
function XEAnimFlyCurveControllerManager:RemoveAnimCurveFlyController(szControllerName) end


---@public 获取当前物件飞行控制器个数
---@return number
function XEAnimFlyCurveControllerManager:GetAnimCurveFlyControllerCount() end


---@public 获取指定索引的物件飞行控制器
---@param szControllerName string
---@return XEAnimCurveFlyController
function XEAnimFlyCurveControllerManager:GetAnimCurveFlyController(szControllerName) end


---@public XEAnimFlyCurveControllerManager_Release00
---@return void
function XEAnimFlyCurveControllerManager:Release() end


