---Montage的通知基类
---@class XEAnimMonNotify : XEAnimMonBase
XEAnimMonNotify = {}


---@type number @enum NotifyState
XEAnimMonNotify.NS_UNKOWN = 0


---@type number @enum NotifyState
XEAnimMonNotify.NS_LIVE_EXPLAINED = 0


---@type number @enum NotifyState
XEAnimMonNotify.NS_SILENT_EXPLAINED = 0


---@public XEAnimMonNotify_new00
---@return XEAnimMonNotify
function XEAnimMonNotify:new() end


---@type string @readonly 
XEAnimMonNotify.NODE_TYPENAME = ''


---@public 设置通知播放的起始时间，单位是微秒
---@param nMicroSeconds number
---@return void
function XEAnimMonNotify:SetStartTime(nMicroSeconds) end


---@public 获取通知播放的起始时间
---@return number
function XEAnimMonNotify:GetStartTime() end


---@public 是否是父节点上同类型的通知中的最后一个
---@param nUpperboundTime number
---@return boolean
function XEAnimMonNotify:IsTheLast(nUpperboundTime) end


---@public 是否在父节点的有效区间内
---@return boolean
function XEAnimMonNotify:IsInParentRange() end


---@public 设置是否为有效段模式
---有效段模式关闭时，会判定一次触发／反触发的运行情况，不考虑是否在段区间内。
---@param bSectionMode boolean
---@return void
function XEAnimMonNotify:SetSectionMode(bSectionMode) end


---@public 判断是否为有效段模式
---@return boolean
function XEAnimMonNotify:IsSectionMode() end


---@public 获取在有效段模式时，有效段结束时间，单位是微秒
---@return number
function XEAnimMonNotify:GetSectionEndTime() end


---@public 设置在有效段模式时，有效段结束时间，单位是微秒
---@param nMicroSeconds number
---@return void
function XEAnimMonNotify:SetSectionEndTime(nMicroSeconds) end


