---骨头节点对应的实例类
---@class XEBoneInstance : XEUserNodeInstance
XEBoneInstance = {}


---@public XEBoneInstance_new00
---@param pNodeTl XEBone
---@return XEBoneInstance
function XEBoneInstance:new(pNodeTl) end


---@public 设置引擎骨头实例指针
---@param pBone XBone
---@return void
function XEBoneInstance:SetBone(pBone) end


---@public 获取引擎骨头实例指针
---@return XBone
function XEBoneInstance:GetBone() end


---@public 获取当前骨头索引
---@return number
function XEBoneInstance:GetBoneIndex() end


---@public 获取当前骨头实例对应的模板指针
---@return XEBone
function XEBoneInstance:GetBoneTemplate() end


---@public 获取当前骨头相对于父节点的矩阵
---@return XMATRIX4 [out]矩阵
function XEBoneInstance:GetRelativeMatrix() end


---@public 获取当前骨头相对于父节点的矩阵信息
---@return XETransform
---@return boolean 是否获取成功
function XEBoneInstance:GetRelativeTransform() end


---@public 获取当前骨头的绝对矩阵信息
---@return XMATRIX4 [out]矩阵
function XEBoneInstance:GetAbsoluteMatrix() end


---@public 获取当前骨头的绝对矩阵信息
---@return XETransform
---@return boolean 是否获取成功
function XEBoneInstance:GetAbsoluteTransform() end


---@public 设置当前骨头相对于父节点的矩阵信息
---@param tf  XETransform [in]矩阵信息
---@return boolean 是否设置成功
function XEBoneInstance:SetRelativeTransform(tf) end


---@public 从当前骨头节点Manager中移除刚体实例指针
---@param pIns XEPhysicsSkeletalBodyInstance 要移除的刚体实例指针
---@return void
function XEBoneInstance:RemoveBodyIns(pIns) end


---@public XEBoneInstance_BuildBoneCollider00
---@return XEBoneColliderInstance
function XEBoneInstance:BuildBoneCollider() end


---@public 从当前骨头节点Manager中移除碰撞体
---@return void
function XEBoneInstance:RemoveAllBoneCollider() end


---@public 从当前骨头节点Manager中移除碰撞体
---@param ins XEBoneColliderInstance
---@return void
function XEBoneInstance:RemoveBoneCollider(ins) end


---@public 从当前骨头节点逆向计算出根节点的世界矩阵
---@param matWorld XMATRIX4 这个骨头节点的拟世界矩阵（未生效到骨架里）
---@return XMATRIX4
function XEBoneInstance:CalculateRootWorldMatrix(matWorld) end


---@public 从当前骨头节点逆向计算出根节点的世界矩阵
---@param _pModelCom XEModelComponent 操作的Component节点指针
---@return boolean
function XEBoneInstance:RemoveBoneChain(_pModelCom) end


---@public 从当前骨头节点逆向计算出根节点的世界矩阵
---@param _pModelCom XEModelComponent 操作的Component节点指针
---@return number
function XEBoneInstance:BuildBoneChain(_pModelCom) end


---@public 从当前骨头节点逆向计算出根节点的世界矩阵
---@param _pModelCom XEModelComponent 操作的Component节点指针
---@return boolean
function XEBoneInstance:RecoverBoneChain(_pModelCom) end


---@public 从当前骨头节点逆向计算出根节点的世界矩阵
---@return boolean 是否是软骨
function XEBoneInstance:isSoftBone() end


---@public 获取软骨指针
---@return XESoftBoneChain
function XEBoneInstance:GetSoftBoneChain() end


---@public XEBoneInstance_InitSoftBoneState00
---@return void
function XEBoneInstance:InitSoftBoneState() end


