---组件移动附加器
---@class XEMovementAttacher
XEMovementAttacher = {}


---@public XEMovementAttacher_new00
---@return XEMovementAttacher
function XEMovementAttacher:new() end


---@public XEMovementAttacher_Tick00
---@param DeltaTime number
---@return void
function XEMovementAttacher:Tick(DeltaTime) end


---@class XEMovementAttacher__MoveableComponent
local XEMovementAttacher__MoveableComponent = {}
XEMovementAttacher.MoveableComponent = XEMovementAttacher__MoveableComponent


---@type number @enum MoveState
XEMovementAttacher__MoveableComponent.MS_NOT_START = 0


---@type number @enum MoveState
XEMovementAttacher__MoveableComponent.MS_MOVING = 0


---@type number @enum MoveState
XEMovementAttacher__MoveableComponent.MS_FINISHED = 0


---@type number @enum MoveDir
XEMovementAttacher__MoveableComponent.MD_NEGATIVE = 0


---@type number @enum MoveDir
XEMovementAttacher__MoveableComponent.MD_POSITIVE = 0


---@type number @enum MoveStrategy
XEMovementAttacher__MoveableComponent.MG_ONCE = 0


---@type number @enum MoveStrategy
XEMovementAttacher__MoveableComponent.MG_PATROL = 0


---@type number @enum MoveStrategy
XEMovementAttacher__MoveableComponent.MG_CYCLE = 0


---@public XEMovementAttacher_MoveableComponent_new00
---@return XEMovementAttacher__MoveableComponent
function XEMovementAttacher__MoveableComponent:new() end


---@type XEActorComponent
XEMovementAttacher__MoveableComponent.pComponent = {}


---@type boolean
XEMovementAttacher__MoveableComponent.bRunning = false


---@type number true for moving positive and negative.
XEMovementAttacher__MoveableComponent.eMoveStrategy = 0


---@type number true for positive.
XEMovementAttacher__MoveableComponent.eCurDir = 0


---@type number the state for going to the first point. 0-not done, 1-doing, 2-done.
XEMovementAttacher__MoveableComponent.eGotoFirstPointState = 0


---@type number current movement of going to the first point.
XEMovementAttacher__MoveableComponent.fCurGotoFirstPointLen = 0


---@type number total movements of going to the first point.
XEMovementAttacher__MoveableComponent.fGotoFirstPointLen = 0


---@type number to determine the current run position.
XEMovementAttacher__MoveableComponent.fRunSpeed = 0


---@type number current index of the track points.
XEMovementAttacher__MoveableComponent.nCurTrackPointIndex = 0


---@type number determine the exact position.
XEMovementAttacher__MoveableComponent.fCurSegMoveLen = 0


---@type number determine whether to change the points.
XEMovementAttacher__MoveableComponent.fCurTrackSegLen = 0


---@type XVECTOR3 current movement direction of going to the first point.
XEMovementAttacher__MoveableComponent.vCurGotoFirstPointDir = {}


---@type XVECTOR3
XEMovementAttacher__MoveableComponent.vCurGotoFirstPointStartLocation = {}


---@type XQUATERNION for turning...
XEMovementAttacher__MoveableComponent.qPivotRotation = {}


---@public 添加要处理移动的模型组件
---@param pComponent XEActorComponent 要添加的模型组件指针
---@param eMoveStrategy number 移动策略，默认为MG_ONCE
---@return boolean 是否添加成功
function XEMovementAttacher:AddMovementComponent(pComponent, eMoveStrategy) end


---@public XEMovementAttacher_AddMovementComponent01
---@param pComponent XEActorComponent
---@param eMoveStrategy number
---@param qPivot XQUATERNION
---@return boolean
function XEMovementAttacher:AddMovementComponent(pComponent, eMoveStrategy, qPivot) end


---@public 删除处理移动的模型组件
---@param pComponent XEActorComponent 要删除的模型组件指针
---@return boolean 是否删除成功
function XEMovementAttacher:RemoveMovementComponent(pComponent) end


---@public 处理模型移动
---@param pComponent XEActorComponent 要移动的模型组件指针
---@param szTrackname string 移动轨迹名称，如sin/circle...
---@param fAtWhatSpeed number 移动速度
---@return boolean 是否执行成功
function XEMovementAttacher:DoMove(pComponent, szTrackname, fAtWhatSpeed) end


---@public 停止模型移动
---@param pComponent XEActorComponent 要停止移动的模型组件指针
---@return boolean 是否执行成功
function XEMovementAttacher:DoStop(pComponent) end


---@public 设置移动策略
---@param pComponent XEActorComponent 要处理移动的模型组件指针
---@param eMoveStrategy number 移动策略，默认为MG_PATROL
---@return boolean 是否设置成功
function XEMovementAttacher:SetMoveStrategy(pComponent, eMoveStrategy) end


---@public 设置旋转角度
---@param pComponent XEActorComponent 要处理旋转的模型组件指针
---@param qQ XQUATERNION 旋转角度四元数
---@return boolean 是否设置成功
function XEMovementAttacher:SetPivotRotation(pComponent, qQ) end


---@public 获取旋转角度
---@param pComponent XEActorComponent 要获取旋转的模型组件指针
---@return XQUATERNION 旋转角度四元数
function XEMovementAttacher:GetPivotRotation(pComponent) end


---@public 添加移动轨迹
---@param szTrackname string 移动轨迹名称
---@param vTrackPoints XVECTOR3[] 移动轨迹点数组
---@return boolean 是否添加成功
function XEMovementAttacher:AddMovementTrack(szTrackname, vTrackPoints) end


---@public 判断是否有某个移动轨迹
---@param szTrackname string 移动轨迹名称
---@return boolean 是否找到
function XEMovementAttacher:HasMovementTrack(szTrackname) end


---@public 删除移动轨迹
---@param szTrackname string 移动轨迹名称
---@return boolean 是否删除成功
function XEMovementAttacher:RemoveMovementTrack(szTrackname) end


---@public 获取处理移动的组件指针
---@param pComponent XEActorComponent
---@return XEMovementAttacher__MoveableComponent
function XEMovementAttacher:GetMovableComponent(pComponent) end


