---骨架对应的实例类
---@class XESkeletonInstance : XEUserNodeInstance
XESkeletonInstance = {}


---@public XESkeletonInstance_new00
---@param pNodeTl XESkeleton
---@return XESkeletonInstance
function XESkeletonInstance:new(pNodeTl) end


---@public 更新当前骨架上的所有插槽
---@return void
function XESkeletonInstance:UpdateSocket() end


---@public 获取当前骨架实例的模板指针
---@return XESkeleton
function XESkeletonInstance:GetSkeletonTemplate() end


---@public 根据名称获取骨架上的某个插槽实例
---@param sokcetName string
---@return XEBindSocketInstance
function XESkeletonInstance:GetBindSocketInstance(sokcetName) end


---@public 获取当前骨架上的所有插槽实例
---@param socketInstances XEBindSocketInstance[] [out]插槽实例指针数组
---@return number 插槽个数
function XESkeletonInstance:GetBindSocketInstances(socketInstances) end


---@public 更新所有软骨
---@return void
function XESkeletonInstance:UpdateSoftBones() end


---@public 根据骨头索引获取骨头实例指针
---@param nBoneIndex number
---@return XEBoneInstance
function XESkeletonInstance:GetXEBoneInstance(nBoneIndex) end


---@public 设置是否允许渲染骨头
---@param bEnable boolean
---@return void
function XESkeletonInstance:EnableRenderBone(bEnable) end


---@public 判断是否允许渲染骨头
---@return boolean
function XESkeletonInstance:IsEnableRenderBone() end


---@public 设置是否允许渲染软骨
---@param bEnable boolean
---@return void
function XESkeletonInstance:EnableRenderSoftBone(bEnable) end


---@public 判断是否允许渲染软骨
---@return boolean
function XESkeletonInstance:IsEnableRenderSoftBone() end


---@public 设置是否允许渲染碰撞体
---@param bEnable boolean
---@return void
function XESkeletonInstance:EnableRenderBonecollider(bEnable) end


---@public 判断是否允许渲染碰撞体
---@return boolean
function XESkeletonInstance:IsEnableRenderBonecollider() end


---@public 设置当前选中的骨头索引
---@param nIndex number
---@return void
function XESkeletonInstance:SelectBone(nIndex) end


---@public 获取当前选中的骨头索引
---@return number
function XESkeletonInstance:GetSelectBone() end


---@public 获取引擎骨架指针
---@return XSkeleton
function XESkeletonInstance:GetXSkeleton() end


---@public XESkeletonInstance_GetXSkeleton01
---@return  XSkeleton
function XESkeletonInstance:GetXSkeleton() end


---@public 设置引擎骨架指针
---@param pSkeletonIns XSkeleton
---@return void
function XESkeletonInstance:SetXSkeleton(pSkeletonIns) end


---@public 获取骨架附加的模型组件指针
---@return XEModelComponent
function XESkeletonInstance:GetAttachComponent() end


---@public 设置骨头大小
---@param fSize number
---@return void
function XESkeletonInstance:SetBoneSize(fSize) end


---@public 获取骨头大小
---@return number
function XESkeletonInstance:GetBoneSize() end


---@public 设置是否允许渲染骨架
---@param bRender boolean
---@return void
function XESkeletonInstance:EnableRenderCone(bRender) end


---@public 判断是否允许渲染骨架
---@return boolean
function XESkeletonInstance:IsEnableRenderCone() end


---@public 设置骨架附加的模型组件
---@param pComponent XEModelComponent
---@return void
function XESkeletonInstance:SetAttachComponent(pComponent) end


---@public 重新创建物理实例
---@return boolean
function XESkeletonInstance:ReCreatePhysicsInstance() end


---@public 添加选中的节点
---@param pIns XEUserNode 选中的节点指针
---@return void
function XESkeletonInstance:AddSelectedIns(pIns) end


---@public 清空选中节点数组
---@return void
function XESkeletonInstance:ClearSelectedInsList() end


