---IXEEngineInstance XECORE层的引擎实例对象，内部实现了引擎各个模块的初始化(Init)、销毁(Release)、更新(Frame)的处理逻辑
---@class XEEngineInstance : XEngineInstance
XEEngineInstance = {}


---@public 此函数内执行两部分的工作，一是更新引擎资源，例如，对需要进行渲染的3D对象。二是更新 XEEngineInstance 中保存的 XEFrameListener 监听事件。
---@return void
function XEEngineInstance:Frame() end


---@public 获取Engine当前版本号(xchar*)
---@return string
function XEEngineInstance:GetEngineVersion() end


---@public 获取Engine当前版本号(xint32)
---@return number
function XEEngineInstance:GetEngineVersionValue() end


---@public 获取Engine编译时间
---@return string
function XEEngineInstance:GetEngineVersionCompileTime() end


---@public 获取换装管理器指针
---@return IXEDressupManager
function XEEngineInstance:GetDressupManager() end


---@public 获取视口管理器指针
---@return XEViewportManager
function XEEngineInstance:GetViewportManager() end


---@public 获取事件管理器指针
---@return XEEventManager
function XEEngineInstance:GetEventManager() end


---@public 获取脚本解释器指针
---@return XEScriptInterpreterPool
function XEEngineInstance:GetScriptInterPreterPool() end


---@public 获取曲线管理器指针
---@return XDistributionManager
function XEEngineInstance:GetDistributionManager() end


---@public 设置当前Tick帧间隔
---@param fDel number
---@return void
function XEEngineInstance:SetCurDeltaTime(fDel) end


---@public 设置是否允许Tick，如果设置为false，将不执行Tick函数
---@param bEnable boolean
---@return void
function XEEngineInstance:SetTickEnable(bEnable) end


---@public 获取当前Tick帧间隔
---@return number
function XEEngineInstance:GetCurDeltaTime() end


---@public 设置XEGame的当前ViewPort指针
---@param pViewport XEViewport ViewPort指针
---@return void
function XEEngineInstance:SetCurViewPort(pViewport) end


---@public XEEngineInstance_SetCurViewports00
---@param vViewports XEViewport[]
---@return void
function XEEngineInstance:SetCurViewports(vViewports) end


---@public 获取XEGame的当前ViewPort指针
---@return XEViewport
function XEEngineInstance:GetCurViewPort() end


---@public 获取Game的输入事件管理器（默认为无）
---@return XEInputEventManager
function XEEngineInstance:GetGameInputEventMgr() end


---@public 设置Game的输入事件管理器（默认为无）
---@param pMgr XEInputEventManager
---@return void
function XEEngineInstance:SetGameInputEventMgr(pMgr) end


---@public 获取动画序列资产管理器指针
---@return XEAnimAssetCacheManager
function XEEngineInstance:GetAnimAssetCacheManager() end


---@public 获取飞行管理器指针
---@return XEAnimFlyCurveControllerManager
function XEEngineInstance:GetAnimCurveFlyControllerManager() end


---@public 获取材质曲线效果管理器指针
---@return XEMatFxBindingManager
function XEEngineInstance:GetMatFxBindingManager() end


---@public XEEngineInstance_GetGameplayTagsManager00
---@return XEGameplayTagsManager
function XEEngineInstance:GetGameplayTagsManager() end


---@public XEEngineInstance_GetScheduler00
---@return XEScheduler
function XEEngineInstance:GetScheduler() end


---@public 释放所有世界
---@return void
function XEEngineInstance:ReleaseAllWorld() end


---@public 创建世界
---@param pWorld XEWorld 为NULL,内部创建一个XEWorld并返回指针；为非NULL,内部直接初始化.
---@return XEWorld 返回创建的世界指针
function XEEngineInstance:CreateXEWorld(pWorld) end


---@public 获取当前Game中的世界列表
---@return XEWorld[]
function XEEngineInstance:GetWorldList() end


---@public 获取当前Game中的世界列表
---@return XEWorld[]
function XEEngineInstance:GetWorldList() end


---@public 删除一个世界，pWorld为要删除的世界指针
---@param pWorld XEWorld
---@return void
function XEEngineInstance:DeleteXEWorld(pWorld) end


---@public 判断是否已经初始化
---@return boolean
function XEEngineInstance:IsInit() end


---@public 重新加载资源
---@param pathList string[] 资源列表
---@return void 返回创建的世界指针
function XEEngineInstance:ReloadResource(pathList) end


---@public 删除模板
---@param pLevel XELevel
---@return number 删除的个数
function XEEngineInstance:RemoveAllTemplateInLevel(pLevel) end


---@public 删除模板
---@param pWorld XEWorld 关联的世界
---@return number 删除的个数
function XEEngineInstance:RemoveAllTemplateInWorld(pWorld) end


---@public 释放所有模板
---@return void
function XEEngineInstance:ReleaseAllTemplate() end


---@public 获取绑定脚本实例指针
---@return XEScriptContainerInstance
function XEEngineInstance:GetScriptContainerInstance() end


---@public 根据给定路径创建一个绑定脚本实例
---@param pAssetPath string
---@return boolean
function XEEngineInstance:AttachBindingScriptAsset(pAssetPath) end


---@public 移除绑定脚本实例
---@return void
function XEEngineInstance:DetachBindingScriptInstance() end


