---事件列表类
---@class XEEventList : XOwnerRecorder
XEEventList = {}


---@public XEEventList_new00
---@return XEEventList
function XEEventList:new() end


---@public 设置世界指针
---@param pWorld XEWorld
---@return void
function XEEventList:SetWorld(pWorld) end


---@public 获取世界指针
---@return XEWorld
function XEEventList:GetWorld() end


---@public 判断pEvent是否是空事件
---@param pEvent  XEEventBase
---@return boolean
function XEEventList:IsNullEvent(pEvent) end


---@public 设置事件列表名称
---@param szName string
---@return void
function XEEventList:SetName(szName) end


---@public 获取事件列表名称
---@return string
function XEEventList:GetName() end


---@public 往事件列表中添加一个事件pEvent
---@param pEvent XEEventBase
---@return void
function XEEventList:PushBack(pEvent) end


---@public 事件列表尾部弹出一个事件，并释放这个事件
---@return void
function XEEventList:PopBack() end


---@public 获取到一个有效的事件名称
---@param pPrefix string
---@return string
function XEEventList:GetValidEventName(pPrefix) end


---@public 删除事件列表中的某个事件
---@param pEvent XEEventBase 要删除的事件指针
---@return boolean 是否删除成功
function XEEventList:Remove(pEvent) end


---@public 判断事件列表中是否包含某个事件
---@param pEvent  XEEventBase 被判断的事件指针
---@return boolean 是否含有
function XEEventList:Has(pEvent) end


---@public 查找事件列表中是否包含某个类型的某个事件
---@param szEventType string 被判断的事件类型
---@param szEventName string 被判断的事件名称
---@return XEEventBase 查找到的事件指针
function XEEventList:Find(szEventType, szEventName) end


---@public 判断当前事件列表是否为空
---@return boolean
function XEEventList:IsEmpty() end


---@public 返回当前事件列表的迭代器
---@return IteratorWrapper<XEEventBase*>
function XEEventList:GetEventIterator() end


---@public 释放当前事件列表（会释放列表中的每个事件，再清空列表）
---@return void
function XEEventList:Release() end


