---@class XEMatFxBindingManager : XOwnerRecorder
XEMatFxBindingManager = {}


---@public XEMatFxBindingManager_new00
---@return XEMatFxBindingManager
function XEMatFxBindingManager:new() end


---@class XEMatFxBindingManager__MaterialFxInsMapping
local XEMatFxBindingManager__MaterialFxInsMapping = {}
XEMatFxBindingManager.MaterialFxInsMapping = XEMatFxBindingManager__MaterialFxInsMapping


---@type string
XEMatFxBindingManager__MaterialFxInsMapping.strSkinName = ''


---@type string
XEMatFxBindingManager__MaterialFxInsMapping.strMeshName = ''


---@type number
XEMatFxBindingManager__MaterialFxInsMapping.nLodId = 0


---@type XEMaterialFxInstance
XEMatFxBindingManager__MaterialFxInsMapping.materialFxIns = {}


---@public XEMatFxBindingManager_MaterialFxInsMapping_new00
---@return XEMatFxBindingManager__MaterialFxInsMapping
function XEMatFxBindingManager__MaterialFxInsMapping:new() end


---@public 获取指定组件中记录的材质效果实例
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param key  XEMatFxBindingManager::MaterialFxInsMapping 材质参数键
---@return XEMaterialFxInstance 材质效果实例指针
function XEMatFxBindingManager:GetMaterialFxInstance(pComponent, key) end


---@public 获取指定材质实例中记录的材质效果实例
---@param pMaterialIns  IXMaterialInstance 材质实例对象
---@return XEMaterialFxInstance 材质效果实例指针
function XEMatFxBindingManager:GetMaterialFxInstance(pMaterialIns) end


---@public 获取指定材质实例路径关联的材质效果实例数组
---@param strMaterialInsPath string 材质实例相对路径
---@return XEMaterialFxInstance[]
---@return void
function XEMatFxBindingManager:GetMaterialFxInstances(strMaterialInsPath) end


---@public 获取指定材质实例中绑定的ActorComponent
---@param pMaterialIns  IXMaterialInstance 材质实例对象
---@return XEActorComponent ActorComponent指针
function XEMatFxBindingManager:GetBindingComponent(pMaterialIns) end


---@public 获取指定组件中的材质效果实例集
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@return XEMaterialFxInstance[]
function XEMatFxBindingManager:GetMaterialFxInstances(pComponent) end


---@public 获取指定组件中的材质效果实例集的映射集
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@return MaterialFxInsMapping[]
function XEMatFxBindingManager:GetMaterialFxInsMappings(pComponent) end


---@public 获取指定材质参数模板文件的所有实例对象
---@param szAssetPath string 资产文件
---@return MaterialFxInsMapping[]
function XEMatFxBindingManager:GetMaterialFxInsMappingsForMaterialFxAssetPath(szAssetPath) end


---@public 从关联中移除（仅移除）
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param key  XEMatFxBindingManager::MaterialFxInsMapping 材质参数键
---@return boolean 是否移除成功
function XEMatFxBindingManager:RemoveMaterialFxInstance(pComponent, key) end


---@public 将指定组件的材质效果实例指向pMaterialFxIns
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param key  XEMatFxBindingManager::MaterialFxInsMapping 材质参数键
---@param pMaterialFxIns XEMaterialFxInstance 外部已经创建好的材质效果实例
---@return boolean
function XEMatFxBindingManager:AttachBindingMaterialFxInstance(pComponent, key, pMaterialFxIns) end


---@public 解除指定组件绑定的材质效果实例，并销毁置空
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param key  XEMatFxBindingManager::MaterialFxInsMapping 材质参数键
---@return boolean
function XEMatFxBindingManager:DetachBindingMaterialFxInstance(pComponent, key) end


---@public 解除指定材质效果实例并销毁
---@param pMaterialFxInstance  XEMaterialFxInstance 实例对象
---@return boolean
function XEMatFxBindingManager:DetachBindingMaterialFxInstance(pMaterialFxInstance) end


---@public 由材质效果文件路径创建材质效果实例
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param key  XEMatFxBindingManager::MaterialFxInsMapping 材质参数键
---@param pAssetPath string 材质效果文件资源路径,pathwillbefixed.
---@return boolean
function XEMatFxBindingManager:AttachBindingMaterialFxAsset(pComponent, key, pAssetPath) end


---@public 检查是否已经存在绑定材质实例
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param key  XEMatFxBindingManager::MaterialFxInsMapping 材质参数键
---@return boolean 是否存在
function XEMatFxBindingManager:HasMaterialFxNode(pComponent, key) end


---@public 释放绑定的ActorComponent中的所有材质参数对象
---@param pActorComponent XEActorComponent
---@return boolean
function XEMatFxBindingManager:Release(pActorComponent) end


---@public 更新材质参数实例对象
---@param pComponent XEActorComponent 组件对象，支持的对象类型：ModelComponet相关
---@param fDel number 每帧更新的时间间隔
---@return void
function XEMatFxBindingManager:Tick(pComponent, fDel) end


