---@class XEMatFxDistributionParameterInstance : XEUserNodeInstance
XEMatFxDistributionParameterInstance = {}


---@public XEMatFxDistributionParameterInstance_new00
---@param pNodeTl XEMatFxDistributionParameter
---@return XEMatFxDistributionParameterInstance
function XEMatFxDistributionParameterInstance:new(pNodeTl) end


---@type number @enum MatFxState
XEMatFxDistributionParameterInstance.MFX_STATE_READY = 0


---@type number @enum MatFxState
XEMatFxDistributionParameterInstance.MFX_STATE_PLAYING = 0


---@type number @enum MatFxState
XEMatFxDistributionParameterInstance.MFX_STATE_PLAYED = 0


---@public 清除分布曲线
---@return void
function XEMatFxDistributionParameterInstance:ClearDistribution() end


---@public 获取该实例对应的模板
---@return XEMatFxDistributionParameter
function XEMatFxDistributionParameterInstance:GetMatCurveParameterTemplate() end


---@public 获取关联材质特效参数节点对象
---@return XEMaterialFxInstance
function XEMatFxDistributionParameterInstance:GetMatFxInstance() end


---@public 获取分布指针
---@return userdata
function XEMatFxDistributionParameterInstance:GetDistribution() end


---@public 设置分布指针
---@param pDistribution XRawDistributionBase
---@return void
function XEMatFxDistributionParameterInstance:SetDistribution(pDistribution) end


---@public 如果是Float类型，返回Float分布指针，否则返回NULL
---@return XRawDistributionFloat
function XEMatFxDistributionParameterInstance:GetRawDistributionFloat() end


---@public 如果是Vector类型，返回Vector分布指针，否则返回NULL
---@return XRawDistributionBase
function XEMatFxDistributionParameterInstance:GetRawDistributionVector() end


---@public 如果是Vector3类型，返回Vector3分布指针，否则返回NULL
---@return XRawDistributionVector
function XEMatFxDistributionParameterInstance:GetRawDistributionVector3() end


---@public 如果是Vector4类型，返回Vector4分布指针，否则返回NULL
---@return XRawDistributionVector4
function XEMatFxDistributionParameterInstance:GetRawDistributionVector4() end


---@public 获取FloatConstant分布指针，类型不匹配返回NULL
---@return XDistributionFloatConstant
function XEMatFxDistributionParameterInstance:GetDistributionFloatConstant() end


---@public 获取FloatUniform分布指针，类型不匹配返回NULL
---@return XDistributionFloatUniform
function XEMatFxDistributionParameterInstance:GetDistributionFloatUniform() end


---@public 获取FloatConstantCurve曲线指针，类型不匹配返回NULL
---@return XDistributionFloatConstantCurve
function XEMatFxDistributionParameterInstance:GetDistributionFloatConstantCurve() end


---@public 获取FloatUniformCurve曲线指针，类型不匹配返回NULL
---@return XDistributionFloatUniformCurve
function XEMatFxDistributionParameterInstance:GetDistributionFloatUniformCurve() end


---@public 获取VectorConstant分布指针，类型不匹配返回NULL
---@return XDistributionVectorConstant
function XEMatFxDistributionParameterInstance:GetDistributionVectorConstant() end


---@public 获取VectorUniform分布指针，类型不匹配返回NULL
---@return XDistributionVectorUniform
function XEMatFxDistributionParameterInstance:GetDistributionVectorUniform() end


---@public 获取VectorConstantCurve曲线指针，类型不匹配返回NULL
---@return XDistributionVectorConstantCurve
function XEMatFxDistributionParameterInstance:GetDistributionVectorConstantCurve() end


---@public 获取VectorUniformCurve曲线指针，类型不匹配返回NULL
---@return XDistributionVectorUniformCurve
function XEMatFxDistributionParameterInstance:GetDistributionVectorUniformCurve() end


---@public 获取VectorConstant分布指针，类型不匹配返回NULL
---@return XDistributionVector4Constant
function XEMatFxDistributionParameterInstance:GetDistributionVector4Constant() end


---@public 获取VectorUniform分布指针，类型不匹配返回NULL
---@return XDistributionVector4Uniform
function XEMatFxDistributionParameterInstance:GetDistributionVector4Uniform() end


---@public 获取VectorConstantCurve曲线指针，类型不匹配返回NULL
---@return XDistributionVector4ConstantCurve
function XEMatFxDistributionParameterInstance:GetDistributionVector4ConstantCurve() end


---@public 获取VectorUniformCurve曲线指针，类型不匹配返回NULL
---@return XDistributionVector4UniformCurve
function XEMatFxDistributionParameterInstance:GetDistributionVector4UniformCurve() end


---@public 从资源文件中加载分布数据
---@return boolean 是否加载成功
function XEMatFxDistributionParameterInstance:LoadDistributionFromFile() end


---@public 是否含有点
---@return boolean 是否含有
function XEMatFxDistributionParameterInstance:HasPoints() end


---@public 判定关联的材质参数是否为Color参数
---@param pColorGet XVECTOR4 如果想要同时获取作为Color参数的值，请传入一个XVECTOR4的地址
---@return boolean 是否为颜色参数
function XEMatFxDistributionParameterInstance:IsColor(pColorGet) end


---@public 重置状态
---@return void
function XEMatFxDistributionParameterInstance:ResetState() end


---@public 获取材质状态
---@return number
function XEMatFxDistributionParameterInstance:GetState() end


---@public 根据输入获取曲线上对应返回值
---@param fInVal number 输入值
---@return XEVariant 输出值
function XEMatFxDistributionParameterInstance:Eval(fInVal) end


---@public 获取底层材质实例指针
---@return IXMaterialInstance
function XEMatFxDistributionParameterInstance:GetMaterialInstance() end


---@public 设置底层材质实例指针
---@param pMatIns IXMaterialInstance
---@return void
function XEMatFxDistributionParameterInstance:SetMaterialInstance(pMatIns) end


