---@class XEPatchGraph : XEObjectCommonReceiver
XEPatchGraph = {}


---@type number @enum Type
XEPatchGraph.Graph = 0


---@type number @enum Type
XEPatchGraph.Subgraph = 0


---@type number @enum Type
XEPatchGraph.Function = 0


---@type number @enum Type
XEPatchGraph.Interface = 0


---@type number @enum Type
XEPatchGraph.Macro = 0


---@type number @enum Type
XEPatchGraph.MAX = 0


---@public XEPatchGraph_GetGraphType00
---@param eType number
---@return string
function XEPatchGraph:GetGraphType(eType) end


---@public XEPatchGraph_GetGraphType01
---@param strType string
---@return number
function XEPatchGraph:GetGraphType(strType) end


---@public Add a node to the graph, node's reference will be +1
---@param pNodeToAdd XEPatchGraphNode
---@param bSendNotify boolean
---@return void
function XEPatchGraph:AddNode(pNodeToAdd, bSendNotify) end


---@public Get all children graphs in the specified graph
---@param eType number
---@return XEPatchGraph[]
---@return void
function XEPatchGraph:GetAllChildrenGraphs(eType) end


---@public Create the schema associated with this graph
---@param strSchamaTypeName string
---@return XEPGraphSchema
function XEPatchGraph:CreateSchema(strSchamaTypeName) end


---@public Create node by type
---@param strTypeName string typeofthenode
---@param szNodeTitle string titleofthenode,ifNULL,titlewillbeassignanautoonelike"Node_eeaafccef"
---@param bAddToGraph boolean whetheraddtothegraph,
---@return XEPatchGraphNode
function XEPatchGraph:CreateGraphNode(strTypeName, szNodeTitle, bAddToGraph) end


---@public Get the schema associated with this graph
---@return XEPGraphSchema
function XEPatchGraph:GetSchema() end


---@public XEPatchGraph_GetLevel00
---@return XELevel
function XEPatchGraph:GetLevel() end


---@public XEPatchGraph_GetWorld00
---@return XEWorld
function XEPatchGraph:GetWorld() end


---@public Remove a node from this graph, node's reference will be -1, if reach 0, will delete from memory
---@param pNodeToRemove XEPatchGraphNode
---@return boolean Trueifthenodehasbeenremovedfromthegraph
function XEPatchGraph:RemoveNode(pNodeToRemove) end


---@public 上游->下游的连接顺序解出图节点的连接依赖， 如果节点并排，则按引脚的添加次序排列
---@param eDrivenType number
---@return XEPatchGraphNode[]
function XEPatchGraph:ResolveConnectStreamNodes(eDrivenType) end


---@public 获取排序节点：滤镜节点在前，数据节点在后
---@param arrNodes XEPatchGraphNode[]
---@return void
function XEPatchGraph:SortNodes(arrNodes) end


---@public Find a node By its id
---@param nId number
---@param bIncludeSubGraph boolean
---@return XEPatchGraphNode
function XEPatchGraph:FindNodeById(nId, bIncludeSubGraph) end


---@public Find nodes
---@param szNodeTypeName string Typeofthenode,ifNULL,willnotcheckthetype
---@param szNodeTitleName string title-nameofthenode,ifNULL,willnotcheckthetype
---@param bIncludeSubGraph boolean whetherfindnodesinsub-graphsaswell.
---@return XEPatchGraphNode[] mayreturnmulti
function XEPatchGraph:FindNodes(szNodeTypeName, szNodeTitleName, bIncludeSubGraph) end


---@public XEPatchGraph_FindNodes01
---@param aNodeTypes string[]
---@param bIncludeSubGraph boolean
---@return XEPatchGraphNode[]
function XEPatchGraph:FindNodes(aNodeTypes, bIncludeSubGraph) end


---@public XEPatchGraph_HasNode00
---@param pNode XEPatchGraphNode
---@return boolean
function XEPatchGraph:HasNode(pNode) end


---@public check if the graph is empty
---@return boolean
function XEPatchGraph:IsEmptyGraph() end


---@public 获取当前图对应的资产文件(.rtg)路径
---@return string
function XEPatchGraph:GetAssetPath() end


---@public 将当前图的直接结点转移到目标图，当前图的结点列表将清空
---@param pOtherGraph XEPatchGraph
---@return boolean
function XEPatchGraph:MoveNodesToGraph(pOtherGraph) end


---@public 在子图列表中查找
---@param nGraphId number
---@return XEPatchGraph[]
---@return void
function XEPatchGraph:FindSubGraph(nGraphId) end


---@public 在子图列表中查找关联资产的图
---@param szAssetPath string
---@param eType number
---@return XEPatchGraph[]
---@return void
function XEPatchGraph:FindSubGraph(szAssetPath, eType) end


---@public 获取图实例所属的节点
---@param pGraph XEPatchGraph
---@return XEPatchGraphNode
function XEPatchGraph:GetSubGraphNode(pGraph) end


---@public XEPatchGraph_IsDeleted00
---@return boolean
function XEPatchGraph:IsDeleted() end


---@public XEPatchGraph_SetDeleted00
---@param bDeleted boolean
---@return void
function XEPatchGraph:SetDeleted(bDeleted) end


---@public XEPatchGraph_SetOwnerMgr00
---@param pMgr XEPatchGraphManager
---@return void
function XEPatchGraph:SetOwnerMgr(pMgr) end


---@public XEPatchGraph_GetOwnerMgr00
---@return XEPatchGraphManager
function XEPatchGraph:GetOwnerMgr() end


---@public if set, will be compile once in the tick function
---@return void
function XEPatchGraph:SetPeningStartRun() end


---@public XEPatchGraph_IsPeningStartRun00
---@return boolean
function XEPatchGraph:IsPeningStartRun() end


---@public XEPatchGraph_IsModified00
---@return boolean
function XEPatchGraph:IsModified() end


---@public XEPatchGraph_SetModified00
---@param bModified boolean
---@return void
function XEPatchGraph:SetModified(bModified) end


