---@class XEPatchGraphPin : XClass
XEPatchGraphPin = {}


---@public XEPatchGraphPin_new00
---@return XEPatchGraphPin
function XEPatchGraphPin:new() end


---@public XEPatchGraphPin_new01
---@param pInOwningNode XEPatchGraphNode
---@param nPinGuid number
---@return XEPatchGraphPin
function XEPatchGraphPin:new(pInOwningNode, nPinGuid) end


---@public XEPatchGraphPin_Modify00
---@return void
function XEPatchGraphPin:Modify() end


---@public XEPatchGraphPin_BreakAllPinLinks00
---@param bNotifyNodes boolean
---@return void
function XEPatchGraphPin:BreakAllPinLinks(bNotifyNodes) end


---@public XEPatchGraphPin_BreakLinkTo00
---@param pToPin XEPatchGraphPin
---@return void
function XEPatchGraphPin:BreakLinkTo(pToPin) end


---@public XEPatchGraphPin_SetName00
---@param strPinName string
---@return void
function XEPatchGraphPin:SetName(strPinName) end


---@public XEPatchGraphPin_GetName00
---@return string
function XEPatchGraphPin:GetName() end


---@public XEPatchGraphPin_SetFriendlyName00
---@param strPinFriendlyName string
---@return void
function XEPatchGraphPin:SetFriendlyName(strPinFriendlyName) end


---@public XEPatchGraphPin_GetFriendlyName00
---@return string
function XEPatchGraphPin:GetFriendlyName() end


---@public XEPatchGraphPin_SetToolTip00
---@param strPinToolTip string
---@return void
function XEPatchGraphPin:SetToolTip(strPinToolTip) end


---@public XEPatchGraphPin_GetToolTip00
---@return string
function XEPatchGraphPin:GetToolTip() end


---@public XEPatchGraphPin_GetOwningNode00
---@return XEPatchGraphNode
function XEPatchGraphPin:GetOwningNode() end


---@public XEPatchGraphPin_WasTrashed00
---@return boolean
function XEPatchGraphPin:WasTrashed() end


---@public XEPatchGraphPin_IsHidden00
---@return boolean
function XEPatchGraphPin:IsHidden() end


---@public XEPatchGraphPin_SetHidden00
---@param bIsHidden boolean
---@return void
function XEPatchGraphPin:SetHidden(bIsHidden) end


---@public XEPatchGraphPin_GetDirection00
---@return number
function XEPatchGraphPin:GetDirection() end


---@public XEPatchGraphPin_GetDrivenType00
---@return number
function XEPatchGraphPin:GetDrivenType() end


---@public XEPatchGraphPin_GetId00
---@return number
function XEPatchGraphPin:GetId() end


---@public XEPatchGraphPin_GetType00
---@return XEPGraphPinType
function XEPatchGraphPin:GetType() end


---@public XEPatchGraphPin_IsParamDriven00
---@return boolean
function XEPatchGraphPin:IsParamDriven() end


---@public XEPatchGraphPin_IsFlowDriven00
---@return boolean
function XEPatchGraphPin:IsFlowDriven() end


---@public XEPatchGraphPin_GetSchema00
---@return  XEPGraphSchema
function XEPatchGraphPin:GetSchema() end


---@public According to the type of the pins, and one is the type of input while the other is the type of output
---@param pToPin  XEPatchGraphPin thepinthatlinkto
---@param bCheckNodeLinkStatus boolean iftrue,willbecheckthepin-linkstatusinthenodes,whichwillalsodeterminethelink-ablestatusfortheresult.
---@return boolean
function XEPatchGraphPin:CanMakeLinkTo(pToPin, bCheckNodeLinkStatus) end


---@public Make link to the other pin
---注意：在此不会判定能否建立引脚关联，请在MakeLinkTo之前进行Pin类型的关联判定
---@param pToPin XEPatchGraphPin
---@return void
function XEPatchGraphPin:MakeLinkTo(pToPin) end


---@public get all the pins with the input direction that accept this as an output pin
---这个Pin本身是个输出pin，通过这个函数来获取另一端的所有引脚（必定是输入引脚）
---@return XEPatchGraphPin[]
function XEPatchGraphPin:GetAllInputLinkToPins() end


---@public get all the pins with the output direction that accept this as an input pin
---这个Pin本身是个输入pin，通过这个函数来获取另一端的所有引脚（必定是输出引脚）
---@return XEPatchGraphPin[]
function XEPatchGraphPin:GetAllOutputLinkToPins() end


---@public get all the pins
---@return XEPatchGraphPin[]
function XEPatchGraphPin:GetAllLinkToPins() end


---@public 判断当前pin是否与给定pin有连接
---@param pCheckPin XEPatchGraphPin
---@return boolean
function XEPatchGraphPin:IsLinkToPin(pCheckPin) end


---@public XEPatchGraphPin_SetOwningNode00
---@param pNewOwningNode XEPatchGraphNode
---@return void
function XEPatchGraphPin:SetOwningNode(pNewOwningNode) end


---@public Creates a new pin. Should be called from the OwningNode so it can be immediately added to the Pins array.
---@param pInOwningNode XEPatchGraphNode
---@return XEPatchGraphPin
function XEPatchGraphPin:CreatePin(pInOwningNode) end


---@public Find a pin by its id in a graph
---@param pGraph XEPatchGraph
---@param nId number
---@return XEPatchGraphPin
function XEPatchGraphPin:FindPinByIdInGraph(pGraph, nId) end


---@public Set accept node's type
---@param strPinAcceptNodeType cppstring
---@return void
function XEPatchGraphPin:SetPinAcceptNodeType(strPinAcceptNodeType) end


---@public Get the source of the non-knot owning nodes, multi input-nodes support
---@return XEPatchGraphNode[]
---@return number
function XEPatchGraphPin:GetNoneKnotSourceOwningNodes() end


---@public Get the target of the non-knot owning nodes, multi output-nodes support
---@return XEPatchGraphNode[]
---@return number
function XEPatchGraphPin:GetNoneKnotTargetOwningNodes() end


---@public Get the source of the non-knot owning Links, multi input-links support
---@return XEPatchGraphPin[]
---@return number
function XEPatchGraphPin:GetNoneKnotSourceOwningPins() end


---@public Get the target of the non-knot owning Links, multi output-Links support
---@return XEPatchGraphPin[]
---@return number
function XEPatchGraphPin:GetNoneKnotTargetOwningPins() end


---@public XEPatchGraphPin_GetLinktoPinsNum00
---@return number
function XEPatchGraphPin:GetLinktoPinsNum() end


