---物理骨骼的根节点模板类
---XEPhysicsSkeletalRoot:代表一个phy 资源，引擎底层中，phy资源路径和IXSkeletalPhysicsRes是一一对应的。
---因此不管几个XEPhysicsSkeletalRoot，只要加载的phy资源路径一致，则所有XEPhysicsSkeletalRoot共用同一个IXSkeletalPhysicsRes。
---//一个模型可能加载了多个phy资源，但同时起作用的有且仅有一个phy（也就是XEPhysicsSkeletalRoot指针）
---@class XEPhysicsSkeletalRoot : XEUserNode
XEPhysicsSkeletalRoot = {}


---@public XEPhysicsSkeletalRoot_new00
---@return XEPhysicsSkeletalRoot
function XEPhysicsSkeletalRoot:new() end


---@public 获取当骨骼的资源地址
---@return string 骨骼的资源地址
function XEPhysicsSkeletalRoot:GetSkeAssetPath() end


---@public 获取绑定的物理文件资源地址
---@return string 物理文件资源地址
function XEPhysicsSkeletalRoot:GetPhyAssetPath() end


---@public 为骨骼加载物理文件
---@param szPhyResPath string 物理文件资源地址
---@param szSkePath string
---@return boolean
function XEPhysicsSkeletalRoot:LoadSkeletalPhyAsset(szPhyResPath, szSkePath) end


---@public 获取骨骼对应的引擎中物理资源指针
---@return IXSkeletalPhysicsRes 引擎中物理资源指针
function XEPhysicsSkeletalRoot:GetXSkeletalPhysicsRes() end


---@public 返回是否有了改动
---@return boolean 是否有改动
function XEPhysicsSkeletalRoot:GetIsModify() end


---@public 设置是否有改动
---@param bIsModify boolean
---@return void
function XEPhysicsSkeletalRoot:SetIsModify(bIsModify) end


---@public 引擎物理资源管理器保存对应的物理资源
---@return boolean
function XEPhysicsSkeletalRoot:Save() end


---@public 在骨骼中创建刚体
---@param szBoneName string
---@return boolean 是否创建成功
function XEPhysicsSkeletalRoot:CreateSkeletalBodyInPhysicsWorld(szBoneName) end


---@public 在两个骨骼之间创建关节
---@param szBone1Name string
---@param szBone2Name string
---@return boolean 是否创建成功
function XEPhysicsSkeletalRoot:CreateConstraintInPhysicsWorld(szBone1Name, szBone2Name) end


---@public 移除带有刚体属性的骨骼刚体
---@param pBodyTemp XEPhysicsSkeletalBody
---@return void
function XEPhysicsSkeletalRoot:RemovePhysicsSkeletalBodyFromPhysicsWorld(pBodyTemp) end


---@public 移除两个骨骼所关联的关节
---@param szBone1Name string
---@param szBone2Name string
---@return void
function XEPhysicsSkeletalRoot:RemoveConstraintFromPhysicsWorld(szBone1Name, szBone2Name) end


---@public 创建刚体节点
---@param szBoneName string
---@return XEPhysicsSkeletalBody 是否创建成功
function XEPhysicsSkeletalRoot:CreatePhysicsSkeletalBodyNode(szBoneName) end


---@public 创建关节节点
---@param szBone2Name string
---@param szBone1Name string
---@return XEPhysicsConstraint 创建的关节指针
function XEPhysicsSkeletalRoot:CreateConstraintNode(szBone2Name, szBone1Name) end


---@public 移除节点的模板
---@param pNode XEUserNode
---@param bIncludeChild boolean
---@param bReleaseMemory boolean
---@param bReleaseNodes boolean
---@return void
function XEPhysicsSkeletalRoot:RemoveNodeTempate(pNode, bIncludeChild, bReleaseMemory, bReleaseNodes) end


