---@class XEPrefab : XEUserNode
XEPrefab = {}


---@public XEPrefab_new00
---@return XEPrefab
function XEPrefab:new() end


---@type number @enum EPrefabType 常规Prefab
XEPrefab.EPT_REGULAER = 0


---@type number @enum EPrefabType 变体Prefab
XEPrefab.EPT_VARIANT = 0


---@public 初始化Prefab文件（.prefab）
---@param strAssetPath string Prefab文件路径
---@return void
function XEPrefab:Initialize(strAssetPath) end


---@public 获取Prefab文件路径
---@return string
function XEPrefab:GetAssetPath() end


---@public 更新Prefab文件路径
---@param strAssetPath string
---@return void
function XEPrefab:UpdateAssetPath(strAssetPath) end


---@public 设置当前绑定的文件是否被改变
---@param bSet boolean
---@return void
function XEPrefab:SetModified(bSet) end


---@public 判断当前绑定的文件是否被改变
---@return boolean
function XEPrefab:IsModified() end


---@public 获取Prefab类型
---@return number
function XEPrefab:GetPrefabType() end


---@public 设置Prefab类型
---@param eType number
---@return void
function XEPrefab:SetPrefabType(eType) end


---@public 获取Prefab文件中记录的Actor/Prefab节点数据
---@return string[]
function XEPrefab:GetParamContent() end


---@public 根据Actor列表更新Prefab文件中记录的Actor/Prefab节点数据
---@param arrActor XEActor[]
---@param pRootActor XEActor
---@return void
function XEPrefab:UpdateParamContent(arrActor, pRootActor) end


---@public XEPrefab_UpdateParamContent01
---@param pPrefabIns XEPrefabInstance
---@return void
function XEPrefab:UpdateParamContent(pPrefabIns) end


---@public XEPrefab_GetActorDeserializeString00
---@param pActor XEActor
---@param bRootActor boolean
---@return string
function XEPrefab:GetActorDeserializeString(pActor, bRootActor) end


