---XEPrefabInstance
---XEPrefabInstance 是Actor容器，内部维护一组具有父子关系的Actor组成的列表。
---@class XEPrefabInstance : XEUserNodeInstance
XEPrefabInstance = {}


---@public XEPrefabInstance_new00
---@param pNodeTl XEPrefab
---@return XEPrefabInstance
function XEPrefabInstance:new(pNodeTl) end


---@type number @enum EPrefabHolderType
XEPrefabInstance.EPHT_ACTOR = 0


---@type number @enum EPrefabHolderType
XEPrefabInstance.EPHT_PREFAB_INS = 0


---@public 获取所属关卡
---@return XELevel
function XEPrefabInstance:GetOwnerLevel() end


---@public 获取模板指针
---@return XEPrefab
function XEPrefabInstance:GetPrefabTemplate() end


---@public 获取根Actor
---@return XEActor
function XEPrefabInstance:GetRootActor() end


---@public XEPrefabInstance_GetRootActor01
---@return XEActor
function XEPrefabInstance:GetRootActor() end


---@public 设置根Actor
---@param pActor XEActor
---@return void
function XEPrefabInstance:AcceptRootActor(pActor) end


---@public XEPrefabInstance_GetAttachComponent00
---@return XEActorComponent
function XEPrefabInstance:GetAttachComponent() end


---@public XEPrefabInstance_SetAttachComponent00
---@param pComponnet XEActorComponent
---@return void
function XEPrefabInstance:SetAttachComponent(pComponnet) end


---@public 设置删除状态
---@param bDelete boolean 是否删除
---@return void
function XEPrefabInstance:SetDeleted(bDelete) end


---@public 设置隐藏状态
---@param bHide boolean 是否隐藏
---@return void
function XEPrefabInstance:SetHidden(bHide) end


---@public 设置当前Actor是否在世界运行态时隐藏
---@param bHide boolean
---@return void
function XEPrefabInstance:SetHiddenInGame(bHide) end


---@public 创建并反序列化Prefab资产中的Actor
---@return void
function XEPrefabInstance:CreateActorFromAsset() end


---@public 将当前实例管理的所有Actor移动到指定容器,并将当前Actor列表清空
---@param pOtherContanier XEActorContainer 指定的容器
---@return void
function XEPrefabInstance:MoveActorsToOtherContainer(pOtherContanier) end


---@public 将非Prefab反序列化出来的Actor添加进m_aNewActor列表
---@param pActor XEActor 待添加的Actor
---@return void
function XEPrefabInstance:AddActorToDynamicActorList(pActor) end


---@public 获取非Prefab反序列化的Actor列表
---@return XEActor[]
function XEPrefabInstance:GetDynamicAddActorList() end


---@public 清空非Prefab反序列化的Actor列表
---@return void
function XEPrefabInstance:ClearDynamicAddActorList() end


---@public 根据Prefab实例获取其叶子Prefab的根Actor
---@param pPrefabIns XEPrefabInstance 指定的Prefab实例指针
---@return XEActor 叶子Prefab实例的根Actor（RootActor）
function XEPrefabInstance:GetLeafRootActorFromPrefabInstance(pPrefabIns) end


---@public 获取指定Actor的最顶层Prefab实例
---则会一直查找每一级PrefabActor所属的Prefab实例；
---@param pActor XEActor 指定Actor
---@return XEPrefabInstance pActor所属的最顶层的Prefab实例，即祖先Prefab实例
function XEPrefabInstance:GetFirstParentPrefabInstance(pActor) end


---@public 根据Prefab类型获取其叶子Prefab的根Actor
---@return XEActor
function XEPrefabInstance:GetRootActorByPrefabType() end


---@public 添加相对于基Prefab增加的Actor
---@param pActor XEActor
---@return void
function XEPrefabInstance:AddActorForVariant(pActor) end


---@public 移除相对于基Prefab增加的Actor
---@param pActor XEActor
---@return void
function XEPrefabInstance:RemoveForVariant(pActor) end


---@public 获取相对于基Prefab增加的Actor列表
---@return XEActor[]
function XEPrefabInstance:GetActorsForVariant() end


---@public 清空相对于基Prefab增加的Actor列表
---@return void
function XEPrefabInstance:ClearActorsForVariant() end


