---@class XETransform : XMemBase
XETransform = {}


---@public XETransform_new00
---@return XETransform
function XETransform:new() end


---@public XETransform_new01
---@param mat4 XMATRIX4
---@return XETransform
function XETransform:new(mat4) end


---@public 设置旋转变换的欧拉角。
---@param fPitch number 绕X轴旋转的角（右方向，俯仰角）
---@param fYaw number 绕Y轴旋转的角（上方向，偏航角）
---@param fRoll number 绕Z轴旋转的角（前方向，滚转角）
---@return void
function XETransform:SetRotateEuler(fPitch, fYaw, fRoll) end


---@public 获取旋转变换的欧拉角
---@return number
---@return number
---@return number
---@return void
function XETransform:GetRotateEuler() end


---@public 获取旋转变换的欧拉角
---@return number
function XETransform:GetEulerPitch() end


---@public 获取旋转变换的欧拉角
---@return number
function XETransform:GetEulerYaw() end


---@public 获取旋转变换的欧拉角
---@return number
function XETransform:GetEulerRoll() end


---@public 设置Transform的旋转数据（四元数）
---@param quat XQUATERNION 旋转数据（四元数）
---@return void
function XETransform:SetQuaternion(quat) end


---@public 获取Transform的旋转数据（四元数）
---@return XQUATERNION 旋转数据（四元数）
function XETransform:GetQuaternion() end


---@public 设置前方向和上方向
---@param vDir XVECTOR3 前方向方向向量
---@param vUp XVECTOR3 上方向方向向量
---@return void
function XETransform:SetDirAndUp(vDir, vUp) end


---@public 获取前方向和上方向
---@return XVECTOR3
---@return XVECTOR3
---@return void
function XETransform:GetDirAndUp() end


---@public 设置位置
---@param fX number 位置的x分量
---@param fY number 位置的y分量
---@param fZ number 位置的z分量
---@return void
function XETransform:SetLocation(fX, fY, fZ) end


---@public 设置位置
---@param vLocation XVECTOR3 位置坐标
---@return void
function XETransform:SetLocation(vLocation) end


---@public 获取位置
---@return XVECTOR3 位置坐标
function XETransform:GetLocation() end


---@public 设置缩放
---@param fX number 缩放的x分量
---@param fY number 缩放的y分量
---@param fZ number 缩放的z分量
---@return void
function XETransform:SetScale(fX, fY, fZ) end


---@public 设置缩放
---@param vScale XVECTOR3 缩放数据
---@return void
function XETransform:SetScale(vScale) end


---@public 获取缩放
---@return XVECTOR3 Transform中的缩放信息
function XETransform:GetScale() end


---@public 获取Transform矩阵
---@return XMATRIX4 Transform矩阵
function XETransform:GetTransform() end


---@public 设置Transform矩阵
---@param mt4 XMATRIX4 Transform矩阵
---@return void
function XETransform:SetFromMatrix4(mt4) end


---@public 打印当前变换信息
---@return void
function XETransform:LogInfo() end


