---@class XETriggerData
XETriggerData = {}


---@public XETriggerData_new00
---@return XETriggerData
function XETriggerData:new() end


---@public XETriggerData_new01
---@param _nTriggerState number
---@param _eEventType number
---@param _eventData  XEVariant
---@param _strSender string
---@param _strExecutable string
---@param _fDelay number
---@param _bTriggerRepeat boolean
---@return XETriggerData
function XETriggerData:new(_nTriggerState, _eEventType, _eventData, _strSender, _strExecutable, _fDelay, _bTriggerRepeat) end


---@type number The state when event is executing, eg. overlap begin/stay/end.
XETriggerData.nTriggerState = 0


---@type number specific event type
XETriggerData.eEventType = 0


---@type XEVariant the data that event needs.
XETriggerData.eventData = {}


---@type string sender actor name, may be empty according to specific event.
XETriggerData.strSender = ''


---@type string executor actor name, may be empty according to specific event.
XETriggerData.strExecutable = ''


---@type number delay time in ms.
XETriggerData.fDelayTime = 0


---@type boolean
XETriggerData.bFirstExec = false


---@type boolean can repeat trigger or not.
XETriggerData.bTriggerRepeat = false


---@type number
XETriggerData.nAddIndex = 0


---@type number @enum TriggerState
Triger_None = 0


---@type number @enum TriggerState
Triger_Overlap_Begin = 0


---@type number @enum TriggerState
Trigger_Overlap_Stay = 0


---@type number @enum TriggerState
Trigger_Overlap_End = 0


---@type number @enum TriggerOverlapCheckType
TriggerOverlapCheck_AABB = 0


---@type number @enum TriggerOverlapCheckType
TriggerOverlapCheck_Pos = 0


