---@class XEUserNode : XETreeNode
XEUserNode = {}


---@public XEUserNode_new00
---@return XEUserNode
function XEUserNode:new() end


---@public 创建节点实例
---@return XEUserNodeInstance 节点实例指针
function XEUserNode:SpawnNodeInstance() end


---@public 创建节点实例
---@param szInsTypeName string
---@return XEUserNodeInstance 节点实例指针
function XEUserNode:SpawnNodeInstance(szInsTypeName) end


---@public 在和父节点分离前，做一些事情，比如存储数据，以用来后续恢复
---@return void
function XEUserNode:BeforeRemoveFromParent() end


---@public 在添加到父节点后，做一些事情，用于后续恢复
---@return void
function XEUserNode:AfterAddToParent() end


---@public 设置节点名称
---@param strName string 节点名称
---@param bSameNameLimit boolean 是否限制一个节点树上的节点不能重名，默认为xtrue，xtrue:不能重名，xfalse:可以重名
---@return boolean 是否成功（如果限制不能重名，那么遇到已有的名字，就会返回xfalse）
function XEUserNode:SetNodeName(strName, bSameNameLimit) end


---@public 查找子节点
---@param strName string 查找的节点名称
---@param strType string 节点类型名
---@return XEUserNode 查找到的节点指针
function XEUserNode:FindChildNode(strName, strType) end


---@public 查找子节点
---@param strName string 查找的节点名称
---@return XEUserNode 查找到的节点指针
function XEUserNode:FindChildNode(strName) end


---@public 判断是否有某个子节点
---@param strName string 查找的节点名称
---@param bRecursion boolean 是否递归遍历节点树
---@return boolean 是否找到
function XEUserNode:HasChild(strName, bRecursion) end


---@public 判断是否有某个子节点
---@param pNode  XEUserNode 查找的节点指针
---@param bRecursion boolean 是否递归遍历节点树
---@return boolean 是否找到
function XEUserNode:HasChild(pNode, bRecursion) end


---@public 获取节点类型名，不带祖先节点类型名
---@return string
function XEUserNode:GetTypeNameWithoutAncestorPrefix() end


---@public 取到一个节点有效名字
---@param pNodeContext XEUserNode 上下文节点指针
---@param bBaseOnUseNodeContext boolean 是否需要使用上下文节点名称作base名，默认为xfalse
---@return string 取到的有效名称
function XEUserNode:GetValidNodeName(pNodeContext, bBaseOnUseNodeContext) end


---@public 设置当前节点是否包含子节点
---@param bInclude boolean 是否包含子节点
---@return void
function XEUserNode:SetIncludeChildren(bInclude) end


---@public 判断当前节点是否包含子节点
---@return boolean 是否包含子节点
function XEUserNode:IsIncludeChildren() end


---@public 获取当前节点绑定的脚本路径
---@return string 绑定的脚本路径
function XEUserNode:GetBindingScriptAssetPath() end


---@public 设置当前节点绑定的脚本路径
---@param strAssetPath string 绑定的脚本路径
---@return void
function XEUserNode:SetBindingScriptAssetPath(strAssetPath) end


---@public 把给定节点类型名字去掉祖先名称
---@param szTypeNameWithPrefix string [in][out]节点类型名称
---@return void
function XEUserNode:RemoveAncestorPrefix(szTypeNameWithPrefix) end


---@type string 节点过滤路径
XEUserNode.m_szFilterPath = ''


---@class XEUserNodeInstance : XEUserNode
XEUserNodeInstance = {}


---@type number @enum eRunEffectState
XEUserNodeInstance.RES_NOT_RUN = 0


---@type number @enum eRunEffectState
XEUserNodeInstance.RES_RESTORE_READY = 0


---@type number @enum eRunEffectState
XEUserNodeInstance.RES_RESTORE_FINISH = 0


---@type number @enum eRunEffectState
XEUserNodeInstance.RES_KEEP = 0


---@public XEUserNodeInstance_SetTime00
---@param nMicrosecond number
---@return void
function XEUserNodeInstance:SetTime(nMicrosecond) end


---@public XEUserNodeInstance_BackupFxBefore00
---@return void
function XEUserNodeInstance:BackupFxBefore() end


---@public XEUserNodeInstance_RestoreFxBefore00
---@return void
function XEUserNodeInstance:RestoreFxBefore() end


---@public XEUserNodeInstance_UpdateSocket00
---@param pMatrixAbsolute XMATRIX4
---@return void
function XEUserNodeInstance:UpdateSocket(pMatrixAbsolute) end


---@public XEUserNodeInstance_OnSocketTick00
---@param pBindSocketIns XEBindSocketInstance
---@param matWorld XMATRIX4
---@return void
function XEUserNodeInstance:OnSocketTick(pBindSocketIns, matWorld) end


---@public XEUserNodeInstance_OnSocketRender00
---@param pBindSocketIns XEBindSocketInstance
---@return void
function XEUserNodeInstance:OnSocketRender(pBindSocketIns) end


---@public XEUserNodeInstance_SpawnChildrenNodeInstance00
---@param pNodeMgr XETreeNode::Manager
---@return number
function XEUserNodeInstance:SpawnChildrenNodeInstance(pNodeMgr) end


---@public XEUserNodeInstance_Apply00
---@return void
function XEUserNodeInstance:Apply() end


---@public XEUserNodeInstance_SetRunEfectState00
---@param mode number
---@return void
function XEUserNodeInstance:SetRunEfectState(mode) end


---@public XEUserNodeInstance_GetRunEffectState00
---@return number
function XEUserNodeInstance:GetRunEffectState() end


