---@class XEWorldParam : XOwnerRecorder
XEWorldParam = {}


---@public XEWorldParam_new00
---@return XEWorldParam
function XEWorldParam:new() end


---@public 初始化
---@param pWorld XEWorld
---@return void
function XEWorldParam:Init(pWorld) end


---@public 释放资源
---@return void
function XEWorldParam:Release() end


---@public 设置世界属性是否有改变
---@param bIsModified boolean
---@return void
function XEWorldParam:SetWorldPropertyModified(bIsModified) end


---@public 判断世界属性是否有改变
---@return boolean
function XEWorldParam:IsWorldPropertyModified() end


---@public 设置是否开启世界重力
---@param bIsOverrideGravity boolean
---@return void
function XEWorldParam:SetOverrideGravity(bIsOverrideGravity) end


---@public 判断是否开启世界重力
---@return boolean
function XEWorldParam:IsOverrideGravity() end


---@public 设置世界重力值
---@param vGravity XVECTOR3
---@return void
function XEWorldParam:SetGlobalGravity(vGravity) end


---@public 获取世界重力值，默认是（0，-9.81，0）
---@return XVECTOR3
function XEWorldParam:GetGlobalGravity() end


---@public 设置风速大小
---@param fSpeed number
---@return void
function XEWorldParam:SetWindSpeed(fSpeed) end


---@public 获取风速大小
---@return number
function XEWorldParam:GetWindSpeed() end


---@public 设置风的方向
---@param vDir XVECTOR3
---@return void
function XEWorldParam:SetWindDir(vDir) end


---@public 获取风的方向
---@return XVECTOR3
function XEWorldParam:GetWindDir() end


---@public 设置是否渲染模型的胶囊体/刚体示意图
---@param bDrawPhysics boolean
---@return void
function XEWorldParam:SetDrawPhysics(bDrawPhysics) end


---@public 判断是否渲染模型的胶囊体/刚体示意图
---@return boolean
function XEWorldParam:IsDrawPhysics() end


---@public 设置是否启用QIT（顺序无关的半透明渲染）
---@param bQIT boolean
---@return void
function XEWorldParam:SetQIT(bQIT) end


---@public 判断是否启用QIT（顺序无关的半透明渲染）
---@return boolean
function XEWorldParam:IsQIT() end


---@public 设置QIT 层数，默认是3
---@param nNum number
---@return void
function XEWorldParam:SetQITLayerNum(nNum) end


---@public 获取QIT 层数，默认是3
---@return number
function XEWorldParam:GetQITLayerNum() end


---@public 设置是否开启阴影
---@param bShadow boolean
---@return void
function XEWorldParam:SetShadow(bShadow) end


---@public 判断是否开启阴影
---@return boolean
function XEWorldParam:IsShadow() end


---@public 设置Shadow map分辨率，默认是1024
---@param nData number
---@return void
function XEWorldParam:SetShadowMapResolution(nData) end


---@public 获取Shadow map分辨率
---@return number
function XEWorldParam:GetShadowMapResolution() end


---@public 设置阴影距离
---@param nDistance number
---@return void
function XEWorldParam:SetShadowDistance(nDistance) end


---@public 获取阴影距离
---@return number
function XEWorldParam:GetShadowDistance() end


---@public 设置影子级联数目，默认是2
---@param nNum number
---@return void
function XEWorldParam:SetShadowCascadeNum(nNum) end


---@public 获取影子级联数目
---@return number
function XEWorldParam:GetShadowCascadeNum() end


---@public 设置阴影深度偏移
---@param fDepth number
---@return void
function XEWorldParam:SetShadowDepth(fDepth) end


---@public 获取阴影深度偏移
---@return number
function XEWorldParam:GetShadowDepth() end


---@public 设置软阴影量值
---@param fSoftness number
---@return void
function XEWorldParam:SetShadowSoftness(fSoftness) end


---@public 获取软阴影量值
---@return number
function XEWorldParam:GetShadowSoftness() end


---@public 设置阴影强度
---@param fStrength number
---@return void
function XEWorldParam:SetShadowStrength(fStrength) end


---@public 获取阴影强度
---@return number
function XEWorldParam:GetShadowStrength() end


---@public 设置阴影颜色
---@param vValue XVECTOR4
---@return void
function XEWorldParam:SetShadowColor(vValue) end


---@public 获取阴影颜色
---@return XVECTOR4
function XEWorldParam:GetShadowColor() end


---@public 设置是否开启后处理
---@param bPostprocess boolean
---@return void
function XEWorldParam:SetPostprocessEnable(bPostprocess) end


---@public 获取是否开启后处理
---@return boolean
function XEWorldParam:GetPostprocessEnable() end


---@public 设置是否开启FXAA
---@param bFXAA boolean
---@return void
function XEWorldParam:SetFXAAEnable(bFXAA) end


---@public 获取是否开启FXAA
---@return boolean
function XEWorldParam:GetFXAAEnable() end


---@public 设置是否开启Bloom功能
---@param bBoolm boolean
---@return void
function XEWorldParam:SetBloomEnable(bBoolm) end


---@public 获取是否开启Bloom功能
---@return boolean
function XEWorldParam:GetBloomEnable() end


---@public 设置Bloom颜色阈值，取值范围0-1，超过改颜色后有Bloom效果，RGB通道单独计算
---@param fvalue number
---@return void
function XEWorldParam:SetBloomColorThreshold(fvalue) end


---@public 获取Bloom颜色阈值
---@return number
function XEWorldParam:GetBloomColorThreshold() end


---@public 设置Bloom采样半径， 取值1或2，表示Bloom的范围，1的范围比2小，但2面对细长物体时可能会有重影
---@param fvalue number
---@return void
function XEWorldParam:SetBloomSamplerScale(fvalue) end


---@public 获取Bloom采样半径
---@return number
function XEWorldParam:GetBloomSamplerScale() end


---@public 设置是否启用雾效功能
---@param bFog boolean
---@return void
function XEWorldParam:SetFogEnable(bFog) end


---@public 获取是否启用雾效功能
---@return boolean
function XEWorldParam:GetFogEnable() end


---@public 设置雾效开始距离，单位m，据摄像机多少距离之后有雾
---@param fvalue number
---@return void
function XEWorldParam:SetFogStart(fvalue) end


---@public 获取雾效开始距离，单位m
---@return number
function XEWorldParam:GetFogStart() end


---@public 设置雾效结束距离，单位m，据摄像机多少距离之后全是雾的颜色
---@param fvalue number
---@return void
function XEWorldParam:SetFogEnd(fvalue) end


---@public 获取雾效结束距离，单位m
---@return number
function XEWorldParam:GetFogEnd() end


---@public 设置雾全局密度，密度越大，雾越浓
---@param fvalue number
---@return void
function XEWorldParam:SetFogDensity(fvalue) end


---@public 获取雾全局密度
---@return number
function XEWorldParam:GetFogDensity() end


---@public 设置顶层渐变起始角度
---@param fvalue number 起始角度，默认为0
---@return void
function XEWorldParam:SetFogGradientAngleUpper(fvalue) end


---@public 获取顶层渐变起始角度
---@return number 起始角度
function XEWorldParam:GetFogGradientAngleUpper() end


---@public 设置底层渐变起始角度
---@param fvalue number 起始角度，默认为0
---@return void
function XEWorldParam:SetFogGradientAngleLower(fvalue) end


---@public 获取底层渐变起始角度
---@return number 起始角度
function XEWorldParam:GetFogGradientAngleLower() end


---@public 设置上层雾颜色，即头顶的雾色
---@param vValue XVECTOR4
---@return void
function XEWorldParam:SetFogColorUpper(vValue) end


---@public 获取上层雾颜色
---@return XVECTOR4
function XEWorldParam:GetFogColorUpper() end


---@public 设置下层雾颜色，即脚底的雾色
---@param vValue XVECTOR4
---@return void
function XEWorldParam:SetFogColorLower(vValue) end


---@public 获取下层雾颜色
---@return XVECTOR4
function XEWorldParam:GetFogColorLower() end


---@public 设置World Tick Substepping是否启用
---@param bEnable boolean 是否启用
---@return void
function XEWorldParam:SetWorldTickSubsteppingEnable(bEnable) end


---@public 判断World Tick Substepping是否启用
---@return boolean 是否启用
function XEWorldParam:IsWorldTickSubsteppingEnable() end


---@public 设置一次World Tick Substepping允许花费的最长时间
---@param fMaxStepTime number 最长时间（ms）
---@return void
function XEWorldParam:SetWorldTickMaxStepTime(fMaxStepTime) end


---@public 获取一次World Tick Substepping允许花费的最长时间
---@return number 最长时间（ms）
function XEWorldParam:GetWorldTickmaxStepTime() end


---@public 设置形变动画法线计算方法 OIRIGINAL/NLERP/RECALCULATE,默认是RECALCULATE
---@param eType number
---@return void
function XEWorldParam:SetBlendShapeNormalMethod(eType) end


---@public 获取形变动画法线计算方法
---@return number
function XEWorldParam:GetBlendShapeNormalMethod() end


---@public 获取是否有绑定脚本
---@return string
function XEWorldParam:GetBindingScriptAssetPath() end


---@public 获取绑定对象类型
---@return string
function XEWorldParam:GetBindingScriptObjectType() end


---@public XEWorldParam_SetBindingScriptObjectType00
---@param type string
---@return void
function XEWorldParam:SetBindingScriptObjectType(type) end


---@public 设置特效是否合批渲染
---@param bEnable boolean
---@return void
function XEWorldParam:SetFxBatchEnabled(bEnable) end


---@public 获取特效是否合批渲染
---@return boolean
function XEWorldParam:IsFxBatchEnabled() end


---@public 设置同一层级的粒子是否强制合批
---@param bForce boolean
---@return void
function XEWorldParam:SetFxBatchInSameLayer(bForce) end


---@public 获取同一层级的粒子是否强制合批
---@return boolean
function XEWorldParam:IsFxBatchInSameLayer() end


---@public 设置合批的最大顶点数
---@param nMaxNum number
---@return void
function XEWorldParam:SetFxMaxBatchedVertexNum(nMaxNum) end


---@public 获取合批的最大顶点数
---@return number
function XEWorldParam:GetFxMaxBatchedVertexNum() end


---@public 为画刷设置路径点之间的最小间隔,默认是0.1
---@param fDistance number
---@return void
function XEWorldParam:SetBrushPathPointMinDistance(fDistance) end


---@public 获取画刷上路径点之间的最小间隔,默认是0.1
---@return number
function XEWorldParam:GetBrushPathPointMinDistance() end


---@public 为画刷设置纹理的重复距离
---@param fDistance number
---@return void
function XEWorldParam:SetBrushTexcoordLoopDistance(fDistance) end


---@public 获取画刷 纹理的重复距离,默认是1.0，最小是0.1
---@return number
function XEWorldParam:GetBrushTexcoordLoopDistance() end


