---@class XE2DSeqFramePlayListController : XEAnimControllerBase
XE2DSeqFramePlayListController = {}


---@public XE2DSeqFramePlayListController_new00
---@param pComponent XEImgSequenceFrameComponent
---@return XE2DSeqFramePlayListController
function XE2DSeqFramePlayListController:new(pComponent) end


---@public 获取依赖的组件
---@return XEImgSequenceFrameComponent
function XE2DSeqFramePlayListController:GetComponentOwner() end


---@public 添加一个序列帧动画
---注意：此函数为了兼容sence低于1.5版本，大于等于1.5版本的函数，应该使用BuildSeqFrameAnimIns函数
---@param aFrameListInfo  XEMagicCoreUtility::XE2DSequenceFrameListInfo
---@return XE2DSequenceFrameAnimController
function XE2DSeqFramePlayListController:Add2DSequenceFrameAnim(aFrameListInfo) end


---@public 释放所有序列帧实例
---@return void
function XE2DSeqFramePlayListController:RemoveAllSeqFrameAnim() end


---@public 释放指定索引的序列帧实例
---@param nIndex number 序列帧动画资源索引
---@return boolean 是否移除成功(xbool)
function XE2DSeqFramePlayListController:RemoveSeqFrameAnim(nIndex) end


---@public 获取某个序列帧动画的控制器
---@param nIndex number 指定序列帧动画索引
---@return XE2DSequenceFrameAnimController 序列帧动画控制器
function XE2DSeqFramePlayListController:Get2DSeqFrameAnimController(nIndex) end


---@public 获取当前播放的序列帧动画控制器
---@return XE2DSequenceFrameAnimController
function XE2DSeqFramePlayListController:GetCurrentSeqFrameAnimController() end


---@public 设置当前播放的序列帧动画控制器
---@param nIndex number
---@return void
function XE2DSeqFramePlayListController:SetCurrentController(nIndex) end


---@public 设置是否仅仅更新当前序列帧动画
---@param bTickOnlyCurrentController boolean
---@return void
function XE2DSeqFramePlayListController:SetOnlyTickCurrentController(bTickOnlyCurrentController) end


---@public 设置延迟时间
---@param fDelayTime number
---@return void
function XE2DSeqFramePlayListController:SetDelayTime(fDelayTime) end


---@public 获取延迟时间
---@return number
function XE2DSeqFramePlayListController:GetDelayTime() end


---@public 获取所有序列帧动画控制器,scene 1.5 版本新增
---@return XE2DSequenceFrameAnimController[]
function XE2DSeqFramePlayListController:GetAllSequenceFrameAnimController() end


---@public 获取所有序列帧实例对象
---@return XEMagicSeqFrameInstance[]
function XE2DSeqFramePlayListController:GetSeqFrameAnimInstanceList() end


---@public 加载seq2D资源文件，并创建序列帧实例对象
---@param strAssetPath string 相对于xscene文件的路径
---@return XEMagicSeqFrameInstance 序列帧实例
function XE2DSeqFramePlayListController:BuildSeqFrameAnimIns(strAssetPath) end


---@public 释放序列帧实例对象
---@param pIns XEMagicSeqFrameInstance 待释放的序列帧实例对象
---@return boolean 资源是否释放成功
function XE2DSeqFramePlayListController:DestorySeqFrameAnimIns(pIns) end


---@public XE2DSeqFramePlayListController_GetSeqFrameIns00
---@param nIndex number
---@return XEMagicSeqFrameInstance
function XE2DSeqFramePlayListController:GetSeqFrameIns(nIndex) end


