---@class XE2DSequenceFrameAnimController : XEAnimControllerBase
XE2DSequenceFrameAnimController = {}


---@public XE2DSequenceFrameAnimController_new00
---@return XE2DSequenceFrameAnimController
function XE2DSequenceFrameAnimController:new() end


---@type number @enum ETextureOperator
XE2DSequenceFrameAnimController.ETO_NONE = 0


---@type number @enum ETextureOperator
XE2DSequenceFrameAnimController.ETO_REMOVE = 0


---@type number @enum ETextureOperator
XE2DSequenceFrameAnimController.ETO_MODIFY = 0


---@public 获取序列帧帧数
---@return number
function XE2DSequenceFrameAnimController:GetFrameCount() end


---@public 设置运行时延迟时间
---@param fDelayTime number
---@return void
function XE2DSequenceFrameAnimController:SetDelayTime(fDelayTime) end


---@public 获取运行时延迟时间
---@return number
function XE2DSequenceFrameAnimController:GetDelayTime() end


---@public 获取当前播放到的纹理索引
---@return number
function XE2DSequenceFrameAnimController:GetCurIndex() end


---@public 获取纹理操作类型，暂时编辑器使用
---@return number
function XE2DSequenceFrameAnimController:GetTextureOperator() end


---@public 设置序列帧信息
---@param loopInfo  XEMagicCoreUtility::XESequenceFrameLoopInfo
---@return void
function XE2DSequenceFrameAnimController:SetFrameLoopInfo(loopInfo) end


---@public 获取序列帧信息
---@return XEMagicCoreUtility__XESequenceFrameLoopInfo
function XE2DSequenceFrameAnimController:GetFrameLoopInfo() end


---@public 设置当前控制器绑定的序列帧实例对象
---@param pInstance XEMagicSeqFrameInstance
---@return void
function XE2DSequenceFrameAnimController:SetSequenceFrameInstance(pInstance) end


---@public 获取当前控制器绑定的序列帧实例对象
---@return XEMagicSeqFrameInstance
function XE2DSequenceFrameAnimController:GetSequenceFrameInstance() end


---@public 获取从第一帧到最后一帧的播放次数
---@return number
function XE2DSequenceFrameAnimController:GetPlayNum() end


---@public 设置从第一帧到最后一帧的播放次数
---@param nPlayNum number
---@return void
function XE2DSequenceFrameAnimController:SetPlayNum(nPlayNum) end


---@public 获取序列帧信息
---@return  XEMagicCoreUtility__XE2DSequenceFrameListInfo
function XE2DSequenceFrameAnimController:GetTextureFrameListInfo() end


---@public 获取序列帧纹理类型
---@return number
function XE2DSequenceFrameAnimController:GetTextureAssetType() end


---@public 从序列帧中移除指定索引的纹理
---@param nIndex number
---@return void
function XE2DSequenceFrameAnimController:RemoveTexture(nIndex) end


---@public 设置某帧纹理的列数,用于几行几列切分
---@param nTextureIndex number
---@param nCol number
---@return void
function XE2DSequenceFrameAnimController:SetColForTexture(nTextureIndex, nCol) end


---@public 获取某帧纹理的列数
---@param nTextureIndex number
---@return number
function XE2DSequenceFrameAnimController:GetColForTexture(nTextureIndex) end


---@public 设置某帧纹理的行数,用于几行几列切分
---@param nTextureIndex number
---@param nRow number
---@return void
function XE2DSequenceFrameAnimController:SetRowForTexture(nTextureIndex, nRow) end


---@public 获取某帧纹理的行数
---@param nTextureIndex number
---@return number
function XE2DSequenceFrameAnimController:GetRowForTexture(nTextureIndex) end


---@public 获取序列帧某一帧的纹理信息
---@return XEMagicCoreUtility__XERenderTextureInfo
---@return boolean
function XE2DSequenceFrameAnimController:GetCurrentTextureInfoByIndex() end


---@public 设置序列帧信息
---@param strProjectDir string 工程路径
---@param aInfos  XEMagicCoreUtility::XE2DSequenceFrameListInfo 序列帧信息
---@return boolean
function XE2DSequenceFrameAnimController:SetTextureFrameListInfo(strProjectDir, aInfos) end


---@public 是否允许tick
---@return boolean
function XE2DSequenceFrameAnimController:IsCanTick() end


---@public 移除所有纹理
---@return void
function XE2DSequenceFrameAnimController:RemoveAllTextures() end


---@public 是否允许循环播放
---@return boolean
function XE2DSequenceFrameAnimController:IsValidLoop() end


---@public 是否允许延迟
---@return boolean
function XE2DSequenceFrameAnimController:IsDelayTime() end


---@public 从第一帧到最后一帧的播放次数是否已经达到设置的数量
---@return boolean
function XE2DSequenceFrameAnimController:IsPlayFinishFromStartToEnd() end


---@public XE2DSequenceFrameAnimController_SetTextureOperator00
---@param eType number
---@return void
function XE2DSequenceFrameAnimController:SetTextureOperator(eType) end


