---@class XEImg2DFaceKeyPointSequenceFrameComponent : XEImgSequenceFrameComponent
XEImg2DFaceKeyPointSequenceFrameComponent = {}


---@public XEImg2DFaceKeyPointSequenceFrameComponent_GetTypeName00
---@return string
function XEImg2DFaceKeyPointSequenceFrameComponent:GetTypeName() end


---@type string @readonly 
XEImg2DFaceKeyPointSequenceFrameComponent.COMPONENT_TYPENAME = ''


---@public XEImg2DFaceKeyPointSequenceFrameComponent_new00
---@return XEImg2DFaceKeyPointSequenceFrameComponent
function XEImg2DFaceKeyPointSequenceFrameComponent:new() end


---@public 获取所依赖的所有人脸关键点索引
---@return number[]
function XEImg2DFaceKeyPointSequenceFrameComponent:GetAllKeyPointIndex() end


---@public 添加一个关键点索引
---@param nFaceKeyPointIndex number 表示人脸关键点索引
---@return void
function XEImg2DFaceKeyPointSequenceFrameComponent:AddKeyPointIndex(nFaceKeyPointIndex) end


---@public 更新索引列表中的关键点索引
---@param nIndex number 表示当前组件依赖的人脸关键点列表中的索引
---@param nFaceKeyPointIndex number 表示人脸关键点索引
---@return void
function XEImg2DFaceKeyPointSequenceFrameComponent:SetKeyPointIndex(nIndex, nFaceKeyPointIndex) end


---@public 从索引列表中移除某个人脸关键点索引
---@param nIndex number
---@return boolean 是否移除成功
function XEImg2DFaceKeyPointSequenceFrameComponent:RemoveKeyPointIndex(nIndex) end


---@public 获取依赖的所有人脸关键点的平均坐标
---@return XVECTOR2 依赖的所有人脸关键点的平均坐标（像素坐标）
function XEImg2DFaceKeyPointSequenceFrameComponent:GetPivotPoint() end


---@public 获取当前关键点的缩放因子（脸远近）
---@return XVECTOR3 缩放值
function XEImg2DFaceKeyPointSequenceFrameComponent:GetFaceScaleFactor() end


---@public 设置是否显示最终参考的人脸关键点
---@param bShow boolean
---@return void
function XEImg2DFaceKeyPointSequenceFrameComponent:SetShowPivotPoint(bShow) end


---@public 是否显示最终参考的人脸关键点
---@return boolean
function XEImg2DFaceKeyPointSequenceFrameComponent:IsShowPivotPoint() end


---@public XEImg2DFaceKeyPointSequenceFrameComponent_GetFaceKeyPointInfo00
---@return XEFaceKeyPointInstance
function XEImg2DFaceKeyPointSequenceFrameComponent:GetFaceKeyPointInfo() end


---@public 设置是否外部更新transform
---@param bOuterUpdate boolean
---@return void
function XEImg2DFaceKeyPointSequenceFrameComponent:SetOuterUpdateTransform(bOuterUpdate) end


---@public XEImg2DFaceKeyPointSequenceFrameComponent_IsOuterUpdateTransform00
---@return boolean
function XEImg2DFaceKeyPointSequenceFrameComponent:IsOuterUpdateTransform() end


---@public 获取最终的序列帧中心点的像素坐标
---@return XVECTOR2
function XEImg2DFaceKeyPointSequenceFrameComponent:GetRealPixelCenter() end


---@public 更新序列帧transform
---@param vWorldLoc XVECTOR3 世界空间坐标
---@param quat XQUATERNION
---@param vScaleFactor XVECTOR2 缩放因子，用于运行时改变序列帧尺寸的大小（DesignSize）
---@return void
function XEImg2DFaceKeyPointSequenceFrameComponent:UpdateFrameTransform(vWorldLoc, quat, vScaleFactor) end


