---@class XEImgSequenceFrameComponent : XEImgSegmentationComponent
XEImgSequenceFrameComponent = {}


---@public XEImgSequenceFrameComponent_GetTypeName00
---@return string
function XEImgSequenceFrameComponent:GetTypeName() end


---@type string @readonly 
XEImgSequenceFrameComponent.COMPONENT_TYPENAME = ''


---@public XEImgSequenceFrameComponent_new00
---@return XEImgSequenceFrameComponent
function XEImgSequenceFrameComponent:new() end


---@public 分配一个序列帧动画列表控制器，如果已存在，不重复创建
---@return XE2DSeqFramePlayListController
function XEImgSequenceFrameComponent:Assign2DSequenceFrameAnimPlayListController() end


---@public 获取序列帧动画列表控制器
---@return XE2DSeqFramePlayListController
function XEImgSequenceFrameComponent:Get2DSequenceFrameAnimPlayListController() end


---@public 释放序列帧动画列表控制器
---@return void
function XEImgSequenceFrameComponent:Remove2DSequenceFrameAnimPlayListController() end


---@public 更新序列帧播放状态
---@param nTime number
---@return void
function XEImgSequenceFrameComponent:SetTime(nTime) end


---@public 获取当前播放的纹理对象
---@return IXTexture
function XEImgSequenceFrameComponent:GetCurrentRenderTexture() end


---@public 获取某个顶点的屏幕坐标
---@param nVertexIndex number
---@return XVECTOR2
function XEImgSequenceFrameComponent:GetVertexScreenPos(nVertexIndex) end


---@type number @enum EScaleMode 固定序列帧尺寸不变
XEImgSequenceFrameComponent.EFM_FIXED_SIZE = 0


---@type number @enum EScaleMode 锁定序列帧的宽高比，边界留边
XEImgSequenceFrameComponent.EFM_FIXED_SIZE_RATIO_FIT = 0


---@type number @enum EScaleMode 保持序列帧尺寸与父窗口的尺寸的比值不变，即序列帧的宽（高）与父窗口的宽（高）比值固定
XEImgSequenceFrameComponent.EFM_STRETCH = 0


---@type number @enum EScaleMode
XEImgSequenceFrameComponent.EFM_NUM = 0


---@type number @enum EFlipMode 不翻转
XEImgSequenceFrameComponent.EFM_NONE = 0


---@type number @enum EFlipMode 左右翻转
XEImgSequenceFrameComponent.EFM_LEFT_RIGHT_FLIP = 0


---@type number @enum EFlipMode 上下翻转
XEImgSequenceFrameComponent.EFM_TOP_BOTTOM_FLIP = 0


---@public XEImgSequenceFrameComponent_SetScaleMode00
---@param eScaleMode number
---@return void
function XEImgSequenceFrameComponent:SetScaleMode(eScaleMode) end


---@public XEImgSequenceFrameComponent_GetScaleMode00
---@return number
function XEImgSequenceFrameComponent:GetScaleMode() end


---@public XEImgSequenceFrameComponent_GetAllScaleModeName00
---@return string[]
function XEImgSequenceFrameComponent:GetAllScaleModeName() end


---@public XEImgSequenceFrameComponent_GetScaleModeByName00
---@param strScaleModeName string
---@return number
function XEImgSequenceFrameComponent:GetScaleModeByName(strScaleModeName) end


---@public 获取设计当前序列帧时的设备分辨率
---@return XVECTOR2
function XEImgSequenceFrameComponent:GetRefDeviceWidthHeight() end


---@public 设置旋转角度
---@param fRotate number
---@return void
function XEImgSequenceFrameComponent:SetRotateScreen(fRotate) end


---@public 获取旋转角度
---@return number
function XEImgSequenceFrameComponent:GetRotateScreen() end


---@public 设置缩放值
---@param vScale XVECTOR2
---@return void
function XEImgSequenceFrameComponent:SetScaleScreen(vScale) end


---@public 获取缩放值
---@return XVECTOR2
function XEImgSequenceFrameComponent:GetScaleScreen() end


---@public 设置屏幕空间坐标（屏幕中心点为坐标原点，水平向右为正，竖直向上为正）
---@param vLoc XVECTOR2
---@return void
function XEImgSequenceFrameComponent:SetLocationScreen(vLoc) end


---@public 获取屏幕空间坐标
---@return XVECTOR2
function XEImgSequenceFrameComponent:GetLocationScreen() end


---@public 设置序列帧尺寸
---@param vSize XVECTOR2
---@return void
function XEImgSequenceFrameComponent:SetDesignSize(vSize) end


---@public 获取序列帧尺寸
---@return XVECTOR2
function XEImgSequenceFrameComponent:GetDesignSize() end


---@public 更新序列帧状态，包括位置、大小和朝向
---@return void
function XEImgSequenceFrameComponent:UpdateScreenShape() end


---@public 更新依赖的设备宽高
---@param fWidth number
---@param fHeight number
---@return void
function XEImgSequenceFrameComponent:UpdateDeviceWidthHeight(fWidth, fHeight) end


---@public 是否支持序列帧动画文件（Scene版本低于1.5时，不支持此文件）
---@return boolean
function XEImgSequenceFrameComponent:IsSupportSequenceFrameAnimFile() end


---@public 设置翻转模式
---@param nFlipMode number
---@return void
function XEImgSequenceFrameComponent:SetFlipMode(nFlipMode) end


---@public 获取翻转模式
---@return number
function XEImgSequenceFrameComponent:GetFlipMode() end


---@public 是否左右翻转
---@return boolean
function XEImgSequenceFrameComponent:IsLeftRightFlip() end


---@public 是否上下翻转
---@return boolean
function XEImgSequenceFrameComponent:IsTopButtomFlip() end


---@public XEImgSequenceFrameComponent_LoadSequenceFrameAnim00
---@param szAssetPath string
---@return boolean
function XEImgSequenceFrameComponent:LoadSequenceFrameAnim(szAssetPath) end


