---@class XEFilterContainerInstance : XEUserNodeInstance
XEFilterContainerInstance = {}


---@public XEFilterContainerInstance_new00
---@param pNodeTl XEFilterContainer
---@return XEFilterContainerInstance
function XEFilterContainerInstance:new(pNodeTl) end


---@public 获取滤镜容器模板
---@return XEFilterContainer
function XEFilterContainerInstance:GetFilterContainerTemplate() end


---@public 将材质实例的所有参数设置到子节点
---@return void
function XEFilterContainerInstance:PrepareMaterialInstanceParamToSave() end


---@public 设置关联的Actor
---@param pActor XEActor
---@return void
function XEFilterContainerInstance:AcceptHolder(pActor) end


---@public 获取关联的Actor
---@return XEActor
function XEFilterContainerInstance:GetHolder() end


---@public 设置节点管理器关联的关卡
---@param pLevel XELevel
---@return void
function XEFilterContainerInstance:AcceptLevel(pLevel) end


---@public 获取节点管理器关联的关卡
---@return XELevel
function XEFilterContainerInstance:GetLevel() end


---@public 获取节点管理器关联的世界
---@return XEWorld
function XEFilterContainerInstance:GetWorld() end


---@public 获取自定义手动渲染处理器名称
---@return string
function XEFilterContainerInstance:GetCustomGraphName() end


---@public 获取前向滤镜链的头结点
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetPreprocessFilterListNodeHead() end


---@public 获取前向滤镜链的尾结点
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetPreprocessFilterListNodeTail() end


---@public 获取后置滤镜链的头结点
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetPostprocessFilterListNodeHead() end


---@public 获取后置滤镜链的尾结点
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetPostprocessFilterListNodeTail() end


---@public 获取手动(自定义)滤镜链的头结点
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetCustomprocessFilterListNodeHead() end


---@public 获取手动(自定义)滤镜链的尾结点
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetCustomprocessFilterListNodeTail() end


---@public 获取指定滤镜节点所在的滤镜链节点
---@param pNodeIns XEFilterInstance
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:GetFilterListNode(pNodeIns) end


---@public 获取该滤镜链的前处理链节点构建图
---@return XEGraphBuilderProcess
function XEFilterContainerInstance:GetPreprocessGraphBuilder() end


---@public 获取该滤镜链的后处理链节点构建图
---@return XEGraphBuilderProcess
function XEFilterContainerInstance:GetPostprocessGraphBuilder() end


---@public 获取该滤镜链的手动处理链节点构建图
---@return XEGraphBuilderProcess
function XEFilterContainerInstance:GetCustomprocessGraphBuilder() end


---@public 将指定滤镜节点追加到滤镜链的尾部
---@param pNodeIns XEFilterInstance
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:AddToEnd(pNodeIns) end


---@public 将指定滤镜节点追加到滤镜链的头部
---@param pNodeIns XEFilterInstance
---@return XEFilterUtility__InstanceListFilterNode
function XEFilterContainerInstance:AddToFront(pNodeIns) end


---@public 将指定滤镜节点插入到滤镜链中已存在的某个滤镜节点之后
---@param pNodeInsRef XEFilterInstance 表示在滤镜链中已存在的滤镜节点
---@param pNodeInsToInsert XEFilterInstance 表示待插入的滤镜节点
---@return XEFilterUtility__InstanceListFilterNode 滤镜链节点
function XEFilterContainerInstance:InsertAfter(pNodeInsRef, pNodeInsToInsert) end


---@public 将指定滤镜节点插入到滤镜链中已存在的某个滤镜节点之前
---@param pNodeInsRef XEFilterInstance 表示在滤镜链中已存在的滤镜节点
---@param pNodeInsToInsert XEFilterInstance 表示待插入的滤镜节点
---@return XEFilterUtility__InstanceListFilterNode 滤镜链节点
function XEFilterContainerInstance:InsertBefore(pNodeInsRef, pNodeInsToInsert) end


---@public 交换两个指定滤镜节点在滤镜链中的顺序
---@param pNodeIns1 XEFilterInstance 待交换的滤镜节点1
---@param pNodeIns2 XEFilterInstance 待交换的滤镜节点2
---@param bSwapTemplate boolean 是否更新对应模板的顺序
---@return boolean 顺序是否交换成功
function XEFilterContainerInstance:SwapNode(pNodeIns1, pNodeIns2, bSwapTemplate) end


---@public 判断是否允许交换两个指定滤镜节点在滤镜链中的顺序
---@param pNodeIns1 XEFilterInstance 待交换的滤镜节点1
---@param pNodeIns2 XEFilterInstance 待交换的滤镜节点2
---@return boolean 是否允许交换顺序
function XEFilterContainerInstance:CanSwap(pNodeIns1, pNodeIns2) end


---@public 判断在滤镜链中，第一个节点的顺序是否在第二个节点之前
---@param pNodeIns1 XEFilterInstance 第一个滤镜节点
---@param pNodeIns2 XEFilterInstance 第二个滤镜节点
---@return boolean 是否按照从前到后的顺序
function XEFilterContainerInstance:IsClockwise(pNodeIns1, pNodeIns2) end


---@public 从滤镜链上移除指定滤镜节点及滤镜链节点
---@param pNodeIns XEFilterInstance 待移除的滤镜节点
---@param bRemoveTemplate boolean 是否移除滤镜模板
---@param bRefreshGraph boolean
---@return boolean 是否移除成功
function XEFilterContainerInstance:RemoveNode(pNodeIns, bRemoveTemplate, bRefreshGraph) end


---@public 根据滤镜节点树重新构建双向滤镜链表
---@return void
function XEFilterContainerInstance:ReBuildFilterDoubleLinkList() end


---@public 重新构建滤镜节点树
---@param bRebuildTemplate boolean
---@return void
function XEFilterContainerInstance:ReBuildTreeNode(bRebuildTemplate) end


---@public 获取绑定的所有子滤镜节点
---@param nl XETreeNode[]
---@return void
function XEFilterContainerInstance:GetBindNodeIns(nl) end


---@public 使自定义的手动滤镜节点生效
---@return void
function XEFilterContainerInstance:ApplyCustomprocessEffect() end


---@public 每帧Tick前将会自动更新一次启用状态：检测图像前处理流程是否可用
---@return boolean
function XEFilterContainerInstance:IsImgPreProcessEnabled() end


---@public 每帧Tick前将会自动更新一次启用状态：检测图像后处理流程是否可用
---@return boolean
function XEFilterContainerInstance:IsImgPostProcessEnabled() end


---@public 加载滤镜链资源文件并创建滤镜容器(滤镜链)实例指针
---@param pAssetPath string 滤镜资源文件（xfc文件）
---@param pHolder XEActor 关联的Actor
---@return XEFilterContainerInstance 滤镜容器实例(滤镜链)指针
function XEFilterContainerInstance:CreateFilterContainerInsFromAsset(pAssetPath, pHolder) end


---@public 释放滤镜容器实例(滤镜链)指针
---@param pInstanceToDestroy XEFilterContainerInstance 待释放的滤镜容器实例(滤镜链)指针
---@return boolean 是否释放成功
function XEFilterContainerInstance:DestroyFilterContainerInstance(pInstanceToDestroy) end


---@public XEFilterContainerInstance_GetTypeName00
---@return string
function XEFilterContainerInstance:GetTypeName() end


---@type string @readonly 
XEFilterContainerInstance.NODE_TYPENAME = ''


