---本类代表一个具体的滤镜节点
---@class XEFilterInstance : XEUserNodeInstance
XEFilterInstance = {}


---@public XEFilterInstance_new00
---@param pNodeTl XEFilter
---@return XEFilterInstance
function XEFilterInstance:new(pNodeTl) end


---@public XEFilterInstance_GetTypeName00
---@return string
function XEFilterInstance:GetTypeName() end


---@type string @readonly 
XEFilterInstance.NODE_TYPENAME = ''


---@public 获取滤镜节点对应的模板指针
---@return XEFilter
function XEFilterInstance:GetFilterTemplate() end


---@public 获取滤镜链实例指针
---@return XEFilterContainerInstance
function XEFilterInstance:GetFilterContainerInstance() end


---@public 判断当前节点是否是前置滤镜节点
---@return boolean
function XEFilterInstance:IsPreprocessNode() end


---@public 判断当前节点是否是后置滤镜节点
---@return boolean
function XEFilterInstance:IsPostprocessNode() end


---@public 判断当前节点是否是需要手动渲染的自定义滤镜节点
---@return boolean
function XEFilterInstance:IsCustomprocessNode() end


---@public 判断当前节点是否为帧缓存节点
---@return boolean
function XEFilterInstance:IsFrameCacheNode() end


---@public 判断是否为自动缓存节点
---@return boolean
function XEFilterInstance:IsAutoCacheFrameNode() end


---@public 判断是否为手动缓存节点
---@return boolean
function XEFilterInstance:IsManualCacheFrameNode() end


---@public 判断当前节点是否为带材质的用户节点
---@return boolean
function XEFilterInstance:IsMaterialUserNode() end


---@public 重新构建渲染节点
---@return boolean
function XEFilterInstance:RebuildPrimitiveNode() end


---@public 构建材质实例
---@return boolean
function XEFilterInstance:BuildMaterailInstance() end


---@public 获取材质实例
---@return IXMaterialInstance
function XEFilterInstance:GetMaterialInstance() end


---@public 设置渲染节点
---@param pPrimitiveNode XImageEffectNode
---@return void
function XEFilterInstance:AcceptPrimitiveNode(pPrimitiveNode) end


---@public 获取渲染节点
---@return XImageEffectNode
function XEFilterInstance:GetPrimitiveNode() end


---@public 获取作为用户渲染节点，如果类型匹配
---@return XImageEffectNodeUser
function XEFilterInstance:GetPrimitiveUserNode() end


---@public 获取作为缓存帧渲染节点，如果类型匹配
---@return XImageEffectNodeFrameCache
function XEFilterInstance:GetPrimitiveFrameCacheNode() end


---@public 设置当前节点是否起效
---@param bEnabled boolean
---@param bApplyStatus boolean
---@return void
function XEFilterInstance:SetEnabled(bEnabled, bApplyStatus) end


---@public 应用当前节点的禁用/启用设置
---@return void
function XEFilterInstance:ApplyeEnableStatus() end


---@public 当前节点是否起效
---@return boolean
function XEFilterInstance:IsEnabled() end


---@public 当前节点是否被移除
---@return boolean
function XEFilterInstance:IsEnableDelete() end


---@public 设置当前节点是否被移除
---@param bDelete boolean
---@return void
function XEFilterInstance:SetEnableDelete(bDelete) end


---@public 当前节点是否能被渲染
---@return boolean
function XEFilterInstance:IsValidForRender() end


---@public 手动缓存当前帧,如果是缓存帧
---@param szFrameLabel string
---@return boolean
function XEFilterInstance:CacheFrame(szFrameLabel) end


---@public 设置自动缓存帧间隔
---@param nMilliseconds number
---@param bSyncToTemplate boolean
---@return boolean
function XEFilterInstance:SetFrameCacheInterval(nMilliseconds, bSyncToTemplate) end


---@public 设置缓存帧最大帧数
---@param nMaxNum number
---@param bSyncToTemplate boolean
---@return boolean
function XEFilterInstance:SetFrameCacheMaxNum(nMaxNum, bSyncToTemplate) end


---@public 获取该节点是否可接受输入的原始纹理采样
---@return boolean
function XEFilterInstance:IsAcceptOriginInputSampler() end


---@public 设置顶点描述信息
---@param pVertexDesc IXVertexDesc 引擎定义的顶点描述指针
---@param nPassIndex number 表示指定材质通道的索引，默认为-1，表示所有为所有的通道的渲染节点设置相同的顶点描述
---@return void
function XEFilterInstance:SetVertexDesc(pVertexDesc, nPassIndex) end


---@public 设置顶点缓冲数据（包含顶点数据）
---@param pVertexBuffer IXVertexBuffer 引擎定义的顶点缓冲
---@param nPassIndex number 表示指定材质通道的索引，默认为-1，表示所有为所有的通道的渲染节点设置相同的顶点缓冲
---@return void
function XEFilterInstance:SetVertexBuffer(pVertexBuffer, nPassIndex) end


---@public 设置索引缓冲数据
---@param pIndexBuffer IXIndexBuffer 引擎定义的索引缓冲
---@param nPassIndex number 表示指定材质通道的索引，默认为-1，表示所有为所有的通道的渲染节点设置相同的索引缓冲
---@return void
function XEFilterInstance:SetIndexBuffer(pIndexBuffer, nPassIndex) end


---@public 获取指定通道的顶点描述指针
---@param nPassIndex number 表示材质通道索引，默认为0，表示第一个
---@return  IXVertexDesc 顶点描述指针
function XEFilterInstance:GetVertexDesc(nPassIndex) end


---@public 获取顶点缓冲数据
---@param nPassIndex number 表示材质通道索引，默认为0，表示第一个
---@return  IXVertexBuffer 顶点缓冲指针
function XEFilterInstance:GetVertexBuffer(nPassIndex) end


---@public 获取索引缓冲数据
---@param nPassIndex number 表示材质通道索引，默认为0，表示第一个
---@return  IXIndexBuffer 索引缓冲指针
function XEFilterInstance:GetIndexBuffer(nPassIndex) end


---@public 设置是否拷贝原始图像帧的背景区域
---@param bEnabled boolean
---@return void
function XEFilterInstance:SetCopyOriginAsBackgroundEnabled(bEnabled) end


---@public 是否拷贝原始图像帧的背景区域
---@return boolean
function XEFilterInstance:IsCopyOriginAsBackgroundEnabled() end


---@public 设置顶点信息，便于lua端调用
---@param pVariantVertex XEFilterUtility::XEVaraintVertex 封装引擎渲染所需的顶点描述信息、顶点缓冲数据、索引缓冲数据等
---@param nPassIndex number 传递的Pass索引，如果为-1，则传递到全部Pass
---@return boolean 是否设置成功
function XEFilterInstance:SetVertexFromVariantVertex(pVariantVertex, nPassIndex) end


---@public 设置顶点缓冲、索引缓冲等数据
---@return boolean
function XEFilterInstance:ApplyVBOFromSetting() end


---@public 是否检测到人脸
---@return boolean
function XEFilterInstance:IsFaceDetect() end


---@public 获取系统材质参数列表
---@return string[]
function XEFilterInstance:GetSystemMaterialParams() end


---@public 材质输出重采样(降/超)
---@param nPassIndex number pass的索引
---@param vSize XVECTOR2 新的输出纹理大小
---@param tf number
---@param sp number 纹理尺寸的设置策略：SP_Absolute（0,绝对大小）,SP_Relative（1,相对输入纹理大小），SP_Num（使用输入纹理大小），-1（不改变策略）
---@param bRebuildMtIns boolean 是否重新构建材质实例
---@return boolean
function XEFilterInstance:ReSampleOutputTexForPass(nPassIndex, vSize, tf, sp, bRebuildMtIns) end


---@public 更新VB数据
---@param pFaceActor XEFaceTrackerActor
---@return boolean
function XEFilterInstance:UpdateFaceVertexData(pFaceActor) end


