---序列帧模板
---模板中保存的影响控制器的参数，其优先级低于控制器对应的参数.
---模板中的参数用于在Apply函数内创建实例时初始化初始数据使用.
---修改模板参数(控制器有备份的参数)时，不应该影响实例控制器的值.
---@class XEMagicSequenceFrame : XEUserNode
XEMagicSequenceFrame = {}


---@public XEMagicSequenceFrame_new00
---@return XEMagicSequenceFrame
function XEMagicSequenceFrame:new() end


---@public XEMagicSequenceFrame_Initialize00
---@param strAssetPath string
---@return void
function XEMagicSequenceFrame:Initialize(strAssetPath) end


---@public 获取序列帧文件.seq2d路径
---@return string
function XEMagicSequenceFrame:GetAssetPath() end


---@public 设置序列帧文件.seq2d路径
---@param strAssetPath string
---@return void
function XEMagicSequenceFrame:SetAssetPath(strAssetPath) end


---@public 获取序列帧的文件夹路径
---@return string
function XEMagicSequenceFrame:GetContentDirPath() end


---@public 设置序列帧文件路径
---@param strFrameContentDir string
---@return void
function XEMagicSequenceFrame:SetContentDirPath(strFrameContentDir) end


---@public 设置当前模板是否被修改
---@param bSet boolean
---@return void
function XEMagicSequenceFrame:SetModified(bSet) end


---@public 获取当前模板是否被修改
---@return boolean
function XEMagicSequenceFrame:IsModified() end


---@public 设置是否逆序播放
---@param bReverse boolean
---@return void
function XEMagicSequenceFrame:SetReverse(bReverse) end


---@public 是否逆序播放
---@return boolean
function XEMagicSequenceFrame:IsReverse() end


---@public 设置是否相对当前.seq2d文件的目录
---@param bSet boolean
---@return void
function XEMagicSequenceFrame:SetRelativeToCurrentPath(bSet) end


---@public 是否相对当前.seq2d文件的目录
---@return boolean
function XEMagicSequenceFrame:IsRelativeToCurrentPath() end


---@public 设置每秒播放帧数
---@param nFPS number
---@return void
function XEMagicSequenceFrame:SetFPS(nFPS) end


---@public 获取每秒播放帧数
---@return number
function XEMagicSequenceFrame:GetFPS() end


---@public 获取从第一帧纹理的宽度（像素）
---@return number
function XEMagicSequenceFrame:GetFirstTexWidth() end


---@public 设置从第一帧纹理的宽度（像素）
---@param nWidth number
---@return void
function XEMagicSequenceFrame:SetFirstTexWidth(nWidth) end


---@public 获取从第一帧纹理的高度（像素）
---@return number
function XEMagicSequenceFrame:GetFirstTexHeight() end


---@public 设置从第一帧纹理的高度（像素）
---@param nHeight number
---@return void
function XEMagicSequenceFrame:SetFirstTexHeight(nHeight) end


---@public 设置纹理模式
---@param eMode number
---@return void
function XEMagicSequenceFrame:SetLoopMode(eMode) end


---@public 获取纹理模式
---@return number
function XEMagicSequenceFrame:GetLoopMode() end


---@public 设置开始循环帧索引
---@param nStartIndex number
---@return void
function XEMagicSequenceFrame:SetLoopStartIndex(nStartIndex) end


---@public 获取开始循环帧索引
---@return number
function XEMagicSequenceFrame:GetLoopStartIndex() end


---@public 设置结束循环帧索引
---@param nEndIndex number
---@return void
function XEMagicSequenceFrame:SetLoopEndIndex(nEndIndex) end


---@public 获取结束循环帧索引
---@return number
function XEMagicSequenceFrame:GetLoopEndIndex() end


---@public 获取序列帧信息
---@return XEMagicCoreUtility__XESequenceFrameLoopInfo
function XEMagicSequenceFrame:GetFrameLoopInfo() end


---@public 设置从第一帧到最后一帧的播放次数
---@param nPlayNum number
---@return void
function XEMagicSequenceFrame:SetPlayNum(nPlayNum) end


---@public 获取从第一帧到最后一帧的播放次数
---@return number
function XEMagicSequenceFrame:GetPlayNum() end


---@public 获取序列帧纹理信息
---@return  XEMagicCoreUtility__XE2DSequenceFrameListInfo
function XEMagicSequenceFrame:Get2DSequenceFrameListInfo() end


---@public XEMagicSequenceFrame_Set2DSequenceFrameListInfo00
---@param aFrameListInfo  XEMagicCoreUtility::XE2DSequenceFrameListInfo
---@return void
function XEMagicSequenceFrame:Set2DSequenceFrameListInfo(aFrameListInfo) end


---@public 从序列帧中移除指定索引的纹理
---@param nIndex number
---@return void
function XEMagicSequenceFrame:RemoveTexture(nIndex) end


---@public 设置某帧纹理的列数,用于几行几列切分
---@param nTextureIndex number
---@param nCol number
---@return void
function XEMagicSequenceFrame:SetColForTexture(nTextureIndex, nCol) end


---@public 设置某帧纹理的行数,用于几行几列切分
---@param nTextureIndex number
---@param nRow number
---@return void
function XEMagicSequenceFrame:SetRowForTexture(nTextureIndex, nRow) end


---@public 移除所有纹理
---@return void
function XEMagicSequenceFrame:RemoveAllTextures() end


---@public 是否配置纹理
---@return boolean
function XEMagicSequenceFrame:IsFinishLoadingTexture() end


