---@class XEMagicCoreFaceMaskUtility
XEMagicCoreFaceMaskUtility = {}


---@public 人脸关键点转换：将96个关键点转换为104个关键点
---@param aLandmarks96 number[]
---@return number[]
---@return boolean
function XEMagicCoreFaceMaskUtility:FDKExtend96PtLandmarksTo104PtLandmarks(aLandmarks96) end


---@public 获取人脸关键点三角剖分后的关键点索引数组(104点的索引)
---@return number[]
function XEMagicCoreFaceMaskUtility:GetFDKFacialMaskTriangulationIndexes() end


---@public 获取人脸关键点三角剖分后的关键点索引数组(137点的索引)
---@return number[]
function XEMagicCoreFaceMaskUtility:GetFDKFacialMaskTriangulationIndexes_137() end


---@public 获取标准96个人脸关键点对应的UV(x1,x2...y1,y2..)
---@return XVECTOR2[]
function XEMagicCoreFaceMaskUtility:GetStandandFacialMaskUV() end


---@public 获取人脸关键点三角剖分后的关键点索引数组(137点的索引)
---@return XVECTOR2[]
function XEMagicCoreFaceMaskUtility:GetStandandFacialMaskUV_137() end


---@public 获取标准104个人脸关键点对应的UV(x1,y1,x2,y2..)，拍摄器业务直接用的104点的uv，不是根据96点插值得到
---@return XVECTOR2[]
function XEMagicCoreFaceMaskUtility:GetStandandFacialMaskUV_104() end


---@public 从metadata.xml读取UV数据
---@param pUVAssetFullPath string
---@return XVECTOR2[]
---@return boolean
function XEMagicCoreFaceMaskUtility:LoadMetadataFromXml(pUVAssetFullPath) end


---@public XEMagicCoreFaceMaskUtility_SaveMetadataToXml00
---@param pUVAssetFullPath string
---@param aUV XVECTOR2[]
---@return boolean
function XEMagicCoreFaceMaskUtility:SaveMetadataToXml(pUVAssetFullPath, aUV) end


---@public 根据人脸关键点数量获取三角剖分后的顶点索引列表
---@param nPointNum number
---@return number[]
function XEMagicCoreFaceMaskUtility:GetFDKFacialMaskTriangulationIndexesForPointNum(nPointNum) end


---@public 将96点的UV转为104点
---@param vUpdateUV96 XVECTOR2[]
---@param vUpdateUV104 XVECTOR2[]
---@return boolean
function XEMagicCoreFaceMaskUtility:ConvertLandmarkUV96To104(vUpdateUV96, vUpdateUV104) end


---@type number @enum EFacePartType
XEMagicCoreFaceMaskUtility.EFPT_FULL_SCREEN = 0


---@type number @enum EFacePartType
XEMagicCoreFaceMaskUtility.EFPT_FULL_FACE = 0


---@type number @enum EFacePartType
XEMagicCoreFaceMaskUtility.EFPT_CUSTOM = 0


---@type number @enum EFacePartType
XEMagicCoreFaceMaskUtility.EFPT_NUM = 0


---@public XEMagicCoreFaceMaskUtility_GetFacePartTypes00
---@return string[]
function XEMagicCoreFaceMaskUtility:GetFacePartTypes() end


---@public XEMagicCoreFaceMaskUtility_GetFacePartTypeName00
---@param eType number
---@return string
function XEMagicCoreFaceMaskUtility:GetFacePartTypeName(eType) end


---@public XEMagicCoreFaceMaskUtility_GetFacePartType00
---@param strName string
---@return number
function XEMagicCoreFaceMaskUtility:GetFacePartType(strName) end


