---@class XEDecorationEnvBridgeBase
XEDecorationEnvBridgeBase = {}


---@public mmcv-core-detecting enable/disable
---@param bEnable boolean
---@return void
function XEDecorationEnvBridgeBase:OnMMCVDetectEnableChange(bEnable) end


---@public will add or modify the detected face to the face list, you should call this first.
---return ADD_NEW if there isn't the face with the specific index, otherwise return MODIFY_EXIST
---@param nFaceIndex number
---@param faceDesc  XEMagicCore::XEFaceEntity
---@return number
function XEDecorationEnvBridgeBase:OnFaceEntityDetected(nFaceIndex, faceDesc) end


---@public may include index/matrix/landmarks/expression changing, an assemble detector.
---@return void
function XEDecorationEnvBridgeBase:OnFaceEntitiesChangeDetected() end


---@public objects, such as hand-gesture
---@param nObjectIndex number
---@param objDesc  XEMagicCore::XEObjectEntity
---@return number
function XEDecorationEnvBridgeBase:OnObjectEntityDetected(nObjectIndex, objDesc) end


---@public an assemble detector.
---@return void
function XEDecorationEnvBridgeBase:OnObjectEntitiesChangeDetected() end


---@public body
---@param nBodyIndex number
---@param bodyDesc  XEMagicCore::XEBodyEntity
---@return number
function XEDecorationEnvBridgeBase:OnBodyEntityDetected(nBodyIndex, bodyDesc) end


---@public multi bodies
---@return void
function XEDecorationEnvBridgeBase:OnBodyEntitiesChangeDetected() end


---@public hand-gesture with tracking
---@param nHandGestureIndex number
---@param handGestureDesc  XEMagicCore::XEHandGestureEntity
---@return number
function XEDecorationEnvBridgeBase:OnHandGestureEntityDetected(nHandGestureIndex, handGestureDesc) end


---@public an assemble detector.
---@return void
function XEDecorationEnvBridgeBase:OnHandGestureEntitiesChangeDetected() end


---@public expression detect
---@param nFaceIndex number
---@param expressionDesc  XEMagicCore::XEFaceExpressionEntity
---@return number
function XEDecorationEnvBridgeBase:OnFaceExpressionEntityDetected(nFaceIndex, expressionDesc) end


---@public an assemble detector.
---@return void
function XEDecorationEnvBridgeBase:OnFaceExpressionEntitiesChangeDetected() end


---@public imagesegment entity
---@param entity  XEMagicCore::XEImageSegmentEntity
---@return void
function XEDecorationEnvBridgeBase:OnImageSegmentEntityChangeDetected(entity) end


---@public device attitude entity
---@param entity  XEMagicCore::XEAttitudeEntity
---@return void
function XEDecorationEnvBridgeBase:OnDeviceAttitudeEntityChanged(entity) end


---@public device acceleration entity
---@param entity  XEMagicCore::XEAccelerationEntity
---@return void
function XEDecorationEnvBridgeBase:OnDeviceAccelerationEntityChanged(entity) end


---@public expression detect
---@param nResultIndex number
---@param resultEntity  XEMagicCore::XEMNNResultEntity
---@return number
function XEDecorationEnvBridgeBase:OnMNNResultEntityDetected(nResultIndex, resultEntity) end


---@public an assemble detector.
---@return void
function XEDecorationEnvBridgeBase:OnMNNResultEntitiesChangeDetected() end


---@public setup gesture manager
---@return void
function XEDecorationEnvBridgeBase:SetupGestureManger() end


---@public 获取检测到的所有人脸信息列表
---@return XEFaceEntity[]
function XEDecorationEnvBridgeBase:GetFaceList() end


---@public 获取所有手势识别信息列表
---@return XEObjectEntity[]
function XEDecorationEnvBridgeBase:GetObjectList() end


---@public 获取检测到的所有身体关节点信息列表
---@return XEBodyEntity[]
function XEDecorationEnvBridgeBase:GetBodyList() end


---@public 获取检测到的手势信息列表
---@return XEHandGestureEntity[]
function XEDecorationEnvBridgeBase:GetHandGestureList() end


---@public 获取检测到的表情数据信息
---@return XEFaceExpressionEntity[]
function XEDecorationEnvBridgeBase:GetFaceExpressionList() end


---@public 获取检测到的自定义算法数据信息
---@return XEMNNResultEntity[]
function XEDecorationEnvBridgeBase:GetMNNResultEntityList() end


---@public XEDecorationEnvBridgeBase_GetImageSegmentEntity00
---@return XEMagicCore__XEImageSegmentEntity
function XEDecorationEnvBridgeBase:GetImageSegmentEntity() end


---@public XEDecorationEnvBridgeBase_GetAttitudeEntity00
---@return XEMagicCore__XEAttitudeEntity
function XEDecorationEnvBridgeBase:GetAttitudeEntity() end


---@public XEDecorationEnvBridgeBase_GetAccelerationEntity00
---@return XEMagicCore__XEAccelerationEntity
function XEDecorationEnvBridgeBase:GetAccelerationEntity() end


---@public 获取指定索引的人脸锁指针
---@param nFaceIndex number
---@return XThreadMutex
function XEDecorationEnvBridgeBase:GetFaceMutex(nFaceIndex) end


---@public 清空所有人脸数据
---@return void
function XEDecorationEnvBridgeBase:ClearFaceEntities() end


---@public 清空所有表情识别数据
---@return void
function XEDecorationEnvBridgeBase:ClearObjectEntities() end


---@public 清空所有身体关节点数据
---@return void
function XEDecorationEnvBridgeBase:ClearBodyEntities() end


---@public 清空所有手势数据
---@return void
function XEDecorationEnvBridgeBase:ClearHandGestureEntities() end


---@public 清空所有表情数据
---@return void
function XEDecorationEnvBridgeBase:ClearFaceExpressionEntities() end


---@public 设置允许检测的最大人脸数量
---@param nMaxFace number
---@return void
function XEDecorationEnvBridgeBase:ReSetupFaceMutex(nMaxFace) end


---@public 根据landmark计算得到世界空间人脸Transform
---@param aLandmarkTransformed number[]
---@param maCVtModelView XMATRIX4
---@return XMATRIX4
function XEDecorationEnvBridgeBase:GetFaceWorldMatrixWithLandmarks(aLandmarkTransformed, maCVtModelView) end


