---
--- Created by HongjieFu.
--- DateTime: 2019-08-29 18:40
---

---@class XEWorldController
local XEWorldController = {}

---@public 创建一个场景
---@param mSceneID string 场景ID
---@return XEWorldController
function XEWorldController:CreateScene(mSceneID)
end

---@public xes_Scene_IsActorInTheBackOfCamera00
---@param p_director xes__Director
---@param pActor XEActor
---@return boolean
function XEWorldController:IsActorInTheBackOfCamera(p_director, pActor)
end

---@public xes_Scene_IsActorInScreen00
---@param p_director xes__Director
---@param pActor XEActor
---@return boolean
function XEWorldController:IsActorInScreen(p_director, pActor)
end

---@public xes_Scene_GetActorScreenFrame00
---@param m_pDirector xes__Director
---@param pActor XEActor
---@return xes__Rect
function XEWorldController:GetActorScreenFrame(m_pDirector, pActor)
end

---@public xes_Scene_GetActorScreenFrameWithSkeleton00
---@param m_pDirector xes__Director
---@param pActor XEActor
---@return xes__Rect
function XEWorldController:GetActorScreenFrameWithSkeleton(m_pDirector, pActor)
end

---@public xes_Scene_GetActorScreenFrameWithSkeleton01
---@param m_pDirector xes__Director
---@param pActor XEActor
---@param fixScale number
---@return xes__Rect
function XEWorldController:GetActorScreenFrameWithSkeleton(m_pDirector, pActor, fixScale)
end

---@public xes_Scene_GetActorDetectScreenPosition00
---@param m_pDirector xes__Director
---@param pActor XEActor
---@return XVECTOR2
function XEWorldController:GetActorDetectScreenPosition(m_pDirector, pActor)
end

---@public 获取场景ID
---@return string
function XEWorldController:GetSceneID()
end

---@public 获取世界实例
---@return XEWorld
function XEWorldController:GetWorld()
end

---@public 创建2D物理场景
---@param szSceneName string
---@return IX2DPhysicalScene
function XEWorldController:Create2DPhysicalScene(szSceneName)
end

---@public 创建2D物理场景
---@param szSceneName string
---@param vGravity  XVECTOR2
---@return IX2DPhysicalScene
function XEWorldController:Create2DPhysicalScene(szSceneName, vGravity)
end

---onStart 生命周期回调方法 需要复写
function XEWorldController:onStart()
end

---onResume 生命周期回调方法 需要复写
function XEWorldController:onResume()
end

---onPause 生命周期回调方法 需要复写
function XEWorldController:onPause()
end

---onEnd 生命周期回调方法 需要复写
function XEWorldController:onEnd()
end

---onTick 每一帧渲染前的回调
function XEWorldController:onTick(tickTime)
end

-- 旧版本兼容
xe.Scene = XEWorldController
