---引擎手机端扩展模块命名空间
---@class xe
xe = {}

---Handler 常量
xe.Handler = xe.Handler or {}

xe.Handler.ACTOR = 0
xe.Handler.CALL_FUNC = 1
xe.Handler.TOUCHS = 2
xe.Handler.ACCELEROMETER = 3
xe.Handler.SCENE_CALLBACK = 4

xe.Handler.EVENT_ACC = 10
xe.Handler.EVENT_CUSTOM = 11
xe.Handler.EVENT_TOUCH_BEGAN = 12
xe.Handler.EVENT_TOUCH_MOVED = 13
xe.Handler.EVENT_TOUCH_ENDED = 14
xe.Handler.EVENT_TOUCH_CANCELLED = 15
xe.Handler.EVENT_TOUCHES_BEGAN = 16
xe.Handler.EVENT_TOUCHES_MOVED = 17
xe.Handler.EVENT_TOUCHES_ENDED = 18
xe.Handler.EVENT_TOUCHES_CANCELLED = 19
xe.Handler.EVENT_FACE_LOST = 20
xe.Handler.EVENT_FACE_TRACKING = 21
xe.Handler.EVENT_ATTITUDE = 22
xe.Handler.EVENT_ACCELEROMETER = 23
xe.Handler.EVENT_SCHEDULE_CALLBACK = 24
xe.Handler.EVENT_SCRIPTBRIDGE_CALLBACK = 25
xe.Handler.EVENT_HAND_CALLBACK = 33
xe.Handler.EVENT_OBJECT_CALLBACK = 34
xe.Handler.EVENT_BODY_CALLBACK = 35
xe.Handler.EVENT_EXPRESSION_CALLBACK = 36
xe.Handler.EVENT_CUSTOM_BEGAN = 10000
xe.Handler.EVENT_CUSTOM_ENDED = 11000
xe.Handler.EVENT_GESTURE_CLICK = 37
xe.Handler.EVENT_GESTURE_MOVE = 38
xe.Handler.EVENT_GESTURE_MOVE2 = 39
xe.Handler.EVENT_GESTURE_PINCH = 40
xe.Handler.EVENT_GESTURE_ROTATE2 = 41

xe.Handler.XEANIMATIONPLAY_STEPMOVE_CALLNACK = 27
xe.Handler.XEANIMATIONPLAY_PLAYSTATECHANGE_CALLNACK = 28
xe.Handler.XEANIMATIONPLAY_ONETIMEFINISHED_CALLNACK = 29
xe.Handler.ARSESSIONSTATUS_ADD = 30
xe.Handler.ARSESSIONSTATUS_UPDATE = 31
xe.Handler.ARSESSIONSTATUS_REMOVE = 32

---@public 类构建函数 用于模拟面向对象
---@param className string  类名
---@param super table       基类
---@return table            派生类
function xe.XClass(className, super)

end

---@class xes__Points : Object
local xes__Points = {}
xe.Points = xes__Points

---@public xes_Points_Create00
---@param nSize number
---@return xes__Points
function xes__Points:Create(nSize)
end

---@public xes_Points_new00
---@return xes__Points
function xes__Points:new()
end

---@public xes_Points_Release00
---@return void
function xes__Points:Release()
end

---@public xes_Points_AddControlPoint00
---@param cPoint  XVECTOR3
---@return void
function xes__Points:AddControlPoint(cPoint)
end

---@public xes_Points_InsertControlPoint00
---@param cPoint  XVECTOR3
---@param index number
---@return void
function xes__Points:InsertControlPoint(cPoint, index)
end

---@public xes_Points_ReplaceControlPoint00
---@param cPoint  XVECTOR3
---@param index number
---@return void
function xes__Points:ReplaceControlPoint(cPoint, index)
end

---@public xes_Points_GetControlPointAt00
---@param index number
---@return XVECTOR3
function xes__Points:GetControlPointAt(index)
end

---@public xes_Points_RemoveControlPointAt00
---@param index number
---@return void
function xes__Points:RemoveControlPointAt(index)
end

---@public xes_Points_Num00
---@return number
function xes__Points:Num()
end

---@public xes_Points_ReverseInline00
---@return void
function xes__Points:ReverseInline()
end

---@public xes_Points_Reverse00
---@return xes__Points
function xes__Points:Reverse()
end

---@public xes_Points_Clone00
---@return xes__Points
function xes__Points:Clone()
end

---@public xes_Points_GetControlPoints00
---@return  std__vector<XVECTOR3>
function xes__Points:GetControlPoints()
end

---@public xes_Points_SetControlPoints00
---@param cPoints std__vector<XVECTOR3>
---@return void
function xes__Points:SetControlPoints(cPoints)
end

---@class xes__Face : Object
local xes__Face = {}
xe.Face = xes__Face

---@type number @enum Expression
xes__Face.NONE = 0
---@type number @enum Expression
xes__Face.MOUTH_OPENING = 0
---@type number @enum Expression
xes__Face.MOUTH_OPEN = 0
---@type number @enum Expression
xes__Face.LEFT_EYE_OPEN = 0
---@type number @enum Expression
xes__Face.LEFT_EYE_CLOSING = 0
---@type number @enum Expression
xes__Face.LEFT_EYE_BLINK = 0
---@type number @enum Expression
xes__Face.RIGHT_EYE_OPEN = 0
---@type number @enum Expression
xes__Face.RIGHT_EYE_CLOSING = 0
---@type number @enum Expression
xes__Face.RIGHT_EYE_BLINK = 0
---@type number @enum Expression
xes__Face.EYE_BLINK = 0
---@type number @enum Expression
xes__Face.SMILE = 0
---@type number @enum Expression
xes__Face.DUCKFACE = 0
---@type number @enum Expression
xes__Face.NOD = 0

---@type number
xes__Face.m_nTrackId = 0

---@type number
xes__Face.m_fPitch = 0

---@type number
xes__Face.m_fYaw = 0

---@type number
xes__Face.m_fRoll = 0

---@type xes__Rect
xes__Face.m_rBounds = {}

---@type XVECTOR2[]
xes__Face.m_aLandmarks = {}

---@type XVECTOR2[]
xes__Face.m_137Landmarks = {}

---@type number[]
xes__Face.m_src_points = {}

---@type number[]
xes__Face.m_dst_points = {}

---@public xes_Face_GetTrackId00
---@return number
function xes__Face:GetTrackId()
end

---@public xes_Face_GetEulerAngle00
---@return XVECTOR3
function xes__Face:GetEulerAngle()
end

---@public xes_Face_GetBounds00
---@return xes__Rect
function xes__Face:GetBounds()
end

---@public xes_Face_GetLandmarks00
---@return XVECTOR2[]
function xes__Face:GetLandmarks()
end

---@public xes_Face_Get137Landmarks00
---@return XVECTOR2[]
function xes__Face:Get137Landmarks()
end

---@type number
xes__Face.m_nExpression = 0

---@public xes_Face_GetExpression00
---@return number
function xes__Face:GetExpression()
end

---@type XMATRIX3
xes__Face.m_mCameraMatrix = {}

---@type XMATRIX3
xes__Face.m_mRotationMatrix = {}

---@type XVECTOR3
xes__Face.m_vRotationVector = {}

---@type XVECTOR3
xes__Face.m_vTranslationVector = {}

---@type XMATRIX4
xes__Face.m_mProjectionMatrix = {}

---@type XMATRIX4
xes__Face.m_mModelViewMatrix = {}

---@public xes_Face_GetModelViewMatrix00
---@return XMATRIX4
function xes__Face:GetModelViewMatrix()
end

---@type XVECTOR3
xes__Face.m_vFaceRigEulerVector = {}

---@type number[]
xes__Face.m_aFacerigStates = {}

---@class xes__Expression : Object
local xes__Expression = {}
xe.Expression = xes__Expression

---@class xes__Object
local xes__Object = {}
xe.Object = xes__Object

---@public xes_Object_new00
---@return xes__Object
function xes__Object:new()
end

---@class xes__Size
local xes__Size = {}
xe.Size = xes__Size

---@type number
xes__Size.width = 0

---@type number
xes__Size.height = 0

---@public xes_Size_new00
---@return xes__Size
function xes__Size:new()
end

---@public xes_Size_new01
---@param width number
---@param height number
---@return xes__Size
function xes__Size:new(width, height)
end

---@public xes_Size_new02
---@param other  xes__Size
---@return xes__Size
function xes__Size:new(other)
end

---@public xes_Size_new03
---@param point  XVECTOR2
---@return xes__Size
function xes__Size:new(point)
end

---@public xes_Size_SetSize00
---@param width number
---@param height number
---@return void
function xes__Size:SetSize(width, height)
end

---@public xes_Size_Equals00
---@param target  xes__Size
---@return boolean
function xes__Size:Equals(target)
end

---@type  xes__Size @readonly 
xes__Size.ZERO = {}

---@class xes__Rect
local xes__Rect = {}
xe.Rect = xes__Rect

---@type xes__Size
xes__Rect.size = {}

---@type XVECTOR2
xes__Rect.origin = {}

---@public xes_Rect_new00
---@return xes__Rect
function xes__Rect:new()
end

---@public xes_Rect_new01
---@param x number
---@param y number
---@param width number
---@param height number
---@return xes__Rect
function xes__Rect:new(x, y, width, height)
end

---@public xes_Rect_new02
---@param pos  XVECTOR2
---@param dimension  xes__Size
---@return xes__Rect
function xes__Rect:new(pos, dimension)
end

---@public xes_Rect_new03
---@param other  xes__Rect
---@return xes__Rect
function xes__Rect:new(other)
end

---@public xes_Rect_SetRect00
---@param x number
---@param y number
---@param width number
---@param height number
---@return void
function xes__Rect:SetRect(x, y, width, height)
end

---@public xes_Rect_GetMinX00
---@return number
function xes__Rect:GetMinX()
end

---@public xes_Rect_GetMidX00
---@return number
function xes__Rect:GetMidX()
end

---@public xes_Rect_GetMaxX00
---@return number
function xes__Rect:GetMaxX()
end

---@public xes_Rect_GetMinY00
---@return number
function xes__Rect:GetMinY()
end

---@public xes_Rect_GetMidY00
---@return number
function xes__Rect:GetMidY()
end

---@public xes_Rect_GetMaxY00
---@return number
function xes__Rect:GetMaxY()
end

---@public xes_Rect_Equals00
---@param rect  xes__Rect
---@return boolean
function xes__Rect:Equals(rect)
end

---@public xes_Rect_containsPoint00
---@param point  XVECTOR2
---@return boolean
function xes__Rect:containsPoint(point)
end

---@public xes_Rect_intersectsRect00
---@param rect  xes__Rect
---@return boolean
function xes__Rect:intersectsRect(rect)
end

---@public xes_Rect_intersectsCircle00
---@param center  XVECTOR2
---@param radius number
---@return boolean
function xes__Rect:intersectsCircle(center, radius)
end

---@public xes_Rect_unionWithRect00
---@param rect  xes__Rect
---@return xes__Rect
function xes__Rect:unionWithRect(rect)
end

---@public xes_Rect_merge00
---@param rect  xes__Rect
---@return void
function xes__Rect:merge(rect)
end

---@type  xes__Rect @readonly 
xes__Rect.ZERO = {}

---@class xes__Hand : Object
local xes__Hand = {}
xe.Hand = xes__Hand

---@class xes__Hand__Gesture
local xes__Hand__Gesture = {}
xe.Hand.Gesture = xes__Hand__Gesture

---@class xes__Hand__Joint
local xes__Hand__Joint = {}
xe.Hand.Joint = xes__Hand__Joint

---@type Gesture[]
xes__Hand.m_arrGestures = {}

---@type Joint[]
xes__Hand.m_arrLandmarks = {}

---@type number[]
xes__Hand.m_arrParams = {}

---@class xes__Attitude : Object
local xes__Attitude = {}
xe.Attitude = xes__Attitude

---@public xes_Attitude_new00
---@return xes__Attitude
function xes__Attitude:new()
end

---@public xes_Attitude_Release00
---@return void
function xes__Attitude:Release()
end

---@type number
xes__Attitude.roll = 0

---@type number
xes__Attitude.pitch = 0

---@type number
xes__Attitude.yaw = 0

---@type XMATRIX3
xes__Attitude.m_RotationMatrix = {}

---@type XQUATERNION
xes__Attitude.m_Quaternion = {}

---@public xes_Attitude_GetEulerAngle00
---@return XVECTOR3
function xes__Attitude:GetEulerAngle()
end

---@public xes_Attitude_GetRotationMatrix00
---@return XMATRIX3
function xes__Attitude:GetRotationMatrix()
end

---@public xes_Attitude_GetQuaternion00
---@return XQUATERNION
function xes__Attitude:GetQuaternion()
end

---@class xes__Acceleration : Object
local xes__Acceleration = {}
xe.Acceleration = xes__Acceleration

---@public xes_Acceleration_new00
---@return xes__Acceleration
function xes__Acceleration:new()
end

---@public xes_Acceleration_Release00
---@return void
function xes__Acceleration:Release()
end

---@type number
xes__Acceleration.x = 0

---@type number
xes__Acceleration.y = 0

---@type number
xes__Acceleration.z = 0

---@type number
xes__Acceleration.timestamp = 0

---@public xes_Acceleration_GetAcc00
---@return XVECTOR3
function xes__Acceleration:GetAcc()
end

---@public xes_Acceleration_GetTimestamp00
---@return number
function xes__Acceleration:GetTimestamp()
end

---@class xes__Spline : Object
local xes__Spline = {}
xe.Spline = xes__Spline

---@public xes_Spline_Create00
---@param pPoints xes__Points
---@param fTension number
---@return xes__Spline
function xes__Spline:Create(pPoints, fTension)
end

---@public xes_Spline_new00
---@param pPoints xes__Points
---@param fTension number
---@return xes__Spline
function xes__Spline:new(pPoints, fTension)
end

---@public xes_Spline_GetPoint00
---@param fDurationScale number
---@return XVECTOR3
function xes__Spline:GetPoint(fDurationScale)
end

---@public xes_Spline_DestoryLine00
---@param pSpline xes__Spline
---@return void
function xes__Spline:DestoryLine(pSpline)
end

---@class xes__CatmullRomSpline : Spline
local xes__CatmullRomSpline = {}
xe.CatmullRomSpline = xes__CatmullRomSpline

---@public xes_CatmullRomSpline_Create00
---@param pPoints xes__Points
---@return xes__CatmullRomSpline
function xes__CatmullRomSpline:Create(pPoints)
end

---@public xes_CatmullRomSpline_new00
---@param pPoints xes__Points
---@return xes__CatmullRomSpline
function xes__CatmullRomSpline:new(pPoints)
end

---@public xes_CatmullRomSpline_Release00
---@return void
function xes__CatmullRomSpline:Release()
end

---@class xes__CVBody : Object
local xes__CVBody = {}
xe.CVBody = xes__CVBody

---@class xes__CVBody__Joint
local xes__CVBody__Joint = {}
xe.CVBody.Joint = xes__CVBody__Joint

---@type Joint[]
xes__CVBody.m_joints = {}

---@class xes__CVObject : Object
local xes__CVObject = {}
xe.CVObject = xes__CVObject

---@type string
xes__CVObject.m_Type = ''

---@type xes__Rect
xes__CVObject.m_Bounds = {}

---@type number
xes__CVObject.m_Score = 0

---@class xes__CustomEvent : Event
local xes__CustomEvent = {}
xe.CustomEvent = xes__CustomEvent

---@public xes_CustomEvent_SetUserData00
---@param pData userdata
---@return void
function xes__CustomEvent:SetUserData(pData)
end

---@public xes_CustomEvent_GetUserData00
---@return userdata
function xes__CustomEvent:GetUserData()
end

---@public xes_CustomEvent_GetEventName00
---@return string
function xes__CustomEvent:GetEventName()
end

---@class xes__Event : Object
local xes__Event = {}
xe.Event = xes__Event

---@type number @enum Type
xes__Event.TOUCH = 0
---@type number @enum Type
xes__Event.FACE = 0
---@type number @enum Type
xes__Event.EXPRESSION = 0
---@type number @enum Type
xes__Event.ATTITUDE = 0
---@type number @enum Type
xes__Event.ACCELERATION = 0
---@type number @enum Type
xes__Event.CVBODY = 0
---@type number @enum Type
xes__Event.CVOBJECT = 0
---@type number @enum Type
xes__Event.HAND = 0
---@type number @enum Type
xes__Event.CUSTOM = 0
---@type number @enum Type
xes__Event.DATA = 0
---@type number @enum Type
xes__Event.GESTURE = 0

---@public xes_Event_GetType00
---@return number
function xes__Event:GetType()
end

---@public xes_Event_GetTarget00
---@return XEActor
function xes__Event:GetTarget()
end

---@public xes_Event_IsStopped00
---@return boolean
function xes__Event:IsStopped()
end

---@class xes__ExpressionEventListener : EventListener
local xes__ExpressionEventListener = {}
xe.ExpressionEventListener = xes__ExpressionEventListener

---@public xes_ExpressionEventListener_Create00
---@return xes__ExpressionEventListener
function xes__ExpressionEventListener:Create()
end

---@manual xelua_XEngine_xes_ExpressionEventListener_RegisterHandler_manual
---@public xes_ExpressionEventListener_RegisterHandler_manual
---@return void
function xes__ExpressionEventListener:RegisterHandler()
end

---@class xes__FaceEventListener : EventListener
local xes__FaceEventListener = {}
xe.FaceEventListener = xes__FaceEventListener

---@public xes_FaceEventListener_Create00
---@return xes__FaceEventListener
function xes__FaceEventListener:Create()
end

---@manual xelua_XEngine_xes_FaceEventListener_RegisterHandler_manual
---@public xes_FaceEventListener_RegisterHandler_manual
---@return void
function xes__FaceEventListener:RegisterHandler()
end

---@class xes__CVBodyEventListener : EventListener
local xes__CVBodyEventListener = {}
xe.CVBodyEventListener = xes__CVBodyEventListener

---@public xes_CVBodyEventListener_Create00
---@return xes__CVBodyEventListener
function xes__CVBodyEventListener:Create()
end

---@manual xelua_XEngine_xes_CVBodyEventListener_RegisterHandler_manual
---@public xes_CVBodyEventListener_RegisterHandler_manual
---@return void
function xes__CVBodyEventListener:RegisterHandler()
end

---@class xes__CVObjectEventListener : EventListener
local xes__CVObjectEventListener = {}
xe.CVObjectEventListener = xes__CVObjectEventListener

---@public xes_CVObjectEventListener_Create00
---@return xes__CVObjectEventListener
function xes__CVObjectEventListener:Create()
end

---@manual xelua_XEngine_xes_CVObjectEventListener_RegisterHandler_manual
---@public xes_CVObjectEventListener_RegisterHandler_manual
---@return void
function xes__CVObjectEventListener:RegisterHandler()
end

---@class xes__FaceEvent : Event
local xes__FaceEvent = {}
xe.FaceEvent = xes__FaceEvent

---@type number @enum EventCode
xes__FaceEvent.NONEFACE = 0
---@type number @enum EventCode
xes__FaceEvent.TRACKINGFACE = 0

---@public xes_FaceEvent_Release00
---@return void
function xes__FaceEvent:Release()
end

---@class xes__AccelerationEvent : Event
local xes__AccelerationEvent = {}
xe.AccelerationEvent = xes__AccelerationEvent

---@public xes_AccelerationEvent_GetAcceleration00
---@return  xes__Acceleration
function xes__AccelerationEvent:GetAcceleration()
end

---@public xes_AccelerationEvent_SetAcceleration00
---@param pAcceleration xes__Acceleration
---@return void
function xes__AccelerationEvent:SetAcceleration(pAcceleration)
end

---@class xes__AccelerationEventListener : EventListener
local xes__AccelerationEventListener = {}
xe.AccelerationEventListener = xes__AccelerationEventListener

---@public xes_AccelerationEventListener_Create00
---@return xes__AccelerationEventListener
function xes__AccelerationEventListener:Create()
end

---@manual xelua_XEngine_xes_AccelerationEventListener_RegisterHandler_manual
---@public xes_AccelerationEventListener_RegisterHandler_manual
---@return void
function xes__AccelerationEventListener:RegisterHandler()
end

---@class xes__CVBodyEvent : Event
local xes__CVBodyEvent = {}
xe.CVBodyEvent = xes__CVBodyEvent

---@type number @enum EventCode
xes__CVBodyEvent.DEFAULT = 0
---@type number @enum EventCode
xes__CVBodyEvent.TRACKING = 0

---@public xes_CVBodyEvent_GetEventCode00
---@return number
function xes__CVBodyEvent:GetEventCode()
end

---@public xes_CVBodyEvent_GetBodys00
---@return CVBody[]
function xes__CVBodyEvent:GetBodys()
end

---@public xes_CVBodyEvent_SetBodys00
---@param aBodys CVBody[]
---@return void
function xes__CVBodyEvent:SetBodys(aBodys)
end

---@class xes__CVObjectEvent : Event
local xes__CVObjectEvent = {}
xe.CVObjectEvent = xes__CVObjectEvent

---@type number @enum EventCode
xes__CVObjectEvent.DEFAULT = 0
---@type number @enum EventCode
xes__CVObjectEvent.TRACKING = 0

---@public xes_CVObjectEvent_GetEventCode00
---@return number
function xes__CVObjectEvent:GetEventCode()
end

---@public xes_CVObjectEvent_GetObjects00
---@return CVObject[]
function xes__CVObjectEvent:GetObjects()
end

---@public xes_CVObjectEvent_SetObjects00
---@param aObjects CVObject[]
---@return void
function xes__CVObjectEvent:SetObjects(aObjects)
end

---@class xes__HandEvent : Event
local xes__HandEvent = {}
xe.HandEvent = xes__HandEvent

---@public xes_HandEvent_GetHands00
---@return Hand[]
function xes__HandEvent:GetHands()
end

---@public xes_HandEvent_SetHands00
---@param arrHands Hand[]
---@return void
function xes__HandEvent:SetHands(arrHands)
end

---@class xes__AttitudeEventListener : EventListener
local xes__AttitudeEventListener = {}
xe.AttitudeEventListener = xes__AttitudeEventListener

---@public xes_AttitudeEventListener_Create00
---@return xes__AttitudeEventListener
function xes__AttitudeEventListener:Create()
end

---@manual xelua_XEngine_xes_AttitudeEventListener_RegisterHandler_manual
---@public xes_AttitudeEventListener_RegisterHandler_manual
---@return void
function xes__AttitudeEventListener:RegisterHandler()
end

---@class xes__AttitudeEvent : Event
local xes__AttitudeEvent = {}
xe.AttitudeEvent = xes__AttitudeEvent

---@public xes_AttitudeEvent_GetAttitude00
---@return  xes__Attitude
function xes__AttitudeEvent:GetAttitude()
end

---@public xes_AttitudeEvent_SetAttitude00
---@param pAttitude xes__Attitude
---@return void
function xes__AttitudeEvent:SetAttitude(pAttitude)
end

---@class xes__HandEventListener : EventListener
local xes__HandEventListener = {}
xe.HandEventListener = xes__HandEventListener

---@public xes_HandEventListener_Create00
---@return xes__HandEventListener
function xes__HandEventListener:Create()
end

---@manual xelua_XEngine_xes_HandEventListener_RegisterHandler_manual
---@public xes_HandEventListener_RegisterHandler_manual
---@return void
function xes__HandEventListener:RegisterHandler()
end
