---@class XEDevice
XEDevice = {}


---@type number @enum NetworkType
XEDevice.NETWORK_TYPE_UNCONNECTED = 0


---@type number @enum NetworkType
XEDevice.NETWORK_TYPE_CALLULAR = 0


---@type number @enum NetworkType
XEDevice.NETWORK_TYPE_WIFI = 0


---@public To enable or disable attitude motion.
---@param isEnabled boolean
---@return void
function XEDevice:SetAttitudeEnabled(isEnabled) end


---@public Sets the interval of attitude motion.
---@param interval number
---@return void
function XEDevice:SetAttitudeInterval(interval) end


---@public To enable or disable acceleration motion.
---@param isEnabled boolean
---@return void
function XEDevice:SetAccelerationEnabled(isEnabled) end


---@public Sets the interval of acceleration motion.
---@param interval number
---@return void
function XEDevice:SetAccelerationInterval(interval) end


---@public 获取网络状态
---@return number
function XEDevice:GetNetworkType() end


---@public 获取设备描述信息
---@return string
function XEDevice:GetDeviceInfo() end


---@public 获取是被型号
---@return string
function XEDevice:GetDeviceModel() end


---@public 获取操作系统
---@return string
function XEDevice:GetDeviceSystemVersion() end


