---@class XVECTOR2
XVECTOR2 = {}

---@public XVECTOR2_new00
---@return XVECTOR2
function XVECTOR2:__call()
end

---@public XVECTOR2_new01
---@param fValue number
---@return XVECTOR2
function XVECTOR2:__call(fValue)
end

---@public XVECTOR2_new02
---@param fx number
---@param fy number
---@return XVECTOR2
function XVECTOR2:__call(fx, fy)
end

---@public XVECTOR2_new03
---@param vRhs  XVECTOR2
---@return XVECTOR2
function XVECTOR2:__call(vRhs)
end

---@type number
XVECTOR2.x = 0

---@type number
XVECTOR2.y = 0

---@public 将当前XVECTOR2向量单位化，并返回单位化之前向量的模。单位化是指将向量的模变为1.
---@return number 向量单位化之前的模
function XVECTOR2:Normalize()
end

---@public 设置XVECTOR2向量的2个分量
---@param fx number 为XVECTOR2的x分量赋值的变量
---@param fy number 为XVECTOR2的y分量赋值的变量
---@return void
function XVECTOR2:Set(fx, fy)
end

---@public 将XVECTOR2向量的三个分量分别置为0
---@return void
function XVECTOR2:Clear()
end

---@public 判断XVECTOR2向量是否是零向量，当2个分量均是0时，当前向量才是零向量。
---@return boolean 是否是零向量，True:是零向量；False:非零向量
function XVECTOR2:IsZero()
end

---@public 判断当 XVECTOR2向量与向量vec是否在fEpsilon的误差内相等
---@param vec  XVECTOR2 待比较的向量
---@param fEpsilon number 误差容限，代表浮点数不精确度的公差
---@return boolean True:表示当前向量与v向量在fEpsilon误差内相等;False:表示当前向量与v向量在fEpsilon误差内不相等。
function XVECTOR2:IsEquals(vec, fEpsilon)
end

---@public 计算当前XVECTOR2向量的模
---@return number 当前向量的模
function XVECTOR2:Magnitude()
end

---@public 计算当前XVECTOR2向量的模的平方。
---@return number 当前向量的模的平方
function XVECTOR2:SquaredMagnitude()
end

---@public 获取当前向量XY分量中的最小值
---@return number 当前向量分量中的最小值
function XVECTOR2:MinMemberValue()
end

---@public 获取当前向量XY分量中的最大值
---@return number 当前向量分量中的最大值
function XVECTOR2:MaxMemberValue()
end

---@public 修正XY分量到[-1,1]之间
---@return void
function XVECTOR2:Snap()
end

---@manual xelua_XEngine_XVECTOR2_AddVecWith_manual
---@public XVECTOR2_AddVecWith_manual
---@param vec  XVECTOR2
---@return void
function XVECTOR2:AddVecWith(vec)
end

---@manual xelua_XEngine_XVECTOR2_SubVecWith_manual
---@public XVECTOR2_SubVecWith_manual
---@param vec  XVECTOR2
---@return void
function XVECTOR2:SubVecWith(vec)
end

---@manual xelua_XEngine_XVECTOR2_MulFloatWith_manual
---@public XVECTOR2_MulFloatWith_manual
---@param fvalue number
---@return void
function XVECTOR2:MulFloatWith(fvalue)
end

---@manual xelua_XEngine_XVECTOR2_DevFloatWith_manual
---@public XVECTOR2_DevFloatWith_manual
---@param fvalue number
---@return void
function XVECTOR2:DevFloatWith(fvalue)
end

---@class XVECTOR3
XVECTOR3 = {}

---@public XVECTOR3_new00
---@return XVECTOR3
function XVECTOR3:new()
end

---@public XVECTOR3_new01
---@param m number
---@return XVECTOR3
function XVECTOR3:new(m)
end

---@public XVECTOR3_new02
---@param x number
---@param y number
---@param z number
---@return XVECTOR3
function XVECTOR3:new(x, y, z)
end

---@public XVECTOR3_new03
---@param v  XVECTOR3
---@return XVECTOR3
function XVECTOR3:new(v)
end

---@type number
XVECTOR3.x = 0

---@type number
XVECTOR3.y = 0

---@type number
XVECTOR3.z = 0

---@public 将当前XVECTOR2向量单位化，并返回单位化之前向量的模。单位化是指将向量的模变为1.
---@return number 向量单位化之前的模
function XVECTOR3:Normalize()
end

---@public 设置XVECTOR2向量的2个分量
---@param _x number
---@param _y number
---@param _z number
---@return void
function XVECTOR3:Set(_x, _y, _z)
end

---@public 将XVECTOR2向量的三个分量分别置为0
---@return void
function XVECTOR3:Clear()
end

---@public 判断XVECTOR2向量是否是零向量，当2个分量均是0时，当前向量才是零向量。
---@return boolean 是否是零向量，True:是零向量；False:非零向量
function XVECTOR3:IsZero()
end

---@public 判断当 XVECTOR2向量与向量vec是否在fEpsilon的误差内相等
---@param v  XVECTOR3
---@param epsilon number
---@return boolean True:表示当前向量与v向量在fEpsilon误差内相等;False:表示当前向量与v向量在fEpsilon误差内不相等。
function XVECTOR3:IsEquals(v, epsilon)
end

---@public 计算当前XVECTOR2向量的模
---@return number 当前向量的模
function XVECTOR3:Magnitude()
end

---@public 计算当前向量 x 分量与 z 分量平方和的平方根，并返回结果。
---@return number x分量与z分量平方和的平方根
function XVECTOR3:MagnitudeH()
end

---@public 计算当前XVECTOR2向量的模的平方。
---@return number 当前向量的模的平方
function XVECTOR3:SquaredMagnitude()
end

---@public 计算当前 XVECTOR3 向量 x 分量和 z 分量的平方和
---@return number 当前向量x分量和z分量的平方和。
function XVECTOR3:SquaredMagnitudeH()
end

---@public 获取当前向量分量中的最小值
---@return number 当前向量分量中的最小值
function XVECTOR3:MinMember()
end

---@public 获取当前向量分量中的最大值
---@return number 当前向量分量中的最大值
function XVECTOR3:MaxMember()
end

---@public 修正XY分量到[-1,1]之间
---@return void
function XVECTOR3:Snap()
end

---@public 叉积函数，计算向量vec1和向量vec2的叉积，此函数是XVECTOR2的友元函数
---@param v1  XVECTOR3
---@param v2  XVECTOR3
---@return void 向量vec1和向量vec2的叉积运算得到的向量
function XVECTOR3:CrossProduct(v1, v2)
end

---@manual xelua_XEngine_XVECTOR3_AddVecWith_manual
---@public XVECTOR3_AddVecWith_manual
---@param vec  XVECTOR3
---@return void
function XVECTOR3:AddVecWith(vec)
end

---@manual xelua_XEngine_XVECTOR3_SubVecWith_manual
---@public XVECTOR3_SubVecWith_manual
---@param vec  XVECTOR3
---@return void
function XVECTOR3:SubVecWith(vec)
end

---@manual xelua_XEngine_XVECTOR3_MulFloatWith_manual
---@public XVECTOR3_MulFloatWith_manual
---@param f number
---@return void
function XVECTOR3:MulFloatWith(f)
end

---@manual xelua_XEngine_XVECTOR3_DevFloatWith_manual
---@public XVECTOR3_DevFloatWith_manual
---@param f number
---@return void
function XVECTOR3:DevFloatWith(f)
end

---@class XVECTOR4
XVECTOR4 = {}

---@type number
XVECTOR4.x = 0

---@type number
XVECTOR4.y = 0

---@type number
XVECTOR4.z = 0

---@type number
XVECTOR4.w = 0

---@public XVECTOR4_new00
---@return XVECTOR4
function XVECTOR4:new()
end

---@public XVECTOR4_new01
---@param _x number
---@param _y number
---@param _z number
---@param _w number
---@return XVECTOR4
function XVECTOR4:new(_x, _y, _z, _w)
end

---@public XVECTOR4_new02
---@param f number
---@return XVECTOR4
function XVECTOR4:new(f)
end

---@public XVECTOR4_new03
---@param v  XVECTOR4
---@return XVECTOR4
function XVECTOR4:new(v)
end

---@public XVECTOR4_new04
---@param v  XVECTOR3
---@return XVECTOR4
function XVECTOR4:new(v)
end

---@public 设置XVECTOR2向量的2个分量
---@param _x number
---@param _y number
---@param _z number
---@param _w number
---@return void
function XVECTOR4:Set(_x, _y, _z, _w)
end

---@public 将XVECTOR2向量的三个分量分别置为0
---@return void
function XVECTOR4:Clear()
end

---@public 判断当 XVECTOR2向量与向量vec是否在fEpsilon的误差内相等
---@param v  XVECTOR4
---@param epsilon number
---@return boolean True:表示当前向量与v向量在fEpsilon误差内相等;False:表示当前向量与v向量在fEpsilon误差内不相等。
function XVECTOR4:IsEquals(v, epsilon)
end

---@class XMATRIX3
XMATRIX3 = {}

---@type number @enum CONSTRUCT
XMATRIX3.IDENTITY = 0

---@type number @enum CONSTRUCT
XMATRIX3.CLEARED = 0

---@type number
XMATRIX3._11 = 0

---@type number
XMATRIX3._12 = 0

---@type number
XMATRIX3._13 = 0

---@type number
XMATRIX3._21 = 0

---@type number
XMATRIX3._22 = 0

---@type number
XMATRIX3._23 = 0

---@type number
XMATRIX3._31 = 0

---@type number
XMATRIX3._32 = 0

---@type number
XMATRIX3._33 = 0

---@public XMATRIX3_new00
---@return XMATRIX3
function XMATRIX3:new()
end

---@public XMATRIX3_new01
---@param c number
---@return XMATRIX3
function XMATRIX3:new(c)
end

---@public XMATRIX3_new02
---@param rkMatrix  XMATRIX3
---@return XMATRIX3
function XMATRIX3:new(rkMatrix)
end

---@public XMATRIX3_new03
---@param fEntry00 number
---@param fEntry01 number
---@param fEntry02 number
---@param fEntry10 number
---@param fEntry11 number
---@param fEntry12 number
---@param fEntry20 number
---@param fEntry21 number
---@param fEntry22 number
---@return XMATRIX3
function XMATRIX3:new(fEntry00, fEntry01, fEntry02, fEntry10, fEntry11, fEntry12, fEntry20, fEntry21, fEntry22)
end

---@public 获取当前矩阵第 i 行的向量
---@param i number 表示当前矩阵行号的索引值
---@return XVECTOR3 XVECTOR3：当前矩阵第i行的向量
function XMATRIX3:GetRow(i)
end

---@public 获取当前矩阵第 i 列的向量
---@param i number 表示当前矩阵列号的索引值
---@return XVECTOR3 XVECTOR3：当前矩阵第i列的向量
function XMATRIX3:GetCol(i)
end

---@public 将当前矩阵进行转置运算，即将交换矩阵的行和列。
---@return void
function XMATRIX3:Transpose()
end

---@public 将XVECTOR2向量的三个分量分别置为0
---@return void
function XMATRIX3:Clear()
end

---@public 将当前矩阵设为单位矩阵，即其主对角线上的元素全为1，其他元素全为0。
---@return void
function XMATRIX3:Identity()
end

---@public 将当前矩阵设为表示平移信息的矩阵，平移向量为(x,y)。此时，当前矩阵不包含旋转和缩放信息。
---@param x number 表示平移向量的x分量
---@param y number 表示平移向量的y分量
---@return void
function XMATRIX3:Translate(x, y)
end

---@public 将当前矩阵旋转fRad弧度的矩阵。
---@param fRad number 表示旋转角(弧度)。
---@return void
function XMATRIX3:Rotate(fRad)
end

---@public 将当前矩阵进行逆转置矩阵的运算，即先对矩阵计算出逆矩阵，再对逆矩阵做转置矩阵的计算。
---@return void
function XMATRIX3:InverseTM()
end

---@manual xelua_XEngine_XMATRIX3_MulMatWith_manual
---@public XMATRIX3_MulMatWith_manual
---@param mRight  XMATRIX3
---@return XMATRIX3
function XMATRIX3:MulMatWith(mRight)
end

---@class XMATRIX4
XMATRIX4 = {}

---@type number @enum CONSTRUCT
XMATRIX4.IDENTITY = 0

---@type number
XMATRIX4._11 = 0

---@type number
XMATRIX4._12 = 0

---@type number
XMATRIX4._13 = 0

---@type number
XMATRIX4._14 = 0

---@type number
XMATRIX4._21 = 0

---@type number
XMATRIX4._22 = 0

---@type number
XMATRIX4._23 = 0

---@type number
XMATRIX4._24 = 0

---@type number
XMATRIX4._31 = 0

---@type number
XMATRIX4._32 = 0

---@type number
XMATRIX4._33 = 0

---@type number
XMATRIX4._34 = 0

---@type number
XMATRIX4._41 = 0

---@type number
XMATRIX4._42 = 0

---@type number
XMATRIX4._43 = 0

---@type number
XMATRIX4._44 = 0

---@public XMATRIX4_new00
---@return XMATRIX4
function XMATRIX4:new()
end

---@public XMATRIX4_new01
---@param v number
---@return XMATRIX4
function XMATRIX4:new(v)
end

---@public XMATRIX4_new02
---@param mat  XMATRIX4
---@return XMATRIX4
function XMATRIX4:new(mat)
end

---@public XMATRIX4_new03
---@param c number
---@return XMATRIX4
function XMATRIX4:new(c)
end

---@public XMATRIX4_new04
---@param fEntry00 number
---@param fEntry01 number
---@param fEntry02 number
---@param fEntry03 number
---@param fEntry10 number
---@param fEntry11 number
---@param fEntry12 number
---@param fEntry13 number
---@param fEntry20 number
---@param fEntry21 number
---@param fEntry22 number
---@param fEntry23 number
---@param fEntry30 number
---@param fEntry31 number
---@param fEntry32 number
---@param fEntry33 number
---@return XMATRIX4
function XMATRIX4:new(
    fEntry00,
    fEntry01,
    fEntry02,
    fEntry03,
    fEntry10,
    fEntry11,
    fEntry12,
    fEntry13,
    fEntry20,
    fEntry21,
    fEntry22,
    fEntry23,
    fEntry30,
    fEntry31,
    fEntry32,
    fEntry33)
end

---@public 将XVECTOR2向量的三个分量分别置为0
---@return void
function XMATRIX4:Clear()
end

---@public 将当前矩阵设为单位矩阵，即其主对角线上的元素全为1，其他元素全为0。
---@return void
function XMATRIX4:Identity()
end

---@public 将当前矩阵进行转置运算，即将交换矩阵的行和列。
---@return void
function XMATRIX4:Transpose()
end

---@public 获取当前矩阵的转置矩阵
---@return XMATRIX4 XMATRIX4:当前矩阵的转置矩阵
function XMATRIX4:GetTranspose()
end

---@public 将当前矩阵进行逆矩阵运算。
---@return void
function XMATRIX4:Inverse()
end

---@public 获取当前矩阵的逆矩阵。
---@return XMATRIX4 XMATRIX4:当前矩阵的逆矩阵
function XMATRIX4:GetInverse()
end

---@public 将当前矩阵进行逆转置矩阵的运算，即先对矩阵计算出逆矩阵，再对逆矩阵做转置矩阵的计算。
---@return void
function XMATRIX4:InverseTM()
end

---@public 获取当前矩阵的逆转置矩阵。
---@return XMATRIX4 XMATRIX4:当前矩阵计算出的逆转置矩阵。
function XMATRIX4:GetInverseTM()
end

---@public 计算当前矩阵的行列式。
---@return number 基于当前矩阵计算出的行列式的值
function XMATRIX4:Determinant()
end

---@public 将当前矩阵设为表示平移信息的矩阵，平移向量为(x,y)。此时，当前矩阵不包含旋转和缩放信息。
---@param x number 表示平移向量的x分量
---@param y number 表示平移向量的y分量
---@param z number
---@return void
function XMATRIX4:Translate(x, y, z)
end

---@public 将当前矩阵设为表示绕 X 轴旋转 fRad 弧度的矩阵。此时，当前矩阵不包含平移和缩放信息。
---@param fRad number 表示旋转角(弧度)。
---@return void
function XMATRIX4:RotateX(fRad)
end

---@public 将当前矩阵设为表示绕 Y 轴旋转 fRad弧度的矩阵。此时，当前矩阵不包含平移和缩放信息。
---@param fRad number 表示旋转角(弧度)。
---@return void
function XMATRIX4:RotateY(fRad)
end

---@public 将当前矩阵设为表示绕 Z 轴旋转 fRad弧度的矩阵。此时，当前矩阵不包含平移和缩放信息。
---@param fRad number 表示旋转角(弧度)。
---@return void
function XMATRIX4:RotateZ(fRad)
end

---@public 计算绕向量 v旋转 fRad 弧度的矩阵（此时参考点是坐标原点）。旋转后的矩阵不包含平移和缩放信息。注意：要求向量 v 为单位化后的向量。
---@param v  XVECTOR3 表示单位化之后的旋转轴
---@param fRad number 表示旋转角(弧度)
---@return void
function XMATRIX4:RotateAxis(v, fRad)
end

---@public 计算以 vPos 为参考点，绕向量 vAxis旋转 fRad 弧度的矩阵。旋转后的矩阵不包含平移和缩放信息。
---@param vPos  XVECTOR3 参考点。
---@param vAxis  XVECTOR3 表示单位化之后的旋转轴
---@param fRad number 表示旋转角(弧度)
---@return void
---@attention 要求向量 vAxis 为单位化后的向量。
function XMATRIX4:RotateAxis(vPos, vAxis, fRad)
end

---@public 将当前矩阵设为仅包含缩放信息的矩阵，三个轴的缩放量分别是 sz,sy,sz
---@param sx number 表示x轴上的缩放量
---@param sy number 表示y轴上的缩放量
---@param sz number 表示z轴上的缩放量
---@return void
function XMATRIX4:Scale(sx, sy, sz)
end

---@public 设置当前矩阵的旋转信息，不影响其原始的缩放和平移信息
---@param mat  XMATRIX3 表示旋转信息的33矩阵
---@return void
function XMATRIX4:SetRotatePart(mat)
end

---@public 获取当前矩阵的旋转信息
---@return XMATRIX3 XMATRIX3：当前矩阵包含的旋转信息，以33的矩阵表示
function XMATRIX4:GetRotatePart()
end

---@public 设置当前矩阵的平移信息，不影响其原始的缩放和旋转信息
---@param vTrans  XVECTOR3 表示平移向量
---@return void
function XMATRIX4:SetTransPart(vTrans)
end

---@public 获取当前矩阵的平移信息
---@return XVECTOR3 XVECTOR3：当前矩阵包含的平移向量
function XMATRIX4:GetTransPart()
end

---@public 获取当前矩阵第 i 行的向量
---@param i number 表示当前矩阵行号的索引值
---@return XVECTOR3 XVECTOR3：当前矩阵第i行的向量
function XMATRIX4:GetRow(i)
end

---@public 获取当前矩阵第 i 列的向量
---@param i number 表示当前矩阵列号的索引值
---@return XVECTOR3 XVECTOR3：当前矩阵第i列的向量
function XMATRIX4:GetCol(i)
end

---@public 设置当前矩阵第 i 行的向量为 v
---@param i number
---@param v  XVECTOR3 要设置为当前矩阵第i行向量的向量
---@return void
function XMATRIX4:SetRow(i, v)
end

---@public 设置当前矩阵第 i 列的向量为 v
---@param i number
---@param v  XVECTOR3 要设置为当前矩阵第i列向量的向量
---@return void
function XMATRIX4:SetCol(i, v)
end

---@public 与operator *实现同样的功能，之后版本应该把operator *的功能改为矩阵的直接相乘.通过当前矩阵变换3D矢量 v.
---@param v  XVECTOR3 待变换的向量
---@return XVECTOR3 XVECTOR3：向量v变换后的结果向量
---@attention 与MulVec 函数的功能不同进，此函数进行乘法计算时，矩阵的平移信息对向量产生影响。即 v 代表空间一个点，它的齐次坐标w = 1
function XMATRIX4:TransformCoord(v)
end

---@public 通过当前矩阵变换3D向量 inV ，并将计算结果赋给outV.
---@param inV  XVECTOR3 [in]待变换的向量
---@param outV XVECTOR3 [out]变换后的向量
---@return void
---@attention 与MulVec 函数的功能不同进，此函数进行乘法计算时，矩阵的平移信息对向量产生影响。即 v 代表空间一个点，它的齐次坐标w = 1
function XMATRIX4:TransformCoord(inV, outV)
end

---@public 直接相乘,通过当前矩阵变换3D 向量 v ，并将计算结果返回
---@param v  XVECTOR3 待变换的向量
---@return XVECTOR3 XVECTOR3：向量v变换后的结果向量
---@attention 进行乘法计算时，矩阵的平移信息不对向量产生影响。即 v 代表向量，它的齐次坐标w = 0
function XMATRIX4:MulVec(v)
end

---@manual xelua_XEngine_XMATRIX4_MulMatWith_manual
---@public XMATRIX4_MulMatWith_manual
---@param mat  XMATRIX4
---@return XMATRIX4
function XMATRIX4:MulMatWith(mat)
end

---@manual xelua_XEngine_XMATRIX4_MulFloatWith_manual
---@public XMATRIX4_MulFloatWith_manual
---@param s number
---@return XMATRIX4
function XMATRIX4:MulFloatWith(s)
end

---@manual xelua_XEngine_XMATRIX4_DevFloatWith_manual
---@public XMATRIX4_DevFloatWith_manual
---@param s number
---@return XMATRIX4
function XMATRIX4:DevFloatWith(s)
end

---@manual xelua_XEngine_XMATRIX4_AddMatWith_manual
---@public XMATRIX4_AddMatWith_manual
---@param mat  XMATRIX4
---@return XMATRIX4
function XMATRIX4:AddMatWith(mat)
end

---@manual xelua_XEngine_XMATRIX4_SubMatWith_manual
---@public XMATRIX4_SubMatWith_manual
---@param mat  XMATRIX4
---@return XMATRIX4
function XMATRIX4:SubMatWith(mat)
end

---@manual xelua_XEngine_XMATRIX4_AsLuaTable_manual
---@public XMATRIX4_AsLuaTable_manual
---@return void
function XMATRIX4:AsLuaTable()
end

---@class XQUATERNION
XQUATERNION = {}

---@public XQUATERNION_new00
---@return XQUATERNION
function XQUATERNION:new()
end

---@public XQUATERNION_new01
---@param mat  XMATRIX4
---@return XQUATERNION
function XQUATERNION:new(mat)
end

---@public XQUATERNION_new02
---@param vAxis  XVECTOR3
---@param fAngle number
---@return XQUATERNION
function XQUATERNION:new(vAxis, fAngle)
end

---@public XQUATERNION_new03
---@param fXAngle number
---@param fYAngle number
---@param fZAngle number
---@return XQUATERNION
function XQUATERNION:new(fXAngle, fYAngle, fZAngle)
end

---@public XQUATERNION_new04
---@param fw number
---@param fx number
---@param fy number
---@param fz number
---@return XQUATERNION
function XQUATERNION:new(fw, fx, fy, fz)
end

---@public XQUATERNION_new05
---@param fw number
---@param fv  XVECTOR3
---@return XQUATERNION
function XQUATERNION:new(fw, fv)
end

---@public 将当前四元数转化为矩阵形式
---@return XMATRIX4
---@return void
function XQUATERNION:ConvToMatrix()
end

---@public 从矩阵中提取旋转信息并转化为四元数形式
---@param mat  XMATRIX4 变换矩阵
---@return void
function XQUATERNION:ConvFromMatrix(mat)
end

---@public 将四元数转化为绕三个轴旋转的欧拉角(弧度)
---@return number
---@return number
---@return number
---@return void
function XQUATERNION:ConvToEulerAngle()
end

---@public 将绕三个轴旋转的欧拉角转化为四元数形式
---@param fXAngle number 绕x轴旋转的欧拉角(弧度)
---@param fYAngle number 绕y轴旋转的欧拉角(弧度)
---@param fZAngle number 绕z轴旋转的欧拉角(弧度)
---@return void
function XQUATERNION:ConvFromEulerAngle(fXAngle, fYAngle, fZAngle)
end

---@public 将四元数转化为轴角对的表示形式，结果为 vAxis 和 fAngle
---@return XVECTOR3
---@return number
---@return void
function XQUATERNION:ConvertToAxisAngle()
end

---@public 根据旋转轴和旋转角计算得到四元数
---@param vAxis  XVECTOR3 旋转轴
---@param fAngle number 旋转角(弧度)
---@return void
function XQUATERNION:ConvertFromAxisAngle(vAxis, fAngle)
end

---@public 将XVECTOR2向量的三个分量分别置为0
---@return void
function XQUATERNION:Clear()
end

---@public 设置XVECTOR2向量的2个分量
---@param fx number 为XVECTOR2的x分量赋值的变量
---@param fy number 为XVECTOR2的y分量赋值的变量
---@param fz number
---@param fw number
---@return void
function XQUATERNION:Set(fx, fy, fz, fw)
end

---@public 计算当前四元数的模并返回
---@return number 当前四元数的模
function XQUATERNION:Norm()
end

---@public 将当前XVECTOR2向量单位化，并返回单位化之前向量的模。单位化是指将向量的模变为1.
---@return  XQUATERNION 向量单位化之前的模
function XQUATERNION:Normalize()
end

---@public 计算当前四元数的共轭，并返回得到的共轭四元数，此函数是 XQUATERNION 的成员函数
---@return  XQUATERNION XQUATERNION：共轭四元数
function XQUATERNION:Conjugate()
end

---@public 将当前矩阵进行逆矩阵运算。
---@return  XQUATERNION
function XQUATERNION:Inverse()
end

---@public 将当前矩阵设为单位矩阵，即其主对角线上的元素全为1，其他元素全为0。
---@return XQUATERNION
function XQUATERNION:Identity()
end

---@public 获取从向量vSrc旋转到vTo的四元数
---@param vSrc  XVECTOR3 原始向量
---@param vTo  XVECTOR3 旋转后向量
---@return XQUATERNION 从向量vSrc旋转到vTo的四元数
function XQUATERNION:RotationFromTo(vSrc, vTo)
end
