---@class XCOLORBASE
XCOLORBASE = {}


---@public XCOLORBASE_new00
---@return XCOLORBASE
function XCOLORBASE:new() end


---@public XCOLORBASE_new01
---@param srcColor number
---@return XCOLORBASE
function XCOLORBASE:new(srcColor) end


---@public XCOLORBASE_new02
---@param srcColor  XCOLORBASE
---@return XCOLORBASE
function XCOLORBASE:new(srcColor) end


---@public XCOLORBASE_new03
---@param fValue number
---@return XCOLORBASE
function XCOLORBASE:new(fValue) end


---@public XCOLORBASE_new04
---@param frValue number
---@param fgValue number
---@param fbValue number
---@param faValue number
---@return XCOLORBASE
function XCOLORBASE:new(frValue, fgValue, fbValue, faValue) end


---@public 设置颜色的四个分量值
---@param frValue number 设置颜色的r分量
---@param fgValue number 设置颜色的g分量
---@param fbValue number 设置颜色的b分量
---@param faValue number 设置颜色的a分量
---@return void
function XCOLORBASE:Set(frValue, fgValue, fbValue, faValue) end


---@public 转换为XCOLOR格式
---@return number XCOLOR格式的颜色（一个xuint32代表四个颜色分量）
function XCOLORBASE:ConvertToRGBAColor() end


---@public r、g、b、a 都修正到[0~1]区间
---@return void
function XCOLORBASE:Clamp() end


---@public r、g、b、a 如果某值小于0，就修正对应值为0.0
---@return void
function XCOLORBASE:ClampFloor() end


---@public r、g、b、a 如果某值大于1.0，就修正对应值为1.0
---@return void
function XCOLORBASE:ClampRoof() end


---@type number
XCOLORBASE.r = 0


---@type number
XCOLORBASE.g = 0


---@type number
XCOLORBASE.b = 0


---@type number r g b a 值的大小必须是一个字节。
XCOLORBASE.a = 0


---@class XHSVCOLORBASE
XHSVCOLORBASE = {}


---@public XHSVCOLORBASE_new00
---@return XHSVCOLORBASE
function XHSVCOLORBASE:new() end


---@public XHSVCOLORBASE_new01
---@param fColor number
---@return XHSVCOLORBASE
function XHSVCOLORBASE:new(fColor) end


---@public XHSVCOLORBASE_new02
---@param fhValue number
---@param fsValue number
---@param fvValue number
---@param faValue number
---@return XHSVCOLORBASE
function XHSVCOLORBASE:new(fhValue, fsValue, fvValue, faValue) end


---@type number
XHSVCOLORBASE.h = 0


---@type number
XHSVCOLORBASE.s = 0


---@type number
XHSVCOLORBASE.v = 0


---@type number r g b a 值的大小必须是一个字节。
XHSVCOLORBASE.a = 0


---@class XVIEWPORTPARAMETER
XVIEWPORTPARAMETER = {}


---@type number
XVIEWPORTPARAMETER.X = 0


---@type number
XVIEWPORTPARAMETER.Y = 0


---@type number
XVIEWPORTPARAMETER.nWidth = 0


---@type number
XVIEWPORTPARAMETER.nHeight = 0


---@type number
XVIEWPORTPARAMETER.fMinZ = 0


---@type number
XVIEWPORTPARAMETER.fMaxZ = 0


---@class XBaseVertex
XBaseVertex = {}


---@public XBaseVertex_new00
---@return XBaseVertex
function XBaseVertex:new() end


---@type XVECTOR3
XBaseVertex.Position = {}


---@type XVECTOR4
XBaseVertex.TangentX = {}


---@type XVECTOR4
XBaseVertex.TangentZ = {}


---@type XVECTOR2
XBaseVertex.TexCoord0 = {}


---@type XVECTOR2
XBaseVertex.TexCoord1 = {}


---@type number
XBaseVertex.Color = 0


---@class XSkinMeshVertex : XBaseVertex
XSkinMeshVertex = {}


---@public XSkinMeshVertex_new00
---@return XSkinMeshVertex
function XSkinMeshVertex:new() end


---@public XSkinMeshVertex_new01
---@param rhs  XSkinMeshVertex
---@return XSkinMeshVertex
function XSkinMeshVertex:new(rhs) end


---@type XVECTOR4
XSkinMeshVertex.BlendWeights = {}


---@class XBlendShapeMeshVertex
XBlendShapeMeshVertex = {}


---@public XBlendShapeMeshVertex_new00
---@return XBlendShapeMeshVertex
function XBlendShapeMeshVertex:new() end


---@public XBlendShapeMeshVertex_new01
---@param otherBShpPosition XVECTOR3
---@param otherBShpTangentZ XVECTOR3
---@param otherBShpTangentX XVECTOR3
---@return XBlendShapeMeshVertex
function XBlendShapeMeshVertex:new(otherBShpPosition, otherBShpTangentZ, otherBShpTangentX) end


---@type XVECTOR3
XBlendShapeMeshVertex.BShpPosition = {}


---@type XVECTOR3
XBlendShapeMeshVertex.BShpTangentZ = {}


---@type XVECTOR3
XBlendShapeMeshVertex.BShpTangentX = {}


