---@class XBone : XOwnerRecorder
XBone = {}


---@class XBone__XBoneRenderData
local XBone__XBoneRenderData = {}
XBone.XBoneRenderData = XBone__XBoneRenderData


---@type XCusSphere
XBone__XBoneRenderData.sphere = {}


---@type XCusCone[]
XBone__XBoneRenderData.cones = {}


---@type XCOLORBASE
XBone__XBoneRenderData.color = {}


---@class XBone__XBoneColliderRenderData
local XBone__XBoneColliderRenderData = {}
XBone.XBoneColliderRenderData = XBone__XBoneColliderRenderData


---@type XCusCapsule[]
XBone__XBoneColliderRenderData.capsules = {}


---@type string @readonly 
XBone__XBoneColliderRenderData.szBoneName = ''


---@class XBone__BoneState
local XBone__BoneState = {}
XBone.BoneState = XBone__BoneState


---@type XQUATERNION
XBone__BoneState.quOrientation = {}


---@type XVECTOR3
XBone__BoneState.vPos = {}


---@type number
XBone__BoneState.fWeight = 0


---@type number
XBone__BoneState.iBlendMode = 0


---@class XBone__BoneCollider
local XBone__BoneCollider = {}
XBone.BoneCollider = XBone__BoneCollider


---@type XVECTOR3
XBone__BoneCollider.vCenter = {}


---@type number
XBone__BoneCollider.fRadius = 0


---@type number
XBone__BoneCollider.fHeight = 0


---@type XVECTOR3
XBone__BoneCollider.vRotate = {}


---@type boolean
XBone__BoneCollider.bBoundOutside = false


---@type number @enum 
XBone.FLAG_FAKEBONE = 0


---@type number @enum 
XBone.FLAG_FLIPPED = 0


---@type number @enum 
XBone.BM_NORMAL = 0


---@type number @enum 
XBone.BM_COMBINE = 0


---@type number @enum 
XBone.BM_EXCLUSIVE = 0


---@type number @enum 
XBone.BM_ABSTRACK = 0


---@type number @enum 
XBone.TRANS_POS_X = 0


---@type number @enum 
XBone.TRANS_POS_Y = 0


---@type number @enum 
XBone.TRANS_POS_Z = 0


---@type number @enum 
XBone.TRANS_POS = 0


---@type number @enum 
XBone.TRANS_ORI = 0


---@type number @enum 
XBone.TRANS_ALL = 0


---@type number @enum RetargetingPolicy
XBone.Animation = 0


---@type number @enum RetargetingPolicy
XBone.Skeleton = 0


---@type number @enum RetargetingPolicy
XBone.AnimationScale = 0


---@public XBone_new00
---@return XBone
function XBone:new() end


---@public 根据骨架初始化骨头信息
---@param pSkeleton XSkeleton 骨架指针
---@return boolean 是否初始化成功
function XBone:Init(pSkeleton) end


---@public 释放
---@return void
function XBone:Release() end


---@public 克隆骨头信息
---@param pDstSkeleton XSkeleton
---@return XBone 克隆的骨头指针
function XBone:Duplicate(pDstSkeleton) end


---@public 从文件加载
---@param pFile XFileBase 文件指针
---@return boolean 是否加载成功
function XBone:Load(pFile) end


---@public 保存到文件
---@param pFile XFileBase 文件指针
---@return boolean 是否保存成功
function XBone:Save(pFile) end


---@public 设置骨头名称
---@param szName string 骨头名称
---@return void
function XBone:SetName(szName) end


---@public 获取骨头名称
---@return string 骨头名称
function XBone:GetName() end


---@public 获取骨头关联的骨架指针
---@return XSkeleton 骨架指针
function XBone:GetSkeleton() end


---@public 设置骨头关联的骨架指针
---@param pSkeleton XSkeleton 骨架指针
---@return void
function XBone:SetSkeleton(pSkeleton) end


---@public 骨骼更新时，是否受骨架中高度偏移的影响，为xtrue时，会在骨头位置更新时，叠加骨架的高度偏移， [为引擎内部模块间调用接口]
---@return boolean
function XBone:IsAnimDriven() end


---@public 骨头更新,更新骨头的各矩阵信息， 绝对矩阵，父骨头空间矩阵等都会更新
---@param nDeltaTime number
---@return boolean 是否更新成功
function XBone:Update(nDeltaTime) end


---@public 获取骨头的父节点索引
---@return number 骨头的父节点索引
function XBone:GetParent() end


---@public 设置骨头的父节点索引
---@param iParent number 骨头的父节点索引
---@return void
function XBone:SetParent(iParent) end


---@public 获取骨头的父节点骨头指针指针
---@return XBone 骨头的父节点骨头指针指针
function XBone:GetParentPtr() end


---@public 获取骨头的根节点骨头指针指针
---@return XBone 骨头的根节点骨头指针
function XBone:GetRootBonePtr() end


---@public 给当前骨头添加子骨头
---@param iChild number 子骨头索引
---@return boolean
function XBone:AddChild(iChild) end


---@public 获取当前骨头某个子骨头索引
---@param iIndex number [in]要获取的子节点的存储索引
---@return number 获取到的子骨头节点索引
function XBone:GetChild(iIndex) end


---@public 获取当前骨头所有子节点个数
---@return number 当前骨头所有子节点个数
function XBone:GetChildNum() end


---@public 获取子骨头指针
---@param iIndex number 子骨头索引
---@return XBone 子骨头指针
function XBone:GetChildPtr(iIndex) end


---@public 获取骨头控制器。注意：骨头更新时，会调用控制器，参与骨头各矩阵的计算
---@return XBoneControllerBase 骨头控制器
function XBone:GetFirstController() end


---@public 设置骨头控制器。
---@param pController XBoneControllerBase 骨头控制器
---@return void
function XBone:SetFirstController(pController) end


---@public 重置骨头的相对矩阵.
---使用m_matOriginRel来重置相对矩阵
---@return void
function XBone:ResetRelativeTM() end


---@public 设置骨头的相对矩阵
---@param mat XMATRIX4 骨头的相对矩阵
---@return void
function XBone:SetRelativeTM(mat) end


---@public 设置骨头的相对矩阵
---@param quRot XQUATERNION 骨头相对矩阵的旋转四元数信息
---@param vTrans XVECTOR3 骨头相对矩阵的平移信息
---@return void
function XBone:SetRelativeTM(quRot, vTrans) end


---@public 获取骨头的相对矩阵
---@return XMATRIX4 骨头的相对矩阵
function XBone:GetRelativeTM() end


---@public 获取骨头相对矩阵的旋转四元数信息
---@return XQUATERNION 骨头相对矩阵的旋转四元数信息
function XBone:GetRelativeQuat() end


---@public 设置到父骨头空间的矩阵,但是不影响相对矩阵
---@param matUpToParent XMATRIX4 设置到父骨头空间的矩阵
---@return void
function XBone:SetUpToParentTM(matUpToParent) end


---@public 获取到父骨头空间的矩阵
---@return XMATRIX4 到父骨头空间的矩阵
function XBone:GetUpToParentTM() end


---@public 获取到根骨头空间的矩阵
---@return XMATRIX4 到根骨头空间的矩阵
function XBone:GetUpToRootTM() end


---@public 获取骨头的本地模型空间矩阵
---@return XMATRIX4 骨头的本地模型空间矩阵
function XBone:GetLocalAbsTM() end


---@public 获取骨头的绝对空间的矩阵，一般为世界空间的矩阵
---@return XMATRIX4 骨头的绝对空间矩阵
function XBone:GetAbsoluteTM() end


---@public 获取骨头的模型空间矩阵（不包含缩放信息）
---@return XMATRIX4 骨头的模型空间矩阵（不包含缩放信息）
function XBone:GetNoScaleAbsTM() end


---@public 设置本地空间的矩阵
---@param mat XMATRIX4 本地空间矩阵
---@return void
function XBone:SetLocalAbsTM(mat) end


---@public 设置绝对空间的矩阵
---@param mat XMATRIX4 绝对空间矩阵
---@return void
function XBone:SetAbsoluteTM(mat) end


---@public 父子骨头之间，是否继承缩放信息
---@return boolean 是否继承缩放信息
function XBone:IsInheritScale() end


---@public 设置父子骨头间是否继承缩放信息
---@param InheritScale boolean 是否继承缩放信息
---@return void
function XBone:SetInheritScale(InheritScale) end


---@public 设置本地空间的缩放信息，可理解为骨头上设置的缩放信息
---@param vScale XVECTOR3 本地空间的缩放信息
---@return void
function XBone:SetLocalSF(vScale) end


---@public 获取本地空间的缩放信息
---@return XVECTOR3 本地空间的缩放信息
function XBone:GetLocalSF() end


---@public 设置全局空间的缩放信息， 全局可理解为相对骨架根空间上的缩放信息
---@param vScale XVECTOR3 全局空间的缩放信息
---@return void
function XBone:SetGlobalSF(vScale) end


---@public 获取全局空间的缩放信息， 全局可理解为相对骨架根空间上的缩放信息
---@return XVECTOR3
function XBone:GetGlobalSF() end


---@public 获取碰撞体信息
---@return BoneCollider[] 碰撞体
function XBone:GetBoneColliders() end


---@public 添加一个碰撞体,返回指针
---@return XBone__BoneCollider 碰撞体
function XBone:AddBoneCollider() end


---@public 添加一个碰撞体,返回指针
---@param nIndex number 删除的碰撞体索引
---@return void 碰撞体
function XBone:RemoveBoneCollider(nIndex) end


---@public 根据索引获取一个碰撞体
---@param nIndex number
---@return XBone__BoneCollider
function XBone:GetBoneCollider(nIndex) end


---@public [为引擎内部模块间调用接口]
---@return XMATRIX4
function XBone:GetBoneInitTM() end


---@public [为引擎内部模块间调用接口]
---@param mat XMATRIX4
---@return void
function XBone:SetBoneInitTM(mat) end


---@public [为引擎内部模块间调用接口]
---@return XMATRIX4
function XBone:GetOriginalMatrix() end


---@public [为引擎内部模块间调用接口]
---@param mat XMATRIX4
---@return void
function XBone:SetOriginalMatrix(mat) end


---@public [为引擎内部模块间调用接口]
---@return XVECTOR3
function XBone:GetOriginalPos() end


---@public [为引擎内部模块间调用接口]
---@return XQUATERNION
function XBone:GetOriginalDir() end


