---@class XCusOBB
XCusOBB = {}


---@public XCusOBB_new00
---@return XCusOBB
function XCusOBB:new() end


---@public XCusOBB_new01
---@param CusObb  XCusOBB
---@return XCusOBB
function XCusOBB:new(CusObb) end


---@public 判断指定点是否在OBB内
---@param vPoint XVECTOR3 要判断的指定点坐标
---@return boolean 在OBB内，返回true,不在返回false.
function XCusOBB:IsPointInOBB(vPoint) end


---@public 计算与3个坐标轴的交点坐标（以原点为中心）
---@return void
function XCusOBB:CompleteExtAxis() end


---@public 清空OBB数据
---@return void
function XCusOBB:Clear() end


---@public 根据2个给定的OBB，构建一个包含这2个OBB的新的OBB
---@param CusObb1  XCusOBB 第一个OBB信息
---@param CusObb2  XCusOBB 第二个OBB信息
---@return void
function XCusOBB:BuildOBB(CusObb1, CusObb2) end


---@public 根据给定的顶点信息，构建一个新的OBB
---@param pVertexPosition XVECTOR3 顶点数组buffer
---@param nVertCount number 顶点数组中顶点的数目
---@return void
function XCusOBB:BuildOBB(pVertexPosition, nVertCount) end


---@public 根据给定的formAABB，构建一个新的OBB
---@param formAABB  XCusAABB 给定的OBB信息
---@return void
function XCusOBB:BuildOBB(formAABB) end


---@public XCusOBB_GetVertices00
---@param bWire boolean
---@return XVECTOR3
---@return number
---@return void
function XCusOBB:GetVertices(bWire) end


---@type XVECTOR3
XCusOBB.Center = {}


---@type XVECTOR3
XCusOBB.XAxis = {}


---@type XVECTOR3
XCusOBB.YAxis = {}


---@type XVECTOR3
XCusOBB.ZAxis = {}


---@type XVECTOR3
XCusOBB.ExtX = {}


---@type XVECTOR3
XCusOBB.ExtY = {}


---@type XVECTOR3
XCusOBB.ExtZ = {}


---@type XVECTOR3
XCusOBB.Extents = {}


---@class XCusAABB
XCusAABB = {}


---@public XCusAABB_new00
---@return XCusAABB
function XCusAABB:new() end


---@public XCusAABB_new01
---@param aabb  XCusAABB
---@return XCusAABB
function XCusAABB:new(aabb) end


---@public XCusAABB_new02
---@param vMins XVECTOR3
---@param vMaxs XVECTOR3
---@return XCusAABB
function XCusAABB:new(vMins, vMaxs) end


---@public 清空OBB数据
---@return void
function XCusAABB:Clear() end


---@public 添加顶点信息
---@param v XVECTOR3 添加的顶点
---@return void
function XCusAABB:AddVertex(v) end


---@public 根据给定的OBB信息，构建一个AABB包围盒
---@param obb  XCusOBB 给定的OBB信息
---@return void
function XCusAABB:Build(obb) end


---@public 合并一个subAABB到当前AABB
---@param subAABB  XCusAABB 要合并的AABB信息
---@return void
function XCusAABB:Merge(subAABB) end


---@public 由Center和Extents计算AABB包围盒“最大”和“最小”点信息
---@return void
function XCusAABB:CompleteMinsMaxs() end


---@public 由“最大”和“最小”点信息计算AABB包围盒中心点和到各个面距离信息
---@return void
function XCusAABB:CompleteCenterExts() end


---@public 判断指定点是否在该AABB内
---@param v XVECTOR3 要判断的指定点坐标
---@return boolean 在AABB内，返回true,不在返回false.
function XCusAABB:IsPointIn(v) end


---@public 判断指定AABB是否在该AABB内
---@param aabb  XCusAABB 要判断的指定aabb
---@return boolean 在AABB内，返回true,不在返回false.
function XCusAABB:IsAABBIn(aabb) end


---@public 判断指定AABB和当前AABB是否相交
---@param aabb  XCusAABB 指定aabb
---@return boolean 如果相交，返回true,不相交，返回false.
function XCusAABB:IsIntersect(aabb) end


---@public 根据给定的顶点信息，构建一个AABB
---@param aVertPos XVECTOR3 顶点数组buffer
---@param iNumVert number 顶点数组中顶点的数目
---@return void
function XCusAABB:Build(aVertPos, iNumVert) end


---@public XCusAABB_GetVertices00
---@param bWire boolean
---@return XVECTOR3
---@return number
---@return void
function XCusAABB:GetVertices(bWire) end


---@type XVECTOR3
XCusAABB.Center = {}


---@type XVECTOR3
XCusAABB.Extents = {}


---@type XVECTOR3
XCusAABB.Mins = {}


---@type XVECTOR3
XCusAABB.Maxs = {}


---@class XCusPlane
XCusPlane = {}


---@public XCusPlane_new00
---@return XCusPlane
function XCusPlane:new() end


---@public XCusPlane_new01
---@param p  XCusPlane
---@return XCusPlane
function XCusPlane:new(p) end


---@public XCusPlane_new02
---@param n XVECTOR3
---@param d number
---@return XCusPlane
function XCusPlane:new(n, d) end


---@public XCusPlane_new03
---@param n XVECTOR3
---@param vPoint XVECTOR3
---@return XCusPlane
function XCusPlane:new(n, vPoint) end


---@public 根据三个点创建一个面
---@param v1 XVECTOR3 给定坐标点1
---@param v2 XVECTOR3 给定坐标点2
---@param v3 XVECTOR3 给定坐标点3
---@return boolean 是否创建成功
function XCusPlane:CreatePlane(v1, v2, v3) end


---@public 根据三个点创建一个面
---@param vPoint XVECTOR3 给定坐标点1
---@return number 距离
function XCusPlane:GetDistanceToPoint(vPoint) end


---@public 根据三个点创建一个面
---@param vPoint XVECTOR3 给定坐标点1
---@return XVECTOR3 平面上最近点坐标
function XCusPlane:ClosestPointOnPlane(vPoint) end


---@type XVECTOR3
XCusPlane.vNormal = {}


---@type number
XCusPlane.fDist = 0


---@class XCusSPlane : XCusPlane
XCusSPlane = {}


---@type number @enum 
XCusSPlane.TYPE_BAD = 0


---@type number @enum 
XCusSPlane.TYPE_PX = 0


---@type number @enum 
XCusSPlane.TYPE_PY = 0


---@type number @enum 
XCusSPlane.TYPE_PZ = 0


---@type number @enum 
XCusSPlane.TYPE_NX = 0


---@type number @enum 
XCusSPlane.TYPE_NY = 0


---@type number @enum 
XCusSPlane.TYPE_NZ = 0


---@type number @enum 
XCusSPlane.TYPE_MAJORX = 0


---@type number @enum 
XCusSPlane.TYPE_MAJORY = 0


---@type number @enum 
XCusSPlane.TYPE_MAJORZ = 0


---@type number @enum 
XCusSPlane.TYPE_UNKNOWN = 0


---@type number @enum 
XCusSPlane.SIGN_P = 0


---@type number @enum 
XCusSPlane.SIGN_NX = 0


---@type number @enum 
XCusSPlane.SIGN_NY = 0


---@type number @enum 
XCusSPlane.SIGN_NZ = 0


---@public XCusSPlane_new00
---@return XCusSPlane
function XCusSPlane:new() end


---@public XCusSPlane_new01
---@param p  XCusSPlane
---@return XCusSPlane
function XCusSPlane:new(p) end


---@public XCusSPlane_new02
---@param n XVECTOR3
---@param d number
---@return XCusSPlane
function XCusSPlane:new(n, d) end


---@public [引擎内部模块间调用接口]
---@return void
function XCusSPlane:MakeType() end


---@public [引擎内部模块间调用接口]
---@return void
function XCusSPlane:MakeSignBits() end


---@public [引擎内部模块间调用接口]
---@return void
function XCusSPlane:MakeTypeAndSignBits() end


---@type number
XCusSPlane.byType = 0


---@type number
XCusSPlane.bySignBits = 0


---@class XCusCapsule
XCusCapsule = {}


---@public XCusCapsule_new00
---@return XCusCapsule
function XCusCapsule:new() end


---@public XCusCapsule_new01
---@param src  XCusCapsule
---@return XCusCapsule
function XCusCapsule:new(src) end


---@public 判断指定点是否在该AABB内
---@param vPos XVECTOR3 要判断的指定点坐标
---@return boolean 在AABB内，返回true,不在返回false.
function XCusCapsule:IsPointIn(vPos) end


---@type XVECTOR3
XCusCapsule.vCenter = {}


---@type XVECTOR3
XCusCapsule.vAxisX = {}


---@type XVECTOR3
XCusCapsule.vAxisY = {}


---@type XVECTOR3
XCusCapsule.vAxisZ = {}


---@type number
XCusCapsule.fHalfLen = 0


---@type number
XCusCapsule.fRadius = 0


---@class XCusCone
XCusCone = {}


---@type XVECTOR3
XCusCone.vPos = {}


---@type XVECTOR3
XCusCone.vAxisX = {}


---@type XVECTOR3
XCusCone.vAxisY = {}


---@type XVECTOR3
XCusCone.vAxisZ = {}


---@type number
XCusCone.fHeight = 0


---@type number
XCusCone.fRadius = 0


---@class XCusCylinder
XCusCylinder = {}


---@public XCusCylinder_new00
---@return XCusCylinder
function XCusCylinder:new() end


---@public XCusCylinder_new01
---@param src  XCusCylinder
---@return XCusCylinder
function XCusCylinder:new(src) end


---@public 判断指定点是否在该AABB内
---@param vPos XVECTOR3 要判断的指定点坐标
---@return boolean 在AABB内，返回true,不在返回false.
function XCusCylinder:IsPointIn(vPos) end


---@type XVECTOR3
XCusCylinder.vCenter = {}


---@type XVECTOR3
XCusCylinder.vAxisX = {}


---@type XVECTOR3
XCusCylinder.vAxisY = {}


---@type XVECTOR3
XCusCylinder.vAxisZ = {}


---@type number
XCusCylinder.fHalfLen = 0


---@type number
XCusCylinder.fRadius = 0


---@class XCusSphere
XCusSphere = {}


---@type XVECTOR3
XCusSphere.vPos = {}


---@type number
XCusSphere.fRadius = 0


